unit AVIMorphFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, GraphicEx,
  StdCtrls, ComCtrls, Menus, ExtCtrls, ExtDlgs,
  AVIRerun, Spin;

type
  TAVIMorphForm = class(TForm)
    ScrollBox1: TScrollBox;
    EndImage: TImage;
    AviMenu: TMainMenu;
    File1: TMenuItem;
    OpenEndImage1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Morph1: TMenuItem;
    SetPoints1: TMenuItem;
    Help1: TMenuItem;
    Help2: TMenuItem;
    About1: TMenuItem;
    Panel2: TPanel;
    Panel1: TPanel;
    MorphListBox: TListBox;
    AviSpd: TSaveDialog;
    OpenMorLine1: TMenuItem;
    Openwav1: TMenuItem;
    AVIRerun1: TAVIRerun;
    ColorDialog1: TColorDialog;
    AVIOPD: TOpenPictureDialog;
    ChooseAvi1: TMenuItem;
    N2: TMenuItem;
    RedrawLines1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Makes1: TMenuItem;
    Morph2: TMenuItem;
    Warp1: TMenuItem;
    Tween1: TMenuItem;
    List1: TMenuItem;
    ClearAllPoints1: TMenuItem;
    ViewFrames1: TMenuItem;
    N3: TMenuItem;
    Panel3: TPanel;
    SetPointsBtn: TButton;
    MorphPicsSpinEdit: TSpinEdit;
    FPSSpinEdit: TSpinEdit;
    ColorPanel: TPanel;
    MakeAVIBtn: TButton;
    MakeBitmapsCB: TCheckBox;
    ViewBtn: TButton;
    ProgressBar1: TProgressBar;
    MorLineLabel: TLabel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Panel4: TPanel;
    BothImage: TImage;
    Splitter3: TSplitter;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    Splitter4: TSplitter;
    OpenStartImage1: TMenuItem;
    StatusBar: TStatusBar;
    AVI1: TMenuItem;
    MakeAVI1: TMenuItem;
    ViewAVI1: TMenuItem;
    LoadImageList1: TMenuItem;
    FillListbyFileSelection1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Help2Click(Sender: TObject);

    procedure OpenEndImage1Click(Sender: TObject);
procedure OpenEndImage(const FileName: string);
procedure SetStuffEnabled(Input:Integer);    
    procedure Save1Click(Sender: TObject);
    procedure OpenMorLine1Click(Sender: TObject);
    procedure Openwav1Click(Sender: TObject);

    procedure MorphListBoxClick(Sender: TObject);
    procedure MorphListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure SetPointsBtnClick(Sender: TObject);
    procedure ViewBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);

    procedure EndImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure EndImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

procedure DrawEndShape
  (TopLeft, BottomRight: TPoint; AMode: TPenMode);
    procedure EndImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ColorPanelClick(Sender: TObject);

    procedure MakeAVIBtnClick(Sender: TObject);
Procedure TweenMorph(MorphThis:Integer;var AMyBitmap:TBitmap);
Procedure TweenWarp(MorphThis:Integer;var AMyBitmap:TBitmap);
Procedure TweenTween(MorphThis:Integer;var AMyBitmap:TBitmap);
FUNCTION CreateTweenBitmap(CONST BitmapA:  TBitmap;
                           CONST WeightA:  CARDINAL;
                           CONST BitmapB:  TBitmap;
                           CONST WeightB:  CARDINAL):  TBitmap;

FUNCTION LoadGraphicFile(CONST Filename:  STRING):  TBitmap;

Procedure MsetLength(Which:Integer);
Procedure sumLinessrc(var InColor:TColor;warp:TPoint);
Procedure sumLinesdst(var InColor:TColor;warp:TPoint);
Function clip(num, min, max:Integer):Integer;

Function getSourceLocsrc(Todo:Integer;var orig,warp:TPoint):Double;
Function getSourceLocdst(Todo:Integer;var orig,warp:TPoint):Double;

    procedure ChooseAvi1Click(Sender: TObject);
    procedure RedrawLines1Click(Sender: TObject);
    procedure ClearAllPoints1Click(Sender: TObject);
    procedure List1Click(Sender: TObject);
    procedure Warp1Click(Sender: TObject);
    procedure Morph2Click(Sender: TObject);
    procedure Tween1Click(Sender: TObject);
    procedure ViewFrames1Click(Sender: TObject);

    procedure OpenStartImage1Click(Sender: TObject);
procedure OpenStartImage(const FileName: string);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
procedure DrawShape
  (TopLeft, BottomRight, Tri, Quad: TPoint; AMode: TPenMode);
    procedure LoadImageList1Click(Sender: TObject);
    procedure FillListbyFileSelection1Click(Sender: TObject);
  private
    { Private declarations }
    {MorphingOnStart called by button ..sets DrawingStart
    Image1 MouseUp sets MorphingOnStartDrawing
    EndImage sets   MorphingOnEndDrawing
    MouseUp sets MorphingOnStart to false..  }
    MorphingOnStart,DrawingStart,
    MorphingOnStartDrawing,
    MorphingOnEndDrawing, UserAbort : boolean;

    StartImageWidth, StartImageHeight,
    EndImageWidth,   EndImageHeight:Integer;
    AviWavFileName,  MorphFilePath,
    MorphStartFileName, MorphEndFileName:String;
    GCWidthScale,  GCHeightScale:Double;
    MSOrigin, MSMovePt,
    MEOrigin, MEMovePt:TPoint;
    ImageList: TStringList;

  public
    { Public declarations }
  end;

var
  AVIMorphForm: TAVIMorphForm;

implementation

{$R *.DFM}
uses TongGlobals,
  {a_layer a_prev called by} a_loader;


procedure TAVIMorphForm.FormCreate(Sender: TObject);
begin
  top := AVIMorphFormY;
  left := AVIMorphFormX;
  AviWavFileName:='';
  MorphStartFileName:='';
  MorphEndFileName:='';
  MorphFilePath:=ImagePath;
  ProgressBar1.Visible:=False;
  MorphTweens:=10;
  MorphPicsSpinEdit.Value:=10;
  FPSSpinEdit.Value:=17;
  MorLineCount:=0;
  Setlength(MorphArray,0);
  SetStuffEnabled(0);
  OpenEndImage1.Enabled:=False;
  LoadImageList1.Enabled:=False;
  FillListbyFileSelection1.Enabled:=False;
  MorphingOnStart:=False;
  DrawingStart:=False;
  MorphingOnStartDrawing:=False;
  MorphingOnEndDrawing:=False;
  DrawingTool := dtLine;
  ImageList:= TStringList.Create;
end;

procedure TAVIMorphForm.SetStuffEnabled(Input:Integer);
var Setit:Boolean;
Begin
  Setit:=False;
  If Input>0 then Setit:=True;
  SetPointsBtn.Enabled:=Setit;
  SetPoints1.Enabled:=Setit;
  If Input>1 then Setit:=True else Setit:=False;
  {SetStuffEnabled(2);}
  MorphListBox.Enabled:=Setit;
  {EndImage.Enabled:=Setit;}
  MakeAVIBtn.Enabled:=Setit;
  If Input>2 then Setit:=True else Setit:=False;
  {SetStuffEnabled(3);}
  ViewBtn.Enabled:=Setit;
End;

procedure TAVIMorphForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Setlength(MorphArray,0);
  AviWavFileName:='';
  MorphFilePath:='';
  MorphEndFileName:='';
  MorphStartFileName:='';
  ImageList.Free;
  AVIMorphFormY := AVIMorphForm.top;
  AVIMorphFormX := AVIMorphForm.left;
end;

procedure TAVIMorphForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TAVIMorphForm.About1Click(Sender: TObject);
begin { PicAboutBox.Init(11);   PicAboutBox.ShowModal;}
  ShowMessage('Based on Anderson Morphing Majic'+#13#10+
              'Copyright 2004, Ivan Lee Herring');
end;

procedure TAVIMorphForm.Help2Click(Sender: TObject);
begin
  Application.HelpContext(13222);
end;

procedure TAVIMorphForm.OpenEndImage1Click(Sender: TObject);
begin
  If OpenWithPreview then
  begin
    AviOpd.InitialDir:=MorphFilePath;
    AviOpd.FileName:=MorphEndFileName;
    with AviOpd do
    if Execute then OpenEndImage(FileName);
  end else
  begin
    OpenDialog1.Filter:=
    'All (*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf'+
    '|Portable Network Graphics (*.png)|*.png|JPEG Image File (*.jpg)|*.jpg|JPEG Image File (*.jpeg)|*.jpeg|Bitmaps (*.bmp)|*.bmp|Icons (*.ico)|*.ico|Enhanced Metafiles (*.emf)|*.emf|Metafiles (*.wmf)|*.wmf|Morph List Text|*.mlt';
    OpenDialog1.InitialDir:=MorphFilePath;
    OpenDialog1.FileName:=MorphEndFileName;
    with OpenDialog1 do
    if Execute then OpenEndImage(FileName);
  end;
end;

procedure TAVIMorphForm.OpenEndImage(const FileName: string);
var
  GraphicClass: TGraphicExGraphicClass;
  Graphic: TGraphic;
  Target:TBitmap;
  MyRect:TRect;
begin
  Try
    Screen.Cursor := crHourGlass;
    MorphEndFileName:=ExtractFileName(FileName);
    MorphFilePath:=ExtractFilePath(FileName);
    GraphicClass :=
      FileFormatList.GraphicFromContent(MorphFilePath+MorphEndFileName);
    if GraphicClass = nil then
      EndImage.Picture.LoadFromFile(MorphFilePath+MorphEndFileName)
    else
    begin
      // GraphicFromContent always returns TGraphicExGraphicClass
      Graphic := GraphicClass.Create;
      Graphic.LoadFromFile(MorphFilePath+MorphEndFileName);
      EndImage.Picture.Graphic := Graphic;
    end;
    if (not(EndImage.Picture.Graphic is TBitmap)) then
    begin
      Target := TBitmap.Create;
      Target.PixelFormat := pf24Bit;
      Target.Width := EndImage.Picture.Width;
      Target.Height := EndImage.Picture.Height;
      Target.Canvas.Draw(0, 0, EndImage.Picture.Graphic);
      EndImage.Picture.Graphic := Target;
      Target.Free;
    end;
    EndImage.Picture.Bitmap.PixelFormat := pf24bit;
    EndImageWidth:=EndImage.Picture.Width;
    EndImageHeight:=EndImage.Picture.Height;
    If ((EndImageWidth=StartImageWidth)and
        (EndImageHeight=StartImageHeight)) then
    BEGIN
    {Compute Transform Scale and Place Bitmaps
    into the Dual bitmaps area
    GCWidthScale  GCHeightScale  EndWidthScale  EndHeightScale    }
    GCWidthScale:= 128/StartImageWidth;
    GCHeightScale:= 96/StartImageHeight;
    Target := TBitmap.Create;
    Target.PixelFormat := pf24Bit;
    Target.Width := 256;
    Target.Height := 96;
    Target.Canvas.Brush.Color := clWhite;
    Target.Canvas.Brush.Style := bsSolid;
    { ARect:=(Left, Top, Right, Bottom: Integer)}
    MyRect := Rect(0,0,256,96);
    Target.Canvas.FillRect(MyRect);
    MyRect := Rect(0,0,127,95);
    Target.Canvas.StretchDraw(MyRect, Image1.Picture.Graphic);
    MyRect := Rect(128,0,255,95);
    Target.Canvas.StretchDraw(MyRect, EndImage.Picture.Graphic);
    BothImage.Picture.Graphic := Target;
    Target.Free;
    SetStuffEnabled(1);
    END else
    Begin
      EndImage.Picture.Graphic :=nil;
      SetStuffEnabled(0);
      DoMessages(15);
    End;
  finally
    Screen.Cursor := crDefault;
  end;
end;


procedure TAVIMorphForm.OpenStartImage1Click(Sender: TObject);
begin  {StartImageHeight StartImageWidth}
  If OpenWithPreview then
  begin
    AviOpd.InitialDir:=MorphFilePath;
    AviOpd.FileName:=MorphStartFileName;
    with AviOpd do
    if Execute then OpenStartImage(FileName);
  end else
  begin
    OpenDialog1.Filter:=
    'All (*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf'+
    '|Portable Network Graphics (*.png)|*.png|JPEG Image File (*.jpg)|*.jpg|JPEG Image File (*.jpeg)|*.jpeg|Bitmaps (*.bmp)|*.bmp|Icons (*.ico)|*.ico|Enhanced Metafiles (*.emf)|*.emf|Metafiles (*.wmf)|*.wmf|Morph List Text|*.mlt';
    OpenDialog1.InitialDir:=MorphFilePath;
    OpenDialog1.FileName:=MorphStartFileName;
    with OpenDialog1 do
    if Execute then OpenStartImage(FileName);
  end;
end;

procedure TAVIMorphForm.OpenStartImage(const FileName: string);
var
  GraphicClass: TGraphicExGraphicClass;
  Graphic: TGraphic;
  Target:TBitmap;
  MyRect:TRect;
begin
  Try
    Screen.Cursor := crHourGlass;
    MorphStartFileName:=ExtractFileName(FileName);
    MorphFilePath:=ExtractFilePath(FileName);
    GraphicClass :=
      FileFormatList.GraphicFromContent(MorphFilePath+MorphStartFileName);
    if GraphicClass = nil then
      Image1.Picture.LoadFromFile(MorphFilePath+MorphStartFileName)
    else
    begin
      // GraphicFromContent always returns TGraphicExGraphicClass
      Graphic := GraphicClass.Create;
      Graphic.LoadFromFile(MorphFilePath+MorphStartFileName);
      Image1.Picture.Graphic := Graphic;
    end;
    if (not(Image1.Picture.Graphic is TBitmap)) then
    begin
      Target := TBitmap.Create;
      Target.PixelFormat := pf24Bit;
      Target.Width := Image1.Picture.Width;
      Target.Height := Image1.Picture.Height;
      Target.Canvas.Draw(0, 0, Image1.Picture.Graphic);
      Image1.Picture.Graphic := Target;
      Target.Free;
    end;
    Image1.Picture.Bitmap.PixelFormat := pf24bit;
    StartImageWidth:=Image1.Picture.Width;
    StartImageHeight:=Image1.Picture.Height;
    {If ((EndImageWidth=StartImageWidth)and
        (EndImageHeight=StartImageHeight)) then }
    BEGIN
    {Compute Transform Scale and Place Bitmaps
    into the Dual bitmaps area
    GCWidthScale  GCHeightScale  EndWidthScale  EndHeightScale    }
    GCWidthScale:= 128/StartImageWidth;
    GCHeightScale:= 96/StartImageHeight;
    Target := TBitmap.Create;
    Target.PixelFormat := pf24Bit;
    Target.Width := 256;
    Target.Height := 96;
    Target.Canvas.Brush.Color := clWhite;
    Target.Canvas.Brush.Style := bsSolid;
    { ARect:=(Left, Top, Right, Bottom: Integer)}
    MyRect := Rect(0,0,256,96);
    Target.Canvas.FillRect(MyRect);
    MyRect := Rect(0,0,127,95);
    Target.Canvas.StretchDraw(MyRect, Image1.Picture.Graphic);
    {MyRect := Rect(128,0,255,95);
    Target.Canvas.StretchDraw(MyRect, EndImage.Picture.Graphic);}
    BothImage.Picture.Graphic := Target;
    Target.Free;
    {SetStuffEnabled(1);}
    END;
    OpenEndImage1.Enabled:=True;
  finally
    Screen.Cursor := crDefault;
  end;
end;



procedure TAVIMorphForm.Openwav1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir:=MorphFilePath;
  OpenDialog1.Filter:='*.wav';
  OpenDialog1.FileName:=ChangeFileExt(MorphStartFileName,'.wav');
  if OpenDialog1.Execute then
  begin
    If (Lowercase(ExtractFileExt(OpenDialog1.FileName))='.wav') then
    begin
      AviWavFileName:=OpenDialog1.FileName;
    end;
  end;
end;

procedure TAVIMorphForm.OpenMorLine1Click(Sender: TObject);
var
  aLineRecord:LineRecord;
  PlotString:String;
begin
  OpenDialog1.Filter:= 'Morph Array List|*.mal';
  OpenDialog1.InitialDir:=MorphFilePath;
  OpenDialog1.FileName:=ChangeFileExt(MorphStartFileName,'.mal');
  if OpenDialog1.Execute then
  begin
    If (Lowercase(ExtractFileExt(OpenDialog1.FileName))='.mal') then
    begin
      MorphListBox.Items.Clear;
      SetLength(MorphArray,0);
      MorLineCount:=0;
      AssignFile(MorphArrayFile,OpenDialog1.FileName);
      Reset(MorphArrayFile);
      While (not eof(MorphArrayFile))do
      begin
      Read(MorphArrayFile,aLineRecord);
      SetLength(MorphArray,MorLineCount+1);
      MorphArray[MorLineCount]:=aLineRecord;
      PlotString:=(
             Inttostr(MorphArray[MorLineCount].Start[0].X)+','+
             Inttostr(MorphArray[MorLineCount].Start[0].Y)+' ; '+
             Inttostr(MorphArray[MorLineCount].Finish[0].X)+','+
             Inttostr(MorphArray[MorLineCount].Finish[0].Y)      );
      MorphListBox.Items.Add(PlotString);
      inc(MorLineCount);
      end;
      CloseFile(MorphArrayFile);
      SetStuffEnabled(2);      
    end;
  end;
end;

procedure TAVIMorphForm.Save1Click(Sender: TObject);
var
  aLineRecord:LineRecord;
  I:Integer;
begin
  if MorphListBox.Items.Count > 0  then
  begin
    AviSpd.Filter:= 'Morph Array List|*.mal';
    AviSpd.InitialDir:=MorphFilePath;
    AviSpd.FileName:=ChangeFileExt(MorphStartFileName,'.mal');
    if AviSpd.Execute then
    begin
      If (Lowercase(ExtractFileExt(AviSpd.FileName))='.mal') then
      begin
      AssignFile(MorphArrayFile,AviSpd.FileName);
      Rewrite(MorphArrayFile);
      For I:=0 to MorLineCount-1 do
      begin
      aLineRecord:=MorphArray[I];
      Write(MorphArrayFile,aLineRecord);
      end;
      CloseFile(MorphArrayFile);
      end;
    end;
  end;
end;


procedure TAVIMorphForm.MorphListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i,TempNumb:Integer;
begin
  if ((Key=VK_DELETE) and (MorphListBox.ItemIndex>-1)) then
  begin
    TempNumb:=MorphListBox.ItemIndex;
    MorphListBox.Items.Delete(MorphListBox.ItemIndex);
    {Delete point from LineList}
    For i:= TempNumb to MorphListBox.Items.Count-1 do
    begin {Itemindex starts at 0 too so not -1}
    MorphArray[i].Start[0].X:=
      MorphArray[i+1].Start[0].X;
    MorphArray[i].Start[0].Y:=
      MorphArray[i+1].Start[0].Y;
    MorphArray[i].Start[1].X:=
      MorphArray[i+1].Start[1].X;
    MorphArray[i].Start[1].Y:=
      MorphArray[i+1].Start[1].Y;
{  DeltaX,DeltaY  Length}
    MorphArray[i].DeltaXs:=
      MorphArray[i+1].DeltaXs;
    MorphArray[i].DeltaYs:=
      MorphArray[i+1].DeltaYs;
    MorphArray[i].Lengths:=
      MorphArray[i+1].Lengths;
    MorphArray[i].LengthSQs:=
      MorphArray[i+1].LengthSQs;

    MorphArray[i].Finish[0].X:=
      MorphArray[i+1].Finish[0].X;
    MorphArray[i].Finish[0].Y:=
      MorphArray[i+1].Finish[0].Y;
    MorphArray[i].Finish[1].X:=
      MorphArray[i+1].Finish[1].X;
    MorphArray[i].Finish[1].Y:=
      MorphArray[i+1].Finish[1].Y;
{  DeltaX,DeltaY  Length}
    MorphArray[i].DeltaXf:=
      MorphArray[i+1].DeltaXf;
    MorphArray[i].DeltaYf:=
      MorphArray[i+1].DeltaYf;
    MorphArray[i].Lengthf:=
      MorphArray[i+1].Lengthf;
    MorphArray[i].LengthSQf:=
      MorphArray[i+1].LengthSQf;

    MorphArray[i].Result[0].X:=
      MorphArray[i+1].Result[0].X;
    MorphArray[i].Result[0].Y:=
      MorphArray[i+1].Result[0].Y;
    MorphArray[i].Result[1].X:=
      MorphArray[i+1].Result[1].X;
    MorphArray[i].Result[1].Y:=
      MorphArray[i+1].Result[1].Y;
{  DeltaX,DeltaY  Length}
    MorphArray[i].DeltaXr:=
      MorphArray[i+1].DeltaXr;
    MorphArray[i].DeltaYr:=
      MorphArray[i+1].DeltaYr;
    MorphArray[i].Lengthr:=
      MorphArray[i+1].Lengthr;
    MorphArray[i].LengthSQr:=
      MorphArray[i+1].LengthSQr;
    end;
    dec(MorLineCount);
    Setlength(MorphArray,MorLineCount);
  end;
end;

procedure TAVIMorphForm.MorphListBoxClick(Sender: TObject);
var
 TempNumb:Integer;
 ProcessString:String;
begin
  If MorphListBox.Items.Count >0 then
  begin
    ProcessString:=MorphListBox.Items.Strings[MorphListBox.ItemIndex];
    MorLineLabel.Caption:=ProcessString;
    TempNumb:=MorphListBox.ItemIndex;
        AVIMorphForm.BothImage.Canvas.MoveTo(
          Round(MorphArray[TempNumb].Start[0].X*(128/StartImageWidth)),
          Round(MorphArray[TempNumb].Start[0].Y*(96/StartImageHeight)));
        AVIMorphForm.BothImage.Canvas.LineTo(
          Round(MorphArray[TempNumb].Start[1].X*(128/StartImageWidth)),
          Round(MorphArray[TempNumb].Start[1].Y*(96/StartImageHeight)));

        AVIMorphForm.BothImage.Canvas.MoveTo(
          128+Round(MorphArray[TempNumb].Finish[0].X*(128/StartImageWidth)),
          Round(MorphArray[TempNumb].Finish[0].Y*(96/StartImageHeight)));
        AVIMorphForm.BothImage.Canvas.LineTo(
          128+Round(MorphArray[TempNumb].Finish[1].X*(128/StartImageWidth)),
          Round(MorphArray[TempNumb].Finish[1].Y*(96/StartImageHeight)));
  end;
end;

procedure TAVIMorphForm.RedrawLines1Click(Sender: TObject);
var I:Integer;
begin
  DrawingTool := dtLine;
  For I:=0 to MorLineCount-1 do
  begin
    AVIMorphForm.BothImage.Canvas.MoveTo(
          Round(MorphArray[I].Start[0].X*(128/StartImageWidth)),
          Round(MorphArray[I].Start[0].Y*(96/StartImageHeight)));
    AVIMorphForm.BothImage.Canvas.LineTo(
          Round(MorphArray[I].Start[1].X*(128/StartImageWidth)),
          Round(MorphArray[I].Start[1].Y*(96/StartImageHeight)));

    AVIMorphForm.BothImage.Canvas.MoveTo(
          128+Round(MorphArray[I].Finish[0].X*(128/StartImageWidth)),
          Round(MorphArray[I].Finish[0].Y*(96/StartImageHeight)));
    AVIMorphForm.BothImage.Canvas.LineTo(
          128+Round(MorphArray[I].Finish[1].X*(128/StartImageWidth)),
          Round(MorphArray[I].Finish[1].Y*(96/StartImageHeight)));
  End;
end;

procedure TAVIMorphForm.ClearAllPoints1Click(Sender: TObject);
begin
  MorphListBox.Items.Clear;
  SetLength(MorphArray,0);
  MorLineCount:=0;
  MorphingOnStart:=False;
  SetPointsBtn.Caption:='Set Points';
  MorLineLabel.Caption:='';
  SetStuffEnabled(0);
end;

procedure TAVIMorphForm.SetPointsBtnClick(Sender: TObject);
begin
  MorphingOnStart:=(not MorphingOnStart);
  If MorphingOnStart then
  begin
    SetPointsBtn.Caption:='Setting Points';
    MorLineLabel.Caption:='';
    SetStuffEnabled(2);
  end else
  begin
    SetPointsBtn.Caption:='Set Points';
    MorLineLabel.Caption:='';
  end;
end;

procedure TAVIMorphForm.ColorPanelClick(Sender: TObject);
begin
   ColorDialog1.Color:=ColorPanel.Color;
   If ColorDialog1.Execute then
   begin
   ColorPanel.Color:=ColorDialog1.Color;
   BothImage.Canvas.Pen.Color:=ColorDialog1.Color;
   end;
end;




procedure TAVIMorphForm.ViewBtnClick(Sender: TObject);
begin
  ExecuteFile(MorphFilePath+ChangeFileExt(MorphStartFileName,'.avi'),
     '', MorphFilePath, SW_SHOWNORMAL);
end;

procedure TAVIMorphForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  UserAbort:=key=#27;
end;
{---------------------------------------------------------}
{---------------------------------------------------------}


{---------------------------------------------------------}
{---------------------------------------------------------}
procedure TAVIMorphForm.EndImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (not EndImage.Picture.Bitmap.Empty) then
  If MorphingOnStartDrawing then
  begin
  MorphingOnEndDrawing:= True;
  MorphingOnStartDrawing:=False;
  DrawingTool := dtMLine;
  MEOrigin := Point(X, Y);
  MEMovePt := Point(X, Y);
  EndImage.Canvas.MoveTo(X, Y);
  Screen.Cursor := crCross;
  end;
end;

procedure TAVIMorphForm.EndImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  Xs, Ys: string;
begin
  if (not EndImage.Picture.Bitmap.Empty) then
  begin
  if (MorphingOnEndDrawing = True) then
  begin
    DrawEndShape(MEOrigin, MEMovePt, pmNotXor);
    MEMovePt := Point(X, Y);
    DrawEndShape(MEOrigin, MEMovePt, pmNotXor);
  end;
  end;
  str(X, Xs); str(Y, Ys);
  Statusbar.Panels[1].Text := '   X: ' + Xs + ', Y: ' + Ys;
end;

procedure TAVIMorphForm.EndImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var PlotString:String;
begin
  if (not EndImage.Picture.Bitmap.Empty) then
  begin
  if (MorphingOnEndDrawing = True) then
  begin
    MorphingOnEndDrawing:=False;
    MorphingOnStart:=False;
    MEMovePt := Point(X, Y);
        {Remove the line}
    DrawEndShape(MEOrigin, MEMovePt,  pmNotXor);
    DrawingTool := dtLine;
    Screen.Cursor := crDefault;
    DrawShape(MEOrigin, MEMovePt,
        DIYX3Y3, DIYX4Y4, pmNotXor);

   {Draw the line on BothImage bitmap}
{    DrawingTool := dtLine;
    DrawShape(Origin, MovePt,  pmCopy);
    DrawShape(Point(128+MOrigin.X,MOrigin.Y), MMovePt,  pmCopy);}
        AVIMorphForm.BothImage.Canvas.MoveTo(
          128+Round(MEOrigin.X*(128/StartImageWidth)),
          Round(MEOrigin.Y*(96/StartImageHeight)));

        AVIMorphForm.BothImage.Canvas.LineTo(
          128+Round(MEMovePt.X*(128/StartImageWidth)),
          Round(MEMovePt.Y*(96/StartImageHeight)));

    MorphArray[MorLineCount-1].Finish[0].X:=MEOrigin.X;
    MorphArray[MorLineCount-1].Finish[0].Y:=MEOrigin.Y;
    MorphArray[MorLineCount-1].Finish[1].X:=MEMovePt.X;
    MorphArray[MorLineCount-1].Finish[1].Y:=MEMovePt.Y;
    MorphArray[MorLineCount-1].DeltaXf:=
      MorphArray[MorLineCount-1].Finish[1].x
      -MorphArray[MorLineCount-1].Finish[0].x;
    MorphArray[MorLineCount-1].DeltaYf:=
      MorphArray[MorLineCount-1].Finish[1].y
      -MorphArray[MorLineCount-1].Finish[0].y;

    MorphArray[MorLineCount-1].LengthSQf:=
      Sqr(MorphArray[MorLineCount-1].DeltaXf)
      +Sqr(MorphArray[MorLineCount-1].DeltaYf);

    MorphArray[MorLineCount-1].Lengthf:=
      sqrt(MorphArray[MorLineCount-1].LengthSQf);

    MorphArray[MorLineCount-1].DeltaXr:=0;
    MorphArray[MorLineCount-1].DeltaYr:=0;
    MorphArray[MorLineCount-1].Lengthr:=0;
    MorphArray[MorLineCount-1].LengthSQr:=0;

         {PlotBox ?}
         {1024,0001 ; 9876,1234}
    PlotString:=(
             Inttostr(MSOrigin.X)+','+
             Inttostr(MSOrigin.Y)+' ; '+
             Inttostr(MEOrigin.X)+','+
             Inttostr(MEOrigin.Y)      );
    SetPointsBtn.Caption:='Set Points';
    MorphListBox.Items.Add(PlotString);
    MorLineLabel.Caption:=PlotString;
  end;
  end;
end;
{---------------------------------------------------------}

procedure TAVIMorphForm.DrawEndShape
  (TopLeft, BottomRight: TPoint; AMode: TPenMode);
begin
  with EndImage.Canvas do
  begin
    Pen.Mode := AMode;
    case DrawingTool of
      dtMLine:
        begin
          EndImage.Canvas.MoveTo(TopLeft.X, TopLeft.Y);
          EndImage.Canvas.LineTo(BottomRight.X, BottomRight.Y);
        end;
    end;{case}
  end;
end;
{---------------------------------------------------------}
{---------------------------------------------------------}


{---------------------------------------------------------}
procedure TAVIMorphForm.ChooseAvi1Click(Sender: TObject);
begin
  ChooseAvi1.Checked:=(not ChooseAvi1.Checked);
end;
{---------------------------------------------------------}
{10, 12, 12.5, 15, 23.97, 24, 25, 29.97, or 30 FPS}
{---------------------------------------------------------}
{VirtualDub (http://www.geocities.com/virtualdub/index.html)
AVI2MPG1 - http://www.mnsi.net/~jschlic1 )}
procedure TAVIMorphForm.MakeAVIBtnClick(Sender: TObject);
var
  AMyBitmap:TBitmap;
  I:Integer;
  SavedCap : string;
{  InHandle:Handle;}
begin
  MorphTweens:=(MorphPicsSpinEdit.Value);
  If ChooseAvi1.Checked then
     AVIRerun1.Compressor:=acShowDialog else
     AVIRerun1.Compressor:=acDefault;
  AVIRerun1.FileName:=  MorphFilePath+  ChangeFileExt(MorphStartFileName,'.avi');
  AVIRerun1.FPS:=(FPSSpinEdit.Value);
  AVIRerun1.Height:=EndImageHeight;
  AVIRerun1.Width:=EndImageWidth;
  {AVIRerun1.WavFileName:=AviWavFileName;}
  SavedCap:=AVIMorphForm.caption;
  UserAbort:=false;
  AVIMorphForm.caption:='Press ESC to abort';
  ProgressBar1.Visible:=True;
  ProgressBar1.Position:=0;
  Application.ProcessMessages;
  if (not AVIRerun1.CreateAVIFile(AVIMorphForm.Handle{:Handle})) then Exit;
   // if AVIRerun1.filename is empty, a dialog box will appear asking
   // for the filename. CreateAVIFile() will return a bool
   // indicating if user presses "cancel" in the dialog box.
  Application.ProcessMessages;

  If List1.Checked then
  begin     {List1}
     For I:=0 to ImageList.Count-1 do
     begin
      ProgressBar1.Position:=round((i/ImageList.Count)*100);
       // you might want to update your progress bar here.
      Application.ProcessMessages; // so that our app. is not freezed,
      AMyBitmap:= LoadGraphicFile(ImageList.Strings[I]);
      AVIRerun1.AddAVIFrame(AMyBitmap);
      end;
    AVIRerun1.CloseAVIFile(UserAbort);
  end else
  begin
    AVIRerun1.AddAVIFrame(Image1.Picture.Bitmap);
    {Process Bitmaps into AVI}
    i:=1;
    while ( (i< (MorphTweens+1)) and (not UserAbort)) do
    Begin
      try
      ProgressBar1.Position:=round((i/MorphTweens)*100);
       // you might want to update your progress bar here.
      Application.ProcessMessages; // so that our app. is not freezed,
                                      // and will accept user abort.
      {Create, Morph Bitmaps, Add to list}
      AMyBitmap := TBitMap.Create;
      AMyBitmap.PixelFormat := pf24Bit;
      AMyBitmap.Width := EndImage.Picture.Width;
      AMyBitmap.Height := EndImage.Picture.Height;
      If Morph2.Checked then
         TweenMorph(i,AMyBitmap)
      else
      If Warp1.Checked then
         TweenWarp(i,AMyBitmap)
      else
      If Tween1.Checked then
         TweenTween(i,AMyBitmap);
      AVIRerun1.AddAVIFrame(AMyBitmap);
      If MakeBitmapsCB.Checked then
      begin
        AMyBitmap.SaveToFile(
        MorphFilePath+Inttostr(i)+ChangeFileExt(MorphStartFileName,'.bmp'));
      end;
      finally
        AMyBitmap.Free;
        inc(i);
      end;{Finally}
    End;{While}
    AVIRerun1.AddAVIFrame(EndImage.Picture.Bitmap);
    AVIRerun1.CloseAVIFile(UserAbort); // if UserAbort, CloseAVIFile will
                                            // also delete the unfinished file.
  End;
    AVIMorphForm.caption:=SavedCap;
    ProgressBar1.Position:=0;
    ProgressBar1.Visible:=False;
    SetStuffEnabled(3);
End;
{---------------------------------------------------------}



{---------------------------------------------------------}
Procedure TAVIMorphForm.TweenTween(MorphThis:Integer;var AMyBitmap:TBitmap);
begin
  AMyBitmap :=
  CreateTweenBitmap(
{  BitmapA,}
Image1.Picture.Bitmap,
  MorphTweens- MorphThis,
{  TrackBarTween.Max-TrackBarTween.Position,}
{  BitmapB,}EndImage.Picture.Bitmap,
  MorphThis{TrackBarTween.Position});
End;

FUNCTION TAVIMorphForm.CreateTweenBitmap(CONST BitmapA:  TBitmap;
                           CONST WeightA:  CARDINAL;
                           CONST BitmapB:  TBitmap;
                           CONST WeightB:  CARDINAL):  TBitmap;
  CONST
    MaxPixelCount = 65536;
  TYPE
    TRGBArray = ARRAY[0..MaxPixelCount-1] OF TRGBTriple;
    pRGBArray = ^TRGBArray;
  VAR
    i         :  INTEGER;
    j         :  INTEGER;
    RowA      :  pRGBArray;
    RowB      :  pRGBArray;
    RowTween  :  pRGBArray;
    SumWeights:  CARDINAL;
  FUNCTION WeightPixels (CONST pixelA, pixelB:  CARDINAL):  BYTE;
  BEGIN
    RESULT := BYTE((WeightA*pixelA + WeightB*pixelB) DIV SumWeights)
  END {WeightPixels};
BEGIN
{  IF   (BitmapA.PixelFormat <> pf24bit) OR
       (BitmapB.PixelFormat <> pf24bit)
  THEN RAISE ETweenError.Create('Tween:  PixelFormats must be pf24fit');
  IF   (BitmapA.Width  <> BitmapB.Width) OR
       (BitmapA.Height <> BitmapB.Height)
  THEN RAISE ETweenError.Create('Tween:  Bitmap dimensions are not the same');
}
  SumWeights := WeightA + WeightB;
  RESULT := TBitmap.Create;
  RESULT.Width  := BitmapA.Width;
  RESULT.Height := BitmapA.Height;
  RESULT.PixelFormat := pf24bit;
  // If SumWeights is 0, just return a "empty" white image
  IF   SumWeights > 0
  THEN BEGIN
    FOR j := 0 TO RESULT.Height-1 DO
    BEGIN
      RowA     := BitmapA.Scanline[j];
      RowB     := BitmapB.Scanline[j];
      RowTween := RESULT.Scanline[j];
      FOR i := 0 TO RESULT.Width-1 DO
      BEGIN
        WITH RowTween[i] DO
        BEGIN
          rgbtRed   := WeightPixels(rowA[i].rgbtRed,   rowB[i].rgbtRed);
          rgbtGreen := WeightPixels(rowA[i].rgbtGreen, rowB[i].rgbtGreen);
          rgbtBlue  := WeightPixels(rowA[i].rgbtBlue,  rowB[i].rgbtBlue)
        END
      END
    END
  END
END {CreateTweenBitmap};
{---------------------------------------------------------}

{---------------------------------------------------------}
Procedure TAVIMorphForm.TweenWarp(MorphThis:Integer;var AMyBitmap:TBitmap);
var
  scolor:TColor;
	warp:TPoint;
  warpy,warpx,
  r, g, b:Integer;
  srcweight,dstweight,TotalWeight, i, p:Integer;
begin
  TotalWeight:=(MorphTweens+3);{?}
	// Tween the lines used to warp the images
	for i := 0 to (MorLineCount-1)do
  begin
	  for p := 0 to 1 do
    begin
			MorphArray[i].Result[p].x :=
          Round(MorphArray[i].Start[p].x +
					((MorphArray[i].Finish[p].x
            - MorphArray[i].Start[p].x) * MorphThis)
					/(MorphTweens+1));
		  MorphArray[i].Result[p].y :=
          Round(MorphArray[i].Start[p].y +
					((MorphArray[i].Finish[p].y
            - MorphArray[i].Start[p].y) * MorphThis)
					/(MorphTweens+1));
		end;
		MsetLength(i);
	end;

		dstweight := Round((MorphThis * TotalWeight) / (MorphTweens+1));
    srcweight := TotalWeight - dstweight;

		// Go through the screen and get warped source pixels */
		for warpy:=0 to StartImageHeight-1 do{(warp.y = Ymin; warp.y <= Ymax; warp.y++)}
    begin
			for warpx:=0 to StartImageWidth-1 do{(warp.x = Xmin; warp.x <= Xmax; warp.x++)}
      begin
      warp.x:=warpx;
      warp.y:=warpy;
      {sumLinessrc(src, &scolor, SrcLine, &warp, warpLine);}
      sumLinessrc(scolor,warp);
      {sumLinesdst(dst, &dcolor, DstLine, &warp, warpLine);}
{      sumLinesdst(dcolor,warp);}
				r := Round((GetRValue(scolor) * srcweight
           { +	GetRValue(dcolor) * dstweight})
							/ TotalWeight);
				g := Round((GetGValue(scolor) * srcweight
           { +	GetGValue(dcolor) * dstweight})
							/ TotalWeight);
				b := Round((GetBValue(scolor) * srcweight
           {+	GetBValue(dcolor) * dstweight})
							/ TotalWeight);
         AMyBitmap.Canvas.Pixels[warpx,warpy]:=RGB(r,g,b);
			end;
		end;
end;
{---------------------------------------------------------}

{---------------------------------------------------------}
{ FUNC: int	tweenMorph(PICTURE *src, PICTURE *dst)
 DESC: calculate a pixel to plot, from the warping function}
Procedure TAVIMorphForm.TweenMorph(MorphThis:Integer;var AMyBitmap:TBitmap);
var
scolor, dcolor:TColor;
	warp:TPoint;
  warpy,warpx,
 r, g, b{,	x,y}:Integer;  {	COLOR scolor, dcolor;}
{	LINE warpLine[MAX_LINES];}
srcweight,dstweight,TotalWeight,	{t,} i, p:Integer;
begin
  TotalWeight:=(MorphTweens+3);{?}
	// Tween the lines used to warp the images
	for i := 0 to (MorLineCount-1)do
  begin
	  for p := 0 to 1 do
    begin
			MorphArray[i].Result[p].x :=
          Round(MorphArray[i].Start[p].x +
					((MorphArray[i].Finish[p].x
            - MorphArray[i].Start[p].x) * MorphThis)
					/(MorphTweens+1));
		  MorphArray[i].Result[p].y :=
          Round(MorphArray[i].Start[p].y +
					((MorphArray[i].Finish[p].y
            - MorphArray[i].Start[p].y) * MorphThis)
					/(MorphTweens+1));
		end;
		MsetLength(i);
	end;

		dstweight := Round((MorphThis * TotalWeight) / (MorphTweens+1));
    srcweight := TotalWeight - dstweight;

		// Go through the screen and get warped source pixels */
		for warpy:=0 to StartImageHeight-1 do{(warp.y = Ymin; warp.y <= Ymax; warp.y++)}
    begin
			for warpx:=0 to StartImageWidth-1 do{(warp.x = Xmin; warp.x <= Xmax; warp.x++)}
      begin
      warp.x:=warpx;
      warp.y:=warpy;
      {sumLinessrc(src, &scolor, SrcLine, &warp, warpLine);}
      sumLinessrc(scolor,warp);
      {sumLinesdst(dst, &dcolor, DstLine, &warp, warpLine);}
      sumLinesdst(dcolor,warp);
				r := Round((GetRValue(scolor) * srcweight
            +	GetRValue(dcolor) * dstweight)
							/ TotalWeight);
				g := Round((GetGValue(scolor) * srcweight
            +	GetGValue(dcolor) * dstweight)
							/ TotalWeight);
				b := Round((GetBValue(scolor) * srcweight
           +	GetBValue(dcolor) * dstweight)
							/ TotalWeight);
         AMyBitmap.Canvas.Pixels[warpx,warpy]:=RGB(r,g,b);
			 {	Red[warp.x][warp.y] = r;
				Grn[warp.x][warp.y] = g;
				Blu[warp.x][warp.y] = b;}
			end;
		end;
{  AMyBitmap.Assign(GCForm.Image1.Picture.Bitmap);}
end;

{FUNC: int	setLength(LINE *line)
  Set the deltas, the length and the length squared
		for a given line.}
Procedure TAVIMorphForm.MsetLength(Which:Integer);
begin
    MorphArray[Which].DeltaXr:=
      MorphArray[Which].Result[1].x
      -MorphArray[Which].Result[0].x;
    MorphArray[Which].DeltaYr:=
      MorphArray[Which].Result[1].y
      -MorphArray[Which].Result[0].y;

    MorphArray[Which].LengthSQr:=
      Sqr(MorphArray[Which].DeltaXr)
      +Sqr(MorphArray[Which].DeltaYr);

    MorphArray[Which].Lengthr:=
      sqrt(MorphArray[Which].LengthSQr);
end;

Procedure TAVIMorphForm.sumLinesdst(var InColor:TColor;warp:TPoint);
var
	line, x, y:Integer;
	deltaSumX,deltaSumY,weight, weightSum, distance:Double;
	orig:TPoint;
begin
deltaSumX := 0.0;
deltaSumY := 0.0;
	// if no control lines, get an unwarped pixel */
	if (MorLineCount = 0)then
  begin
  orig := warp;
  end	else
  begin
		weightSum := 0.0;
		for line := 0 to MorLineCount-1 do	{origline++, warpline++)}
    begin          {Fills src orig data}
			distance := getSourceLocdst(line,orig,warp);
			weight := 1.0/(0.001+distance*distance);
			deltaSumX := deltaSumX+(orig.x - warp.x) * weight;
			deltaSumY := deltaSumY+(orig.y - warp.y) * weight;
			weightSum :=weightSum+ weight;
		end;
		orig.x := Round(warp.x + deltaSumX / weightSum + 0.5);
		orig.y := Round(warp.y + deltaSumY / weightSum + 0.5);
	end;
	// clip it to the nearest border pixel */
	x := clip(orig.x, 0, StartImageWidth-1);
	y := clip(orig.y, 0, StartImageHeight-1);
  InColor:=EndImage.Canvas.Pixels[x, y];
end;

{				sumLines(src, &scolor, SrcLine, &warp, warpLine);
				sumLines(dst, &dcolor, DstLine, &warp, warpLine);}
{PICTURE *picture,
COLOR *color,
LINE *origline,
POINT *warp,
LINE *warpline)Integer;
DESC: Sum and weight the contribution of each warping line}
Procedure TAVIMorphForm.sumLinessrc(var InColor:TColor;warp:TPoint);
var
	line, x, y:Integer;
	deltaSumX,deltaSumY,weight, weightSum, distance:Double;
	orig:TPoint;
begin
deltaSumX := 0.0;
deltaSumY := 0.0;
	// if no control lines, get an unwarped pixel */
	if (MorLineCount = 0)then
  begin
  orig := warp;
  end	else
  begin
		weightSum := 0.0;
		for line := 0 to MorLineCount-1 do	{origline++, warpline++)}
    begin          {Fills src orig data}
			distance := getSourceLocsrc(line,orig,warp);
			weight := 1.0/(0.001+distance*distance);
			deltaSumX := deltaSumX+(orig.x - warp.x) * weight;
			deltaSumY := deltaSumY+(orig.y - warp.y) * weight;
			weightSum :=weightSum+ weight;
		end;
		orig.x := Round(warp.x + deltaSumX / weightSum + 0.5);
		orig.y := Round(warp.y + deltaSumY / weightSum + 0.5);
	end;
	// clip it to the nearest border pixel */
	x := clip(orig.x, 0, StartImageWidth-1);
	y := clip(orig.y, 0, StartImageHeight-1);
  InColor:=Image1.Canvas.Pixels[x, y];
end;

{DESC: Clip the number to a value between min and max, inclusive.}
Function TAVIMorphForm.clip(num, min, max:Integer):Integer;
begin
	if (num < min)then num := min
	else if (num > max)then num := max;
	clip:= num;
end;

{ DESC: For a given line, locate the corresponding warped pixel
POINT *orig,
LINE *origline,
POINT *warp,
LINE *warpline)Double;}
Function TAVIMorphForm.getSourceLocsrc(Todo:Integer;var orig,warp:TPoint):Double;
var
	distance, fraction, fdist:Double;
	dx, dy:Integer;
begin
	dx := warp.x - MorphArray[Todo].Result[0].X;
	dy := warp.y - MorphArray[Todo].Result[0].Y;
	fraction := (dx *  MorphArray[Todo].deltaxr
             + dy * MorphArray[Todo].deltayr)
				/  (MorphArray[Todo].lengthSQr);
	fdist := (dx *  -MorphArray[Todo].deltayr
          + dy * MorphArray[Todo].deltaxr)
				/ MorphArray[Todo].lengthr;
	if (fraction <= 0 )then
		distance := sqrt(dx* dx + dy * dy)
	else if (fraction >= 1) then
  begin
		dx := warp.x - MorphArray[Todo].Result[1].x;
		dy := warp.y - MorphArray[Todo].Result[1].y;
		distance := sqrt(dx* dx + dy * dy);
	end
	else if (fdist >= 0)then distance :=  fdist
	else distance := -fdist;

	orig.x :=Round(MorphArray[Todo].Start[0].X
  + fraction * MorphArray[Todo].deltaxs -
				fdist * MorphArray[Todo].deltays
				/ MorphArray[Todo].lengths + 0.5);
	orig.y := Round(MorphArray[Todo].Start[0].y
  + fraction * MorphArray[Todo].deltays +
				fdist * MorphArray[Todo].deltaxs
				/  MorphArray[Todo].lengths + 0.5);

getSourceLocsrc:=distance;
end;


Function TAVIMorphForm.getSourceLocdst(Todo:Integer;var orig,warp:TPoint):Double;
var
	distance, fraction, fdist:Double;
	dx, dy:Integer;
begin
	dx := warp.x - MorphArray[Todo].Result[0].X;
	dy := warp.y - MorphArray[Todo].Result[0].Y;
	fraction := (dx *  MorphArray[Todo].deltaxr
             + dy * MorphArray[Todo].deltayr)
				/  (MorphArray[Todo].lengthSQr);
	fdist := (dx *  -MorphArray[Todo].deltayr
          + dy * MorphArray[Todo].deltaxr)
				/ MorphArray[Todo].lengthr;
	if (fraction <= 0 )then
		distance := sqrt(dx* dx + dy * dy)
	else if (fraction >= 1) then
  begin
		dx := warp.x - MorphArray[Todo].Result[1].x;
		dy := warp.y - MorphArray[Todo].Result[1].y;
		distance := sqrt(dx* dx + dy * dy);
	end
	else if (fdist >= 0)then distance :=  fdist
	else distance := -fdist;

	orig.x :=Round(MorphArray[Todo].Finish[0].X
  + fraction * MorphArray[Todo].deltaxf -
				fdist * MorphArray[Todo].deltayf
				/ MorphArray[Todo].lengthf + 0.5);
	orig.y := Round(MorphArray[Todo].Finish[0].y
  + fraction * MorphArray[Todo].deltayf +
				fdist * MorphArray[Todo].deltaxf
				/  MorphArray[Todo].lengthf + 0.5);

getSourceLocdst:=distance;
end;
{---------------------------------------------------------}

{---------------------------------------------------------}
FUNCTION TAVIMorphForm.LoadGraphicFile(CONST Filename:  STRING):  TBitmap;
  VAR
    GraphicClass: TGraphicExGraphicClass;
    Graphic: TGraphic;
    Target  :  TBitmap;
begin
    RESULT := nil;
  IF   FileExists(Filename) THEN
  BEGIN
      GraphicClass := FileFormatList.GraphicFromContent(FileName);
      if GraphicClass = nil then EndImage.Picture.LoadFromFile(FileName)
      else
      begin
        // GraphicFromContent always returns TGraphicExGraphicClass
        Graphic := GraphicClass.Create;
        Graphic.LoadFromFile(FileName);
        EndImage.Picture.Graphic := Graphic;
      end;
        if (not(EndImage.Picture.Graphic is TBitmap)) then
        begin
          Target := TBitmap.Create;
          Target.PixelFormat := pf24Bit;
          Target.Width := EndImage.Picture.Width;
          Target.Height := EndImage.Picture.Height;
          Target.Canvas.Draw(0, 0, EndImage.Picture.Graphic);
          EndImage.Picture.Graphic := Target;
          Target.Free;
        end;
        EndImage.Picture.Bitmap.PixelFormat := pf24bit;
    RESULT := EndImage.Picture.Bitmap;
    RESULT.PixelFormat := pf24Bit;
  END else showmessage(Filename);
end;
{---------------------------------------------------------}




procedure TAVIMorphForm.List1Click(Sender: TObject);
begin
  List1.Checked:=True;
  SetStuffEnabled(2);
  LoadImageList1.Enabled:=True;
  FillListbyFileSelection1.Enabled:=True;
end;
procedure TAVIMorphForm.LoadImageList1Click(Sender: TObject);
begin
  OpenDialog1.Filter:=
    'All (*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf'+
    '|Portable Network Graphics (*.png)|*.png|JPEG Image File (*.jpg)|*.jpg|JPEG Image File (*.jpeg)|*.jpeg|Bitmaps (*.bmp)|*.bmp|Icons (*.ico)|*.ico|Enhanced Metafiles (*.emf)|*.emf|Metafiles (*.wmf)|*.wmf|Morph List Text|*.mlt';
  OpenDialog1.InitialDir:=MorphFilePath;
  OpenDialog1.FileName:=MorphStartFileName;
  with OpenDialog1 do
  if Execute then
  begin
    ImageList.Clear;
    ImageList.Sorted := False;
    ImageList.LoadFromFile(OpenDialog1.FileName);
  end;   {ImageList is KEPT in order from List}
end;

procedure TAVIMorphForm.FillListbyFileSelection1Click(Sender: TObject);
var i:Integer;
begin
  OpenDialog1.Filter:=
    'All (*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf'+
    '|Portable Network Graphics (*.png)|*.png|JPEG Image File (*.jpg)|*.jpg|JPEG Image File (*.jpeg)|*.jpeg|Bitmaps (*.bmp)|*.bmp|Icons (*.ico)|*.ico|Enhanced Metafiles (*.emf)|*.emf|Metafiles (*.wmf)|*.wmf|Morph List Text|*.mlt';
  OpenDialog1.InitialDir:=MorphFilePath;
  OpenDialog1.FileName:=MorphStartFileName;
  with OpenDialog1 do
  if Execute then
  begin
    ImageList.Clear;
      {Selected files are NOT picked in order by File Dialog}
    ImageList.Sorted := True;
    with OpenDialog1.Files do
    for I := 0 to Count - 1 do
    begin
        ImageList.Add( Strings[I]);
    end;
  end;  {ImageList}
end;

procedure TAVIMorphForm.Warp1Click(Sender: TObject);
begin
  Warp1.Checked:=True;
end;

procedure TAVIMorphForm.Morph2Click(Sender: TObject);
begin
  Morph2.Checked:=True;
end;

procedure TAVIMorphForm.Tween1Click(Sender: TObject);
begin
  Tween1.Checked:=True;
end;

procedure TAVIMorphForm.ViewFrames1Click(Sender: TObject);
begin
  AviFrmMain:=TAviFrmMain.Create(Application);
  try
    AviFrmMain.ShowModal;
  finally
    AviFrmMain.Release;
  end;
end;
(*************************************************************)
(*************************************************************)


(*************************************************************)
(*************************************************************)


procedure TAVIMorphForm.Image1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (not Image1.Picture.Bitmap.Empty) then
   if (MorphingOnStart = True) then
      begin
        DrawingTool := dtLine;
        DrawingStart := True;
        Image1.Canvas.MoveTo(X, Y);
        MSOrigin := Point(X, Y);
        MSMovePt := Point(X, Y);
      Screen.Cursor := crCross;
      end
end;

procedure TAVIMorphForm.Image1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  Xs, Ys: string;
begin
  if DrawingStart then
  begin
    if ((DrawingTool = dtLine) ) then
      begin
        if (ssShift in shift)then
        begin
            DrawShape(MSOrigin, MSMovePt, DIYX3Y3, DIYX4Y4, pmNotXor);
            Image1.Canvas.MoveTo(X, Y);
            MSOrigin := Point(X, Y);
            MSMovePt := Point(X, Y);
            DrawShape(MSOrigin, MSMovePt, DIYX3Y3, DIYX4Y4, pmNotXor);
        end else
        begin
            DrawShape(MSOrigin, MSMovePt, DIYX3Y3, DIYX4Y4, pmNotXor);
            MSMovePt := Point(X, Y);
            DrawShape(MSOrigin, MSMovePt, DIYX3Y3, DIYX4Y4, pmNotXor);
        end;
      end ;
  end;
  str(X, Xs); str(Y, Ys);
  Statusbar.Panels[0].Text := '   X: ' + Xs + ', Y: ' + Ys;
end;

procedure TAVIMorphForm.Image1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
      if (DrawingStart = True) then
      begin
        DrawingStart := False;
        MorphingOnStartDrawing:= True;
        DrawingTool := dtLine;
        MSMovePt := Point(X, Y);
    inc(MorLineCount);
    Setlength(MorphArray,MorLineCount);
    MorphArray[MorLineCount-1].Start[0].X:=MSOrigin.X;
    MorphArray[MorLineCount-1].Start[0].Y:=MSOrigin.Y;
    MorphArray[MorLineCount-1].Start[1].X:=MSMovePt.X;
    MorphArray[MorLineCount-1].Start[1].Y:=MSMovePt.Y;
    MorphArray[MorLineCount-1].DeltaXs:=
      MorphArray[MorLineCount-1].Start[1].x
      -MorphArray[MorLineCount-1].Start[0].x;
    MorphArray[MorLineCount-1].DeltaYs:=
      MorphArray[MorLineCount-1].Start[1].y
      -MorphArray[MorLineCount-1].Start[0].y;

    MorphArray[MorLineCount-1].LengthSQs:=
      Sqr(MorphArray[MorLineCount-1].DeltaXs)
      +Sqr(MorphArray[MorLineCount-1].DeltaYs);

    MorphArray[MorLineCount-1].Lengths:=
      sqrt(MorphArray[MorLineCount-1].LengthSQs);
    Screen.Cursor := crDefault;
        AVIMorphForm.BothImage.Canvas.MoveTo(
          Round(MSOrigin.X*(128/StartImageWidth)),
          Round(MSOrigin.Y*(96/StartImageHeight)));
        AVIMorphForm.BothImage.Canvas.LineTo(
          Round(MSMovePt.X*(128/StartImageWidth)),
          Round(MSMovePt.Y*(96/StartImageHeight)));
        {AVIMorphForm.Show;}
      end
end;

procedure TAVIMorphForm.DrawShape
  (TopLeft, BottomRight, Tri, Quad: TPoint; AMode: TPenMode);
begin
  with Image1.Canvas do
  begin
    Pen.Mode := AMode;    {pmCopy}
    case DrawingTool of
      dtLine:
        begin
          Image1.Canvas.MoveTo(TopLeft.X, TopLeft.Y);
          Image1.Canvas.LineTo(BottomRight.X, BottomRight.Y);
        end;
{      dtVDRectangle, dtVTRectangle, dtVFRectangle, dtVNRectangle,
        dtVMRectangle, dtVARectangle, dtVWRectangle, dtVCRectangle,
        dtVSRectangle, dtVBRectangle,}
        dtVRectangle, dtRectangle:
        Image1.Canvas.Rectangle
          (TopLeft.X, TopLeft.Y, BottomRight.X, BottomRight.Y);
      dtCSEllipse, dtEllipse:
        Image1.Canvas.Ellipse
          (Topleft.X, TopLeft.Y, BottomRight.X, BottomRight.Y);
      dtPBrush:
        Image1.Canvas.Ellipse
          (Topleft.X, TopLeft.Y,
          (Topleft.X + DrawingToolPBrushWidth),
          (TopLeft.Y + DrawingToolPBrushWidth));
      dtRoundRect: Image1.Canvas.RoundRect
        (TopLeft.X, TopLeft.Y, BottomRight.X,
          BottomRight.Y, (TopLeft.X - BottomRight.X) div 2,
          (TopLeft.Y - BottomRight.Y) div 2);
    end;
    Pen.Mode := pmCopy;
  end;
end;
(*************************************************************)
(*************************************************************)







end.
