unit DbAdrViewFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Spin, StdCtrls, Buttons,
  ExtCtrls, DBCtrls, Mask, DBCGrids;

type
  TDbAdrViewForm = class(TForm)
    DBNavigator1: TDBNavigator;
    CloseBitBtn: TBitBtn;
    HelpBitBtn: TBitBtn;
    DisconnectBtn: TBitBtn;
    PrintBtn: TBitBtn;
    ConnectBtn: TBitBtn;
    LabelBtn: TBitBtn;
    DBEdit11: TDBEdit;
    Label11: TLabel;
    DBEdit12: TDBEdit;
    Label12: TLabel;
    DBCheckBox3: TDBCheckBox;
    DBCheckBox4: TDBCheckBox;
    DBEdit13: TDBEdit;
    Label13: TLabel;
    DBEdit14: TDBEdit;
    Label14: TLabel;
    DBEdit15: TDBEdit;
    Label15: TLabel;
    DBEdit16: TDBEdit;
    Label16: TLabel;
    DBEdit17: TDBEdit;
    DBEdit18: TDBEdit;
    Label18: TLabel;
    DBEdit19: TDBEdit;
    Label19: TLabel;
    DBEdit20: TDBEdit;
    Label20: TLabel;
    DatabaseSaveBitBtn: TBitBtn;
    AddressRadioGroup: TRadioGroup;
    NamebyRG: TRadioGroup;
    ImgLabelBtn: TBitBtn;
    ImgLabel30Btn: TBitBtn;
    BigLabelsCB: TCheckBox;
    DBImage2: TDBImage;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    DBNavigator2: TDBNavigator;
    DBEdit2: TDBEdit;
    ImageConnectionBtn: TBitBtn;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    Label3: TLabel;
    DBEdit6: TDBEdit;
    Label4: TLabel;
    DBEdit7: TDBEdit;
    AddAddressBtn: TBitBtn;
    EmailBtn: TSpeedButton;
    DBCheckBox1: TDBCheckBox;
    FamilyLinkerBtn: TSpeedButton;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    DBEdit10: TDBEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    KeyedCB: TCheckBox;
    DBCheckBox2: TDBCheckBox;
    DBCheckBox5: TDBCheckBox;
    DBCheckBox6: TDBCheckBox;
    DBEdit21: TDBEdit;
    Label2: TLabel;
    Label5: TLabel;
    SentAndReceivedCB: TCheckBox;
    ClearReceivedBtn: TSpeedButton;
    ClearSentBtn: TSpeedButton;
    AddPersonNotAddressBtn: TSpeedButton;
    SaveDialog1: TSaveDialog;
    AddPersonAndAddressBtn: TSpeedButton;
    AllDataCB: TCheckBox;
    ClearRelativeBtn: TSpeedButton;
    DBCheckBox7: TDBCheckBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CloseBitBtnClick(Sender: TObject);
    procedure HelpBitBtnClick(Sender: TObject);
    procedure Select;
    procedure Disconnect;
    procedure DisconnectBtnClick(Sender: TObject);
    procedure ConnectBtnClick(Sender: TObject);
    procedure Connect;
    procedure DatabaseDo;
procedure DatabaseDoAll;    
    procedure PrintBtnClick(Sender: TObject);
    procedure LabelBtnClick(Sender: TObject);
    procedure DatabaseSaveBitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImgLabelBtnClick(Sender: TObject);
    procedure ImgLabel30BtnClick(Sender: TObject);
procedure DatabaseDodo;

    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure ImageConnectionBtnClick(Sender: TObject);
    procedure DBNavigator2Click(Sender: TObject; Button: TNavigateBtn);
    procedure FormDeactivate(Sender: TObject);
    procedure AddAddressBtnClick(Sender: TObject);
    procedure EmailBtnClick(Sender: TObject);
    procedure FamilyLinkerBtnClick(Sender: TObject);
    procedure ClearReceivedBtnClick(Sender: TObject);
    procedure ClearSentBtnClick(Sender: TObject);
    procedure AddPersonNotAddressBtnClick(Sender: TObject);
    procedure AddPersonAndAddressBtnClick(Sender: TObject);
    procedure ClearRelativeBtnClick(Sender: TObject);
  private
    { Private declarations }
    SavingToFile:Boolean;
  public
    { Public declarations }
  end;

var
  DbAdrViewForm: TDbAdrViewForm;

implementation

{$R *.DFM}
uses ShellAPI, TongGlobals,
     DbSessionFrm,
     DBAdrPrnForm, DBAdrPrnAllForm, DBAdrLblForm,
     DBAdrImgLblForm, DBBigAdrImgLblForm;


procedure TDbAdrViewForm.FormCreate(Sender: TObject);
begin
  left := DbAdrViewFormX;
  top := DbAdrViewFormY;
  DBNavigator1.Enabled:=False;
  SavingToFile:=False;
end;

procedure TDbAdrViewForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  DbAdrViewFormX := DbAdrViewForm.left;
  DbAdrViewFormY := DbAdrViewForm.top;
  DbSessionForm.DataTable.Filtered := False;
  DbSessionForm.DataTable.Filter := '';
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.ImagTable.Filter := '';
  disconnect;
end;
procedure TDbAdrViewForm.FormDeactivate(Sender: TObject);
begin
  DbSessionForm.DataTable.Filtered :=False;
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.DataTable.Filter := '';
  DbSessionForm.ImagTable.Filter := '';
end;
procedure TDbAdrViewForm.CloseBitBtnClick(Sender: TObject);
begin
  DbSessionForm.ImagTable.Filtered := False;
  Close;
end;

procedure TDbAdrViewForm.HelpBitBtnClick(Sender: TObject);
begin
  {Get Help for Address Viewer}
  Application.HelpContext(9200);
end;

procedure TDbAdrViewForm.Select;
var Which: Integer;
begin
  Which := AddressRadioGroup.ItemIndex;
  case Which of
    0..1: begin
        DbSessionForm.DataTable.Filtered := False;
        DbSessionForm.DataTable.Filter := '';
      end;
    2: begin
        DbSessionForm.DataTable.Filter := 'Sent';
        DbSessionForm.DataTable.Filtered := True;
      end;
    3: begin
        DbSessionForm.DataTable.Filter := 'Rcvd';
        DbSessionForm.DataTable.Filtered := True;
      end;
  end;
end;


procedure TDbAdrViewForm.DisconnectBtnClick(Sender: TObject);
begin
  disconnect;
  DBNavigator2.Enabled:=True;
  DBNavigator1.Enabled:=False;
  DbSessionForm.ImagTable.Filtered := False;
end;

procedure TDbAdrViewForm.Disconnect;
begin
  DbSessionForm.ImagTable.Active := False;
  DbSessionForm.LinkTable.Active := False;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.AdrTable.Active := False;
  DbSessionForm.ImagTable.MasterSource := nil;
  DbSessionForm.ImagTable.MasterFields := '';
  DbSessionForm.ImagTable.IndexFieldNames := '';
  DbSessionForm.LinkTable.MasterSource := nil;
  DbSessionForm.LinkTable.MasterFields := '';
  DbSessionForm.LinkTable.IndexFieldNames := '';
  DbSessionForm.DataTable.MasterSource := nil;
  DbSessionForm.DataTable.MasterFields := '';
  DbSessionForm.DataTable.IndexName := '';
  DbSessionForm.AdrTable.MasterSource := nil; {2}
  DbSessionForm.AdrTable.MasterFields := ''; {AddLink}
  DbSessionForm.AdrTable.IndexFieldNames := ''; {AddLink}
  DbSessionForm.AdrTable.Active := True;
  DbSessionForm.ImagTable.Active := True;
  DbSessionForm.LinkTable.Active := True;
  DbSessionForm.DataTable.Active := True;
end;


procedure TDbAdrViewForm.ConnectBtnClick(Sender: TObject);
begin
  connect;
  DBNavigator2.Enabled:=False;
  DBNavigator1.Enabled:=True;
  DbSessionForm.ImagTable.Filtered := False;
end;

procedure TDbAdrViewForm.Connect;
begin
  DbSessionForm.AdrTable.Active := False;
  DbSessionForm.ImagTable.Active := False;
  DbSessionForm.LinkTable.Active := False;
  DbSessionForm.DataTable.Active := False;

  DbSessionForm.DataTable.MasterSource := nil;
  DbSessionForm.DataTable.MasterFields := '';
  DbSessionForm.DataTable.IndexName := '';
  DbSessionForm.ImagTable.MasterSource :=DbSessionForm.AdrDS;{ HoloForm.LinkDS;}
  DbSessionForm.ImagTable.MasterFields := 'ImageLink';
  DbSessionForm.ImagTable.IndexFieldNames := 'ImageLink';
{  DbSessionForm.ImagTable.MasterSource := nil;
  DbSessionForm.ImagTable.MasterFields := '';
  DbSessionForm.ImagTable.IndexFieldNames := '';}
{  DbSessionForm.LinkTable.MasterSource := nil;
  DbSessionForm.LinkTable.MasterFields := '';
  DbSessionForm.LinkTable.IndexName := '';}
  DbSessionForm.LinkTable.MasterSource := DbSessionForm.DataDS;
  DbSessionForm.LinkTable.MasterFields := 'FamilyLink';
  DbSessionForm.LinkTable.IndexName := 'FLink';
  DbSessionForm.AdrTable.MasterSource := DbSessionForm.DataDS; {2}
  DbSessionForm.AdrTable.MasterFields := 'AddLink'; {AddLink}
  DbSessionForm.AdrTable.IndexFieldNames := 'AddLink'; {AddLink}
  DbSessionForm.LinkTable.Active := True;
  DbSessionForm.DataTable.Active := True;
  DbSessionForm.AdrTable.Active := True;
  DbSessionForm.ImagTable.Active := True;
end;

procedure TDbAdrViewForm.FamilyLinkerBtnClick(Sender: TObject);
begin
{Change DataDS Link to Family-Parent}
  DbSessionForm.AdrTable.Active := False;
  DbSessionForm.ImagTable.Active := False;
  DbSessionForm.LinkTable.Active := False;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.DataTable.Filtered := False;
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.DataTable.MasterSource := nil;
  DbSessionForm.DataTable.MasterFields := '';
  DbSessionForm.DataTable.IndexName := 'PLink';
  DbSessionForm.LinkTable.MasterSource := DbSessionForm.DataDS;
  DbSessionForm.LinkTable.MasterFields := 'FamilyLink';
  DbSessionForm.LinkTable.IndexName := 'FLink';
  {LinkDS;}
{  DbSessionForm.ImagTable.MasterSource := DbSessionForm.AdrDS;
  DbSessionForm.ImagTable.MasterFields := 'ImageLink';
  DbSessionForm.ImagTable.IndexFieldNames := 'ImageLink';}
  DbSessionForm.ImagTable.MasterSource := nil;
  DbSessionForm.ImagTable.MasterFields := '';
  DbSessionForm.ImagTable.IndexFieldNames := '';
  DbSessionForm.AdrTable.MasterSource := DbSessionForm.DataDS; {2}
  DbSessionForm.AdrTable.MasterFields := 'AddLink'; {AddLink}
  DbSessionForm.AdrTable.IndexFieldNames := 'AddLink'; {AddLink}

  DbSessionForm.DataTable.Active := True;
  DbSessionForm.LinkTable.Active := True;
  DbSessionForm.ImagTable.Active := True;
  DbSessionForm.AdrTable.Active := True;

  DBNavigator1.Enabled:=True;  //?? Both??
  DBNavigator2.Enabled:=True;
end;

procedure TDbAdrViewForm.ImageConnectionBtnClick(Sender: TObject);
begin

  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.AdrTable.Active := False;
  DbSessionForm.ImagTable.Active := False;
  DbSessionForm.LinkTable.Active := False;
  DbSessionForm.DataTable.Active := False;

  DbSessionForm.DataTable.MasterSource := nil;
  DbSessionForm.DataTable.MasterFields := '';
  DbSessionForm.DataTable.IndexName := '';
{  DbSessionForm.LinkTable.MasterSource := nil;
  DbSessionForm.LinkTable.MasterFields := '';
  DbSessionForm.LinkTable.IndexName := '';}
  DbSessionForm.LinkTable.MasterSource := DbSessionForm.DataDS;
  DbSessionForm.LinkTable.MasterFields := 'FamilyLink';
  DbSessionForm.LinkTable.IndexName := 'FLink';
 (* DbSessionForm.ImagTable.MasterSource := {DbSessionForm.AdrDS;} {HoloForm.LinkDS;}
  DbSessionForm.ImagTable.MasterFields := 'ImageLink';
  DbSessionForm.ImagTable.IndexFieldNames := 'ImageLink'; *)
  DbSessionForm.ImagTable.MasterSource := nil;
  DbSessionForm.ImagTable.MasterFields := '';
  DbSessionForm.ImagTable.IndexFieldNames := '';
  DbSessionForm.AdrTable.MasterSource := DbSessionForm.DataDS; {2}
  DbSessionForm.AdrTable.MasterFields := 'AddLink'; {AddLink}
  DbSessionForm.AdrTable.IndexFieldNames := 'AddLink'; {AddLink}
  DbSessionForm.LinkTable.Active := True;
  DbSessionForm.DataTable.Active := True;
  DbSessionForm.AdrTable.Active := True;
  DbSessionForm.ImagTable.Active := True;

  DBNavigator1.Enabled:=True;
  DBNavigator2.Enabled:=True;
end;

procedure TDbAdrViewForm.DBNavigator1Click(Sender: TObject;
  Button: TNavigateBtn);
{  var ImageInt:Integer;}
begin
  {Address Link selects the Image}
{  ImageInt:=HoloForm.AdrTableImageLink.Value;
        DbSessionForm.ImagTable.Filtered := False;
        DbSessionForm.ImagTable.Filter := 'ImageLink='+
                                     Inttostr(ImageInt);
  DbSessionForm.ImagTable.Filtered := True;}
end;

procedure TDbAdrViewForm.DBNavigator2Click(Sender: TObject;
  Button: TNavigateBtn);
begin
{  DbSessionForm.ImagTable.Filtered := False;}
end;

procedure TDbAdrViewForm.PrintBtnClick(Sender: TObject);
begin
  If AllDataCB.Checked then
  begin
    DbSessionForm.AdrSavedAllTable.Active := True;
    DatabaseDoAll;
    DbSessionForm.AdrSavedAllTable.Active := False;
    DbSessionForm.AdrSavedAllTable.MasterSource := nil;
    DbSessionForm.AdrSavedAllTable.MasterFields := '';
    DbSessionForm.AdrSavedAllTable.IndexName := 'Named';
    DbSessionForm.AdrSavedAllTable.Active := True;
    DbAdrPrnAllForm.DbAdrPrnAllFrm.QuickRep1.Preview; {: TAdrPrnForm}
    DbSessionForm.AdrSavedAllTable.Active := False;
  end else
  begin
    DbSessionForm.AdrSavedTable.Active := True;
    DatabaseDo;  //DatabaseDoDo is for 30 Dupe labels
    DbAdrPrnForm.DbAdrPrnFrm.QuickRep1.Preview; {: TAdrPrnForm}
    DbSessionForm.AdrSavedTable.Active := False;
  end;
end;

{2.625" wide 1.0 " height}
procedure TDbAdrViewForm.LabelBtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  DatabaseDo;
  DbAdrLblForm.DbAdrLblFrm.QuickRep1.Preview;
  DbSessionForm.AdrSavedTable.Active := False;
end;

{2.625" wide 1.0 " height}
{4 x 2}
procedure TDbAdrViewForm.ImgLabelBtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  DatabaseDo;
  If BigLabelsCB.Checked then
  DbBigAdrImgLblForm.DbBigAdrImgLblFrm.QuickRep1.Preview else
  DbAdrImgLblForm.DbAdrImgLblFrm.QuickRep1.Preview;
  DbSessionForm.AdrSavedTable.Active := False;
end;

//Uhm does NOT save so far... ?
procedure TDbAdrViewForm.DatabaseSaveBitBtnClick(Sender: TObject);
var
  F: Textfile;
  Name,  Address, City: string;
begin
  SaveDialog1.Filter := 'Family Image database|*.txt';
  SaveDialog1.FileName := '*.txt';
  SaveDialog1.InitialDir:=DbPath;
  If  SaveDialog1.execute then
  begin   //  Get the file name
    AssignFile(F, SaveDialog1.FileName);
    try  //Create the file
      Rewrite(F);
      DbSessionForm.AdrSavedTable.Active := True;
      DatabaseDo;
      //Loop to save the data.. NOT the Blob image tho
      DbSessionForm.AdrSavedTable.First;
      while (not DbSessionForm.AdrSavedTable.EOF) do
      begin
        Name := DbSessionForm.AdrSavedTable.FieldByName('NameName').AsString;
        Address := DbSessionForm.AdrSavedTable.FieldByName('Address').AsString;
        City := DbSessionForm.AdrSavedTable.FieldByName('City').AsString;
        //Append name to File
        //Writeln(F, Name+' '+Address+' '+City);
        Writeln(F, Name);
        Writeln(F,  Address);
        Writeln(F, City);
        Writeln(F,'');//Blank line separator
        DbSessionForm.AdrSavedTable.Next;
      end; //of eof loop
    finally
        CloseFile(F);
        DbSessionForm.AdrSavedTable.Active := False;
    end; //of finally
  end; //of SaveDialog1
end;

procedure TDbAdrViewForm.ClearSentBtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  Connect;
  Select;
  DbSessionForm.DataTable.First;
  while (not DbSessionForm.DataTable.EOF) do
  begin
    DbSessionForm.DataTable.Edit;
    DBCheckBox4.Checked :=False;
    DbSessionForm.DataTableSent.Value:= False;
    DbSessionForm.DataTable.Post;
    DbSessionForm.DataTable.Next;
  end;
  DbSessionForm.DataTable.Filtered :=False;
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.AdrSavedTable.Active := False;
end;
procedure TDbAdrViewForm.ClearReceivedBtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  Connect;
  Select;
  DbSessionForm.DataTable.First;
  while (not DbSessionForm.DataTable.EOF) do
  begin
    DbSessionForm.DataTable.Edit;
    DBCheckBox3.Checked :=False;
    DbSessionForm.DataTableRcvd.Value:= False;
    DbSessionForm.DataTable.Post;
    DbSessionForm.DataTable.Next;
  end;
  DbSessionForm.DataTable.Filtered :=False;
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.AdrSavedTable.Active := False;
end;
procedure TDbAdrViewForm.ClearRelativeBtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  Connect;
  Select;
  DbSessionForm.DataTable.First;
  while (not DbSessionForm.DataTable.EOF) do
  begin
    DbSessionForm.DataTable.Edit;
    DBCheckBox7.Checked :=False;
    DbSessionForm.DataTableRelative.Value:= False;
    DbSessionForm.DataTable.Post;
    DbSessionForm.DataTable.Next;
  end;
  DbSessionForm.DataTable.Filtered :=False;
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.AdrSavedTable.Active := False;
end;



procedure TDbAdrViewForm.DatabaseDo;
var
  i:Integer;
  Key, SandR,
  aFirstName,  LastName, FirstName,
  A, Address, City, State, Zip: string;
begin
  Connect;
  Select;
  {Empty old table data}
  DbSessionForm.AdrSavedTable.First;
  while (not DbSessionForm.AdrSavedTable.EOF) do
  begin
    DbSessionForm.AdrSavedTable.Delete;
  end;
  {Compile data for new Saved Table}
  DbSessionForm.DataTable.First;
  {HoloForm.AdrSavedTable.Active:=True;}
  i:=1;
  while (not DbSessionForm.DataTable.EOF) do
  begin
  if ( (AddressRadioGroup.Itemindex=0)or

  ( (AddressRadioGroup.Itemindex=1)
  and(   (not DbSessionForm.DataTableChild.Value)
      and(not DbSessionForm.DataTableDeceased.Value)
      and(not DbSessionForm.DataTableMarried.Value) ) )

   or(AddressRadioGroup.Itemindex>1)  )then
  begin
  
    LastName := DbSessionForm.DataTableLastName.Value;
    aFirstName := DbSessionForm.DataTableFirstName.Value;
    //Sort by RadioGroup
    If NamebyRG.ItemIndex=0 then
         FirstName :=LastName+ ' ' +aFirstName
       else FirstName := aFirstName + ' ' + LastName;

    Key:= DbSessionForm.DataTableParentLink.AsString;
    If KeyedCB.Checked then FirstName :=Key+FirstName;
    If SentAndReceivedCB.Checked then
    begin
      SandR:='';
      If DBCheckBox7.Checked then
      begin         //Relative
      If DBCheckBox7.Checked then SandR:=SandR+'[X]' else SandR:=SandR+'[ ]';
                    //Married
      If DBCheckBox5.Checked then SandR:=SandR+'[X]' else SandR:=SandR+'[ ]';
                    //Child
      If DBCheckBox6.Checked then SandR:=SandR+'[X]' else SandR:=SandR+'[ ]';
                    //Deceased
      If DBCheckBox2.Checked then SandR:=SandR+'[X]' else SandR:=SandR+'[ ]';

      end else
      begin       //4 send
      If DBCheckBox4.Checked then SandR:='[X]' else SandR:='[ ]';
      If DBCheckBox3.Checked then SandR:=SandR+'[X]' else SandR:=SandR+'[ ]';
      end;
      FirstName :=SandR+FirstName;
    end;

    A := DbSessionForm.AdrTableA.Value;
    Address := DbSessionForm.AdrTableAddress.Value;
    A := A + ' ' + Address;
    City := DbSessionForm.AdrTableCity.Value;
    State := DbSessionForm.AdrTableState.Value;
    Zip := DbSessionForm.AdrTableZip.Value;
    City := City + ' ' + State + ' ' + Zip;
{  ImageInt:=DbSessionForm.AdrTableImageLink.Value;
        DbSessionForm.ImagTable.Filtered := False;
        DbSessionForm.ImagTable.Filter := 'ImageLink='+
                                     Inttostr(ImageInt);
  DbSessionForm.ImagTable.Filtered := True;}
  If
  ((AddressRadioGroup.Itemindex=2) and (not DBCheckBox4.Checked))
   or
  ((AddressRadioGroup.Itemindex=3) and (not DBCheckBox3.Checked))
   or
  ((AddressRadioGroup.Itemindex=4) and (not DBCheckBox7.Checked))
  then begin end else
  begin
    inc(i);
    DbSessionForm.AdrSavedTable.AppendRecord(
           [Inttostr(I),FirstName, A, City,
           DbSessionForm.ImagTableBLOBIMAGE.Value]);
  end;
  end;
    DbSessionForm.DataTable.Next;
  end;
  DbSessionForm.DataTable.Filtered :=False;
  DbSessionForm.ImagTable.Filtered := False;
end;

procedure TDbAdrViewForm.DatabaseDoAll;
var
  i:Integer;
  Key,
  SandR, aFirstName,  LastName, FirstName,
  Family,Parent,Father,Mother,Spouse,
  A, Address, City, State, Zip: string;
begin
  Connect;
  Select;
  {Empty old table data}
  DbSessionForm.AdrSavedAllTable.First;
  while (not DbSessionForm.AdrSavedAllTable.EOF) do
  begin
    DbSessionForm.AdrSavedAllTable.Delete;
  end;
  {Compile data for new Saved Table}
  DbSessionForm.DataTable.First;
  {HoloForm.AdrSavedTable.Active:=True;}
  i:=1;
  while (not DbSessionForm.DataTable.EOF) do
  begin
  if ((AddressRadioGroup.Itemindex=0)or
  ((AddressRadioGroup.Itemindex=1)
  and((not DbSessionForm.DataTableChild.Value)
   and(not DbSessionForm.DataTableDeceased.Value)
   and (not DbSessionForm.DataTableMarried.Value)))or
   (AddressRadioGroup.Itemindex>1)  )then
  begin
    LastName := DbSessionForm.DataTableLastName.Value;
    aFirstName := DbSessionForm.DataTableFirstName.Value;
    Family:= DbSessionForm.DataTableFamilyLink.AsString;
    Parent:= DbSessionForm.DataTableParentLink.AsString;
    Father:= DbSessionForm.DataTableFather.AsString;
    Mother:= DbSessionForm.DataTableMother.AsString;
    Spouse:= DbSessionForm.DataTableSpouse.AsString;
    //Sort by RadioGroup
    If NamebyRG.ItemIndex=0 then
         FirstName :=LastName+ ' ' +aFirstName
       else FirstName := aFirstName + ' ' + LastName;
    Key:= DbSessionForm.DataTableParentLink.AsString;
    If KeyedCB.Checked then FirstName :=Key+FirstName;
    If SentAndReceivedCB.Checked then
    begin
      SandR:='';
      If DBCheckBox7.Checked then
      begin         //Relative
      If DBCheckBox7.Checked then SandR:=SandR+'[X]' else SandR:=SandR+'[ ]';
                    //Married
      If DBCheckBox5.Checked then SandR:=SandR+'[X]' else SandR:=SandR+'[ ]';
                    //Child
      If DBCheckBox6.Checked then SandR:=SandR+'[X]' else SandR:=SandR+'[ ]';
                    //Deceased
      If DBCheckBox2.Checked then SandR:=SandR+'[X]' else SandR:=SandR+'[ ]';

      end else
      begin       //4 send
      If DBCheckBox4.Checked then SandR:='[X]' else SandR:='[ ]';
      If DBCheckBox3.Checked then SandR:=SandR+'[X]' else SandR:=SandR+'[ ]';
      end;
      FirstName :=SandR+FirstName;
    end;

    A := DbSessionForm.AdrTableA.Value;
    Address := DbSessionForm.AdrTableAddress.Value;
    A := A + ' ' + Address;
    City := DbSessionForm.AdrTableCity.Value;
    State := DbSessionForm.AdrTableState.Value;
    Zip := DbSessionForm.AdrTableZip.Value;
    City := City + ' ' + State + ' ' + Zip;
{  ImageInt:=DbSessionForm.AdrTableImageLink.Value;
        DbSessionForm.ImagTable.Filtered := False;
        DbSessionForm.ImagTable.Filter := 'ImageLink='+
                                     Inttostr(ImageInt);
  DbSessionForm.ImagTable.Filtered := True;}
  If
  ((AddressRadioGroup.Itemindex=2) and (not DBCheckBox4.Checked))
   or
  ((AddressRadioGroup.Itemindex=3) and (not DBCheckBox3.Checked))
   or
  ((AddressRadioGroup.Itemindex=4) and (not DBCheckBox7.Checked))
  then begin end else
  begin
    inc(i);
    DbSessionForm.AdrSavedAllTable.AppendRecord(
           [Inttostr(I),FirstName, A, City,
           Family,Parent,Spouse,Father,Mother{,
           DbSessionForm.ImagTableBLOBIMAGE.Value}]);
  end;
  end;
    DbSessionForm.DataTable.Next;
  end;
  DbSessionForm.DataTable.Filtered :=False;
  DbSessionForm.ImagTable.Filtered := False;
end;



procedure TDbAdrViewForm.ImgLabel30BtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  DatabaseDodo;
  If BigLabelsCB.Checked then
  DbBigAdrImgLblForm.DbBigAdrImgLblFrm.QuickRep1.Preview else
  DbAdrImgLblForm.DbAdrImgLblFrm.QuickRep1.Preview;
  DbSessionForm.AdrSavedTable.Active := False;
end;


procedure TDbAdrViewForm.DatabaseDodo;
var
  ImageInt,I:Integer;
  aFirstName,  LastName, FirstName,
  A, Address, City, State, Zip: string;
begin
  {Select current}
  ImageInt := DbSessionForm.DataTableFamilyLink.Value;
  DbSessionForm.DataTable.Filter := 'FamilyLink='+Inttostr(ImageInt);
  DisConnect;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.DataTable.Filtered := True;
  DbSessionForm.ImagTable.Filtered := False;
  Connect;
  {Empty old table data}
  DbSessionForm.AdrSavedTable.First;
  while (not DbSessionForm.AdrSavedTable.EOF) do
  begin
    DbSessionForm.AdrSavedTable.Delete;
  end;
  {Compile data for new Saved Table}
    LastName := DbSessionForm.DataTableLastName.Value;
    aFirstName := DbSessionForm.DataTableFirstName.Value;
    If NamebyRG.ItemIndex=0 then
    FirstName :=LastName+ ' ' +aFirstName
    else FirstName := aFirstName + ' ' + LastName;
    A := DbSessionForm.AdrTableA.Value;
    Address := DbSessionForm.AdrTableAddress.Value;
    A := A + ' ' + Address;
    City := DbSessionForm.AdrTableCity.Value;
    State := DbSessionForm.AdrTableState.Value;
    Zip := DbSessionForm.AdrTableZip.Value;
    City := City + ' ' + State + ' ' + Zip;
{  ImageInt:=DbSessionForm.AdrTableImageLink.Value;
        DbSessionForm.ImagTable.Filtered := False;
        DbSessionForm.ImagTable.Filter := 'ImageLink='+
                                     Inttostr(ImageInt);
  DbSessionForm.ImagTable.Filtered := True;}
    For I:= 0 to 29 do
      DbSessionForm.AdrSavedTable.AppendRecord(
           [Inttostr(I),FirstName, A, City, DbSessionForm.ImagTableBLOBIMAGE.Value]);
    {DbSessionForm.AdrSavedTable.Active:=False;}
    DbSessionForm.DataTable.Filtered :=False;
    DbSessionForm.ImagTable.Filtered := False;
end;

(*
object DataTableLastName: TStringField   FieldName = 'Last Name'
object DataTableFirstName: TStringField   FieldName = 'First Name'
object DataTableFamilyLink: TIntegerField   FieldName = 'FamilyLink'
object DataTableParentLink: TFloatField   FieldName = 'ParentLink'
object DataTableAddLink: TIntegerField   FieldName = 'AddLink'
object DataTableSpouse: TIntegerField   FieldName = 'Spouse'
object DataTableFather: TIntegerField   FieldName = 'Father'
object DataTableMother: TIntegerField   FieldName = 'Mother'
object DataTableRcvd: TBooleanField    FieldName = 'Rcvd'
object DataTableSent: TBooleanField   FieldName = 'Sent'
object DataTableMarried: TBooleanField   FieldName = 'Married'
object DataTableChild: TBooleanField   FieldName = 'Child'
object DataTableDeceased: TBooleanField   FieldName = 'Deceased'
object DataTableMale: TBooleanField     FieldName = 'Male'
object DataTableRelation: TStringField   FieldName = 'Relation'   Size = 10
*)
 {AddLink    I key
A#         A5
Address    A30
City       A20
State      A2
Zip       A10
ImageLink  I  Links Address to an Image
EMail    A30
Phone     A10
Born      A10
Died      A10}
 (*
object AdrTableAddLink: TIntegerField   FieldName = 'AddLink'
object AdrTableA: TStringField   FieldName = 'A#'  Size = 5
object AdrTableAddress: TStringField   FieldName = 'Address'  Size = 30
object AdrTableCity: TStringField   FieldName = 'City'
object AdrTableState: TStringField   FieldName = 'State'   Size = 2
object AdrTableZip: TStringField   FieldName = 'Zip'   Size = 10
object AdrTableImageLink: TIntegerField   FieldName = 'ImageLink'
object AdrTableEMail: TStringField   FieldName = 'EMail'  Size = 30
object AdrTablePhone: TStringField   FieldName = 'Phone'   Size = 10
object AdrTableBorn: TStringField   FieldName = 'Born'   Size = 10
object AdrTableDied: TStringField  FieldName = 'Died'   Size = 10
 *)

(*
 object ImagTableImageLink: TIntegerField   FieldName = 'ImageLink'
object ImagTableName: TStringField   FieldName = 'Name'   Size = 200
object ImagTableType: TStringField    FieldName = 'Type'  Size = 6
object ImagTableDate: TStringField  FieldName = 'Date'  Size = 10
object ImagTableLatY: TFloatField  FieldName = 'LatY'
object ImagTableLonX: TFloatField  FieldName = 'LonX'
object ImagTableDirection: TIntegerField   FieldName = 'Direction'
object ImagTableCommonName: TStringField  FieldName = 'CommonName'  Size = 30
object ImagTableNotes: TMemoField  FieldName = 'Notes'
  BlobType = ftMemo   Size = 10
object ImagTableBLOBIMAGE: TBlobField    FieldName = 'BLOBIMAGE'
  BlobType = ftBlob
*)
(*
 object AdrSavedTableIdiotNumber: TIntegerField  FieldName = 'IdiotNumber'
object AdrSavedTableNameName: TStringField  FieldName = 'NameName' Size = 45
object AdrSavedTableAddress: TStringField  FieldName = 'Address'  Size = 45
object AdrSavedTableCity: TStringField  FieldName = 'City'  Size = 45
object AdrSavedTableImage: TGraphicField  FieldName = 'Image'
    BlobType = ftGraphic
*)
(*
object LinkTableImageLink: TIntegerField  FieldName = 'ImageLink'
object LinkTableFamilyLink: TIntegerField  FieldName = 'FamilyLink'
*)
 (*
object NoteTableFamilyLink: TIntegerField  FieldName = 'FamilyLink'
object NoteTableNotes: TMemoField  FieldName = 'Notes'
  BlobType = ftMemo   Size = 1
 *)

procedure TDbAdrViewForm.AddPersonAndAddressBtnClick(Sender: TObject);
var
  LastNameS, FirstNameS: string;
  LastOneI: Integer;
  ParentLink:Double;
begin
  LastNameS := DbSessionForm.DataTableLastName.Value;
  FirstNameS :='NewName';// DbSessionForm.DataTableFirstName.Value;
  //DataInt := DbSessionForm.AdrTableAddLink.value;
  ParentLink:=DbSessionForm.DataTableParentLink.Value;
  Disconnect;
  DbSessionForm.DataTable.Last;
  LastOneI:=DbSessionForm.DataTableFamilyLink.Value;
  inc(LastOneI);
  DbSessionForm.DataTable.AppendRecord([LastNameS, FirstNameS,
        LastOneI, //FamilyLink
        ParentLink, //ParentLink
        0,//DataInt, //AddLink
        0,0, 0,
        False, False,False,False, False, False, 'No',False]);
  DbSessionForm.AdrTable.Last;
  LastOneI := DbSessionForm.AdrTableAddLink.value;
  inc(LastOneI);
  DbSessionForm.AdrTable.AppendRecord([LastOneI]);
  DbSessionForm.DataTable.Edit;
  DbSessionForm.DataTableAddLink.Value := LastOneI;
  DbSessionForm.DataTable.Post;  
  Disconnect;
  DbSessionForm.DataTable.Refresh;
  Connect;
  DbSessionForm.DataTable.Refresh;
end;

//Add Address to Current Person(Child, etc)
procedure TDbAdrViewForm.AddAddressBtnClick(Sender: TObject);
var
  DataInt,LastOneI: Integer;
begin
  {Select current}
  DataInt := DbSessionForm.DataTableFamilyLink.Value;
  DisConnect;

  DbSessionForm.AdrTable.Last;
  LastOneI := DbSessionForm.AdrTableAddLink.value;
  inc(LastOneI);
  //No other data.. If new, then all must be different
  DbSessionForm.AdrTable.AppendRecord([LastOneI]);
  DbSessionForm.DataTable.Filter := 'FamilyLink='+Inttostr(DataInt);
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.DataTable.Filtered := True;
  DbSessionForm.DataTable.Active := True;
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.DataTable.Edit;
  DbSessionForm.DataTableAddLink.Value := LastOneI;
  DbSessionForm.DataTable.Post;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.DataTable.Filter := '';
  DbSessionForm.DataTable.Filtered := False;
  DbSessionForm.ImagTable.Filtered := False;
  Connect;
  DbSessionForm.DataTable.Refresh;
End;

//Add Person :Same Last Name and Address (Child, Spouse, etc)
procedure TDbAdrViewForm.AddPersonNotAddressBtnClick(Sender: TObject);
var
  LastNameS, FirstNameS: string;
  DataInt,ParentLink,LastOneI: Integer;
begin
  LastNameS := DbSessionForm.DataTableLastName.Value;
  FirstNameS :='NewName';// DbSessionForm.DataTableFirstName.Value;
  DataInt := DbSessionForm.AdrTableAddLink.value;
  ParentLink:=DbSessionForm.DataTableFamilyLink.Value;
  Disconnect;
//  DbSessionForm.DataTable.IndexName := 'FLink';
  DbSessionForm.DataTable.Last;
  LastOneI:=DbSessionForm.DataTableFamilyLink.Value;
  inc(LastOneI);
  DbSessionForm.DataTable.AppendRecord([LastNameS, FirstNameS,
        LastOneI, //FamilyLink
        ParentLink, //ParentLink
        DataInt, //AddLink
        0,0, 0,
        False, False,False,False, False, False, 'No',False]);
  Disconnect;
  DbSessionForm.DataTable.Refresh;
  Connect;
  DbSessionForm.DataTable.Refresh;
end;

procedure TDbAdrViewForm.EmailBtnClick(Sender: TObject);
var Address:String;
begin
  Address := 'mailto:'+DbSessionForm.AdrTableEMail.AsString;
  ShellExecute(0, 'open', PChar(Address), '', '', SW_SHOW);
end;













end.
