unit PicView;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics,
  Controls, Forms, Dialogs,  ExtCtrls, StdCtrls;

type
  TPicViewBitmap = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
procedure DoLoad(const FileName: String);
  private
    { Private declarations }
  public
    { Public declarations }
    X1, Y1 : integer;
    FocusedListBox : TListBox;
  end;

var
  PicViewBitmap: TPicViewBitmap;

implementation

{$R *.DFM}
uses GraphicEx,TongGlobals;


procedure TPicViewBitmap.FormCreate(Sender: TObject);
begin
  top := PicViewBitmapY;
  left := PicViewBitmapX;
end;

procedure TPicViewBitmap.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    PicViewBitmapX := PicViewBitmap.left;
    PicViewBitmapY := PicViewBitmap.top;
(*
  If AlreadyGone then
  begin
{    dir_list.Free;}
    {DoSaver;}
    Application.ProcessMessages;
    Action := caFree;
  end else
  begin
{  FocusedListBox.Clear; }
  Action:=caHide;
  end;*)
end;

procedure TPicViewBitmap.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
(*
  if FocusedListBox = PicMainForm.AlbumBitmaps then
  with PicMainForm, PicMainForm.AlbumBitmaps do
  case key of
  VK_NEXT : begin
              if ItemIndex < Items.Count - 1 then
              begin
                Selected[ItemIndex]:= false;
                Selected[ItemIndex + 1]:= true;
                ItemIndex:= ItemIndex + 1;
                ViewAlbumThumbnailClick(Sender);
                if (not Image1.Picture.Bitmap.Empty) then
                  UpdateAlbumBitmaps
{                else
                  ikClear(AlbumPicBuf.Ctl);}

              end;
              Key:= 0;
              exit;
             end;
  VK_PRIOR: begin
              if ItemIndex > 0 then
              begin
                Selected[ItemIndex]:= false;
                Selected[ItemIndex - 1]:= true;
                ItemIndex:= ItemIndex - 1;
                ViewAlbumThumbnailClick(Sender);
                if (not Image1.Picture.Bitmap.Empty) then
                  UpdateAlbumBitmaps
{                else
                  ikClear(AlbumPicBuf.Ctl);}

              end;
               Key:= 0;
               exit;
             end;
  end;

  if FocusedListBox = PicMainForm.AllBitmaps then
  with PicMainForm, PicMainForm.AllBitmaps do
  case key of
  VK_NEXT : begin
              if ItemIndex < Items.Count - 1 then
              begin
                Selected[ItemIndex]:= false;
                Selected[ItemIndex + 1]:= true;
                ItemIndex:= ItemIndex + 1;
                ViewAllBitmapsThumbnailClick(Sender);
                if (not Image1.Picture.Bitmap.Empty) then
                  UpdateAllBitmaps
{                else
                  ikClear(AllBitmapsPicBuf.Ctl);}

              end;
              Key:= 0;
              exit;
             end;
  VK_PRIOR: begin
              if ItemIndex > 0 then
              begin
                Selected[ItemIndex]:= false;
                Selected[ItemIndex - 1]:= true;
                ItemIndex:= ItemIndex - 1;
                ViewAllBitmapsThumbnailClick(Sender);
{                if ViewPicBuf.Contents > 0 then
                  UpdateAllBitmaps
                else
                  ikClear(AllBitmapsPicBuf.Ctl);}

              end;
               Key:= 0;
               exit;
             end;
  end;
*)
  Close;{any thing else exits procedure
         so this does not get done}
end;

procedure TPicViewBitmap.Image1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Close;
end;

procedure TPicViewBitmap.DoLoad(const FileName: String);
var
  GraphicClass: TGraphicExGraphicClass;
  Graphic: TGraphic;
{  TargetWidth,TargetHeight:Integer; }
begin
  Screen.Cursor := crHourGlass;
  try
    try
      // determine true file type from content rather than extension
      GraphicClass := FileFormatList.GraphicFromContent(FileName);
      if GraphicClass = nil then Image1.Picture.LoadFromFile(FileName)
                            else
      begin
        // GraphicFromContent always returns TGraphicExGraphicClass
        Graphic := GraphicClass.Create;
        Graphic.LoadFromFile(FileName);
        Image1.Picture.Graphic := Graphic;
         { TargetWidth := Image1.Picture.Width;
          TargetHeight := Image1.Picture.Height; }
      end;
         PicViewBitmap.Caption:='View Bitmap'+ 'X wide: '
                                 +Inttostr(Image1.Picture.Width)
                                 +'Y tall: '
                                 +Inttostr(Image1.Picture.Height);
    except
      raise;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;


end.
