unit a_prev;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, ExtCtrls, StdCtrls,
  a_loader, a_layer, ImgList;

type
  TAviFrmPrev = class(TForm)
    _tool_main: TToolBar;
    btn_plus: TToolButton;
    btn_minus: TToolButton;
    btn_exit: TToolButton;
    ImageList1: TImageList;
    sb_prev: TScrollBox;
    Image1: TImage;
    btn_prev: TToolButton;
    btn_next: TToolButton;
    SaveBtn: TToolButton;
    ZoomLabel: TLabel;
    SaveDialog1: TSaveDialog;
    btn_help: TToolButton;
    btn_info: TToolButton;
    procedure btn_plusClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btn_exitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn_prevClick(Sender: TObject);
    procedure btn_nextClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure btn_infoClick(Sender: TObject);
    procedure btn_helpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AviFrmPrev   : TAviFrmPrev;
  ilayer     : TGridLayer;
  counter,
  zoom       : integer;
  bmp        : TBitmap;

implementation

uses TongGlobals, PicAbout;

{$R *.DFM}

procedure TAviFrmPrev.FormCreate(Sender: TObject);
begin
   ilayer := tgridlayer.create(AviFrmPrev);
   ilayer.parent := sb_prev;
   ilayer.left := 1;
   ilayer.top := 1;
   ilayer.width := 50;
   ilayer.height := 50;
   ilayer.borderstyle := bssingle;
   ilayer.gridstyle := gsline;
   ilayer.gridcolor := clbtnshadow;
   ilayer.visible := false;
end;

procedure TAviFrmPrev.FormShow(Sender: TObject);
begin
  top := Avifrm_prevY;
  left := Avifrm_prevX;
   zoom := 1;
   {s_bar.simpletext} ZoomLabel.Caption:= ' Zoom: 100%';
   counter := AviFrmMain.lbAVI.ItemIndex;
   btn_prev.Enabled := (counter > 0);
   btn_next.Enabled := (counter < AviFrmMain.lbAVI.Items.Count - 1);
   if AviFrmMain.lbAVI.ItemIndex <> - 1 then
   begin
     bmp := TBitmap(AviFrmMain.lbAVI.Items.Objects[counter]);
     image1.picture.bitmap := bmp;
     btn_plusclick(btn_minus);
  end else image1.picture.graphic := nil;
end;
procedure TAviFrmPrev.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Avifrm_prevY := AviFrmPrev.top;
  Avifrm_prevX := AviFrmPrev.left;
   ilayer.visible := false;
end;

procedure TAviFrmPrev.FormDestroy(Sender: TObject);
begin
  ilayer.free;
end;

procedure TAviFrmPrev.btn_exitClick(Sender: TObject);
begin
    close;
end;



procedure TAviFrmPrev.btn_infoClick(Sender: TObject);
begin
{  ShowMessage('Aviloader Copyright (c) 1995. - 2000. HydroS Co.'+#13#10+
              'http://hydros.8k.com/'+#13#10+
              'Copyright 2004, Ivan Lee Herring');}
  PicAboutBox.Init(12);
  PicAboutBox.ShowModal;
end;

procedure TAviFrmPrev.btn_helpClick(Sender: TObject);
begin
  Application.HelpContext(13550);
end;

procedure TAviFrmPrev.SaveBtnClick(Sender: TObject);
begin
  If (not image1.picture.bitmap.Empty) then
  begin
{   OPD.InitialDir:=ImagePath;
   OPD.FileName:=TempName;  }
    SaveDialog1.initialdir:=ImagePath;{ ExtractFilePath(Application.EXEName) ;}
    if SaveDialog1.Execute then
    begin
       image1.picture.bitmap.SaveToFile(SaveDialog1.Filename);
    end;
  end;
end;

procedure TAviFrmPrev.btn_plusClick(Sender: TObject);
begin
   if {AviFrmMain.lbAVI.ItemIndex = - 1 }
   AviFrmMain.lbAVI.Items.Count=0
   then exit;
   case (Sender as TToolButton).Tag of
     0 : if zoom < 32 then zoom := zoom + 1;
     1 : if zoom > 1 then zoom := zoom - 1;
   end;
   {s_bar.simpletext} ZoomLabel.Caption
         := ' Zoom: ' + IntToStr((zoom) * 100) + '%';
   image1.top:=0;
   image1.left:=0;
   image1.width := zoom * bmp.width;
   image1.height := zoom * bmp.height;
   if zoom > 2 then
   begin
     ilayer.top := image1.top;
     ilayer.left := image1.left;
     ilayer.width := image1.width;
     ilayer.height := image1.height;
     ilayer.gridstep  := zoom;
     ilayer.grid := true;
     ilayer.visible := true;
     ilayer.refresh;
   end else ilayer.visible := false;
   image1.autosize := false;
   image1.stretch := true;
   image1.refresh;
   image1.sendtoback;
end;



procedure TAviFrmPrev.btn_prevClick(Sender: TObject);
begin
  if counter > 0 then
  begin
     counter := counter - 1;
     bmp := TBitmap(AviFrmMain.lbAVI.Items.Objects[counter]);
     image1.picture.bitmap := bmp;
     btn_plusclick(btn_prev);
     btn_prev.Enabled := (counter > 0);
     btn_next.Enabled := (counter < AviFrmMain.lbAVI.Items.Count - 1);
  end;
end;
procedure TAviFrmPrev.btn_nextClick(Sender: TObject);
begin
  if counter < (AviFrmMain.lbAVI.Items.Count - 1) then
  begin
     counter := counter + 1;
     bmp := TBitmap(AviFrmMain.lbAVI.Items.Objects[counter]);
     image1.picture.bitmap := bmp;
     btn_plusclick(btn_next);
     btn_prev.Enabled := (counter > 0);
     btn_next.Enabled := (counter < AviFrmMain.lbAVI.Items.Count - 1);
  end;
end;







end.
