// efg's Slide Show
// Web Site:  efg's Computer Lab,
//http://homepages.borland.com/efg2lab/
// September 7, 1998

unit efgScreenPrint;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  GraphicEx, Printers, // Printer
  StdCtrls, Spin, Buttons, ComCtrls, ExtCtrls,
  Paper, Preview;

type
  TefgPrintForm = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Panel1: TPanel;
    SpinEditMaxColumns: TSpinEdit;
    LabelColumns1: TLabel;
    SpinEditRowGapPercentage: TSpinEdit;
    Label1: TLabel;
    ImageFontBtn: TSpeedButton;
    ImageNameLabel: TLabel;
    LabelColumns2: TLabel;
    CheckBoxAnnotations: TCheckBox;
    HeaderFontBtn: TSpeedButton;
    EditHeaderLabel: TEdit;
    FooterFontBtn: TSpeedButton;
    EditFooterLabel: TEdit;
    PreviewBtn: TSpeedButton;
    CancelPrintBtn: TSpeedButton;
    TrackBarProgress: TProgressBar;
    InfoBtn: TSpeedButton;
    HelpBtn: TSpeedButton;
    FlashBtn: TButton;
    TrackBar1: TTrackBar;
    PrintListBtn: TSpeedButton;
    FontDialog1: TFontDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelPrintBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure InfoBtnClick(Sender: TObject);
  PROCEDURE PrintBitmap(Canvas:  TCanvas;
                        DestRect:  TRect;
                        Bitmap:  TBitmap);
    procedure FlashBtnClick(Sender: TObject);
FUNCTION LoadGraphicFile(CONST Filename:  STRING):  TBitmap;
procedure DisplayCurrentImage;
    procedure TrackBar1Change(Sender: TObject);
    procedure PreviewBtnClick(Sender: TObject);

    procedure HeaderFontBtnClick(Sender: TObject);
    procedure FooterFontBtnClick(Sender: TObject);
    procedure ImageFontBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure PrintListBtnClick(Sender: TObject);
{procedure CalledFromDb(AnnoText:String);   }
  private
    { Private declarations }
    Procedure Draw;
  public
    { Public declarations }

  end;

var
  efgPrintForm: TefgPrintForm;
  Continue:Boolean;
  Preview1 : TPreview;

implementation

uses TongGlobals, PicAbout;

{$R *.DFM}

procedure TefgPrintForm.FormCreate(Sender: TObject);
begin
  top := efgPrintFormY;
  left := efgPrintFormX;
  Preview1 := TPreview.Create( Self );
{  Preview1.Buttons:=  '[btPrint,btPageSetup,btOpen,btSave,btLanguage]';}
{  Preview1.Buttons.btHelp:=False;
  Preview1.Buttons.btAbout:=False; }
  Preview1.Paper.PrinterSetup.PaperFormat:=pfLETTER;
  Preview1.Paper.PrinterSetup.PaperWidth_MM:=216;
  Preview1.Paper.PrinterSetup.PixelsPerMM_byX:=11.1111111111111;
  Preview1.Paper.PrinterSetup.PaperHeight_MM:=279;
  Preview1.Paper.PrinterSetup.PixelsPerMM_byY:=11.1541218637993;
  Preview1.Paper.Units := unTenthMillimeters;
{  Preview1.Paper.Units := unTenthMillimeters;   }
  Preview1.Paper.Indentions.Bottom:=0;
  Preview1.Paper.Indentions.Top:=0;
  Preview1.Paper.Indentions.Left:=0;
  Preview1.Paper.Indentions.Right:=0;
  Preview1.MaxPage:=100;
end;

procedure TefgPrintForm.FormShow(Sender: TObject);
begin
  efgPrintForm.Caption:= 'Print '
                      +Inttostr(ResultFileList.Count)
                      +' Sliders';
  EditHeaderLabel.Text :=
     ExtractFilePath(ResultFileList.Strings[0]);
  EditFooterLabel.Text := ExtractFileName(ResultFileList.Strings[0])+
     ' of '+Inttostr(ResultFileList.Count);
  TrackBar1.Max:= (ResultFileList.Count-1);
  If (SpinEditMaxColumns.Value>(ResultFileList.Count-1)) then
  SpinEditMaxColumns.Value:=(ResultFileList.Count-1);
end;

procedure TefgPrintForm.FormActivate(Sender: TObject);
begin
{  Draw;}{reads in the Paper variables for any changes}
end;

procedure TefgPrintForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    efgPrintFormX := efgPrintForm.left;
    efgPrintFormY := efgPrintForm.top;
end;

procedure TefgPrintForm.FormDestroy(Sender: TObject);
begin
 Preview1.Free;
end;

procedure TefgPrintForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8000);
end;

procedure TefgPrintForm.InfoBtnClick(Sender: TObject);
begin
  PicAboutBox.Init(5);
  PicAboutBox.ShowModal;
end;

(***********************************************************)
procedure TefgPrintForm.HeaderFontBtnClick(Sender: TObject);
begin
   FontDialog1.Font:=EditHeaderLabel.Font;
  if FontDialog1.Execute then
  begin
    EditHeaderLabel.Font := FontDialog1.Font;
  end;
end;

procedure TefgPrintForm.FooterFontBtnClick(Sender: TObject);
begin
   FontDialog1.Font:=EditFooterLabel.Font;
  if FontDialog1.Execute then
  begin
    EditFooterLabel.Font := FontDialog1.Font;
  end;
end;

procedure TefgPrintForm.ImageFontBtnClick(Sender: TObject);
begin
   FontDialog1.Font:=ImageNameLabel.Font;
  if FontDialog1.Execute then
  begin
    ImageNameLabel.Font := FontDialog1.Font;
  end;
end;
(***********************************************************)
procedure TefgPrintForm.CancelPrintBtnClick(Sender: TObject);
begin
  Continue := False;
  Application.ProcessMessages;
  Application.ProcessMessages;
  Close;
end;

FUNCTION TefgPrintForm.LoadGraphicFile(CONST Filename:  STRING):  TBitmap;
  VAR
    GraphicClass: TGraphicExGraphicClass;
    Graphic: TGraphic;
    Target  :  TBitmap;
begin
    RESULT := nil;
  IF   FileExists(Filename) THEN
  BEGIN
      GraphicClass := FileFormatList.GraphicFromContent(FileName);
      if GraphicClass = nil then Image1.Picture.LoadFromFile(FileName)
                            else
      begin
        // GraphicFromContent always returns TGraphicExGraphicClass
        Graphic := GraphicClass.Create;
        Graphic.LoadFromFile(FileName);
        Image1.Picture.Graphic := Graphic;
      end;
        if (not(Image1.Picture.Graphic is TBitmap)) then
        begin
          Target := TBitmap.Create;
          Target.PixelFormat := pf24Bit;
          Target.Width := Image1.Picture.Width;
          Target.Height := Image1.Picture.Height;
          Target.Canvas.Draw(0, 0, Image1.Picture.Graphic);
          Image1.Picture.Graphic := Target;
          Target.Free;
        end;
        Image1.Picture.Bitmap.PixelFormat := pf24bit;
    RESULT := Image1.Picture.Bitmap;
    RESULT.PixelFormat := pf24Bit;
  END else showmessage(Filename);
end;

procedure TefgPrintForm.DisplayCurrentImage;
begin
  Image1.Picture.Graphic :=
  LoadGraphicFile(ResultFileList.Strings[TrackBar1.Position]);
  ImageNameLabel.Caption:=
    ExtractFileName(ResultFileList.Strings[TrackBar1.Position]);
end;

procedure TefgPrintForm.TrackBar1Change(Sender: TObject);
begin
  If (TrackBar1.Position< (ResultFileList.Count))then
     DisplayCurrentImage;
end;

procedure TefgPrintForm.FlashBtnClick(Sender: TObject);
VAR
    IndexCount     :  INTEGER;
begin
  Continue := True;
  IndexCount:=0;
      WHILE (Continue AND (IndexCount < (ResultFileList.Count))) DO
      BEGIN
        TrackBarProgress.Position := Round(((IndexCount+1)/ResultFileList.Count)*100);
        Image1.Picture.Graphic := LoadGraphicFile(ResultFileList.Strings[IndexCount]);
        Application.ProcessMessages;
        INC (IndexCount);
      END;
  TrackBarProgress.Position :=0;
end;

(***********************************************************)
procedure TefgPrintForm.PreviewBtnClick(Sender: TObject);
begin
  Draw;
  Preview1.Preview;
end;

procedure TefgPrintForm.Draw;
VAR
    Raw, BitmapToPrint :  TBitmap;
    PrintHeaderFlag:  BOOLEAN;
    PaperHeight,  PaperWidth,
    Column         ,
    IndexCount     ,
    iDelta         ,
    iImageWidth    ,
    iFromLeftMargin,
    jFromTopOfPage ,
    jImageHeight   ,
    jDelta         ,
    jLargestThisRow,
    PageCount      :  INTEGER;
{    dXRatio, dYRatio : Double; }
    EditHeaderLabelText,   EditFooterLabelText,
    LessExtension  :  STRING;
    VAR
      PrintedName:  STRING;
PROCEDURE PrintHeaderAndFooter;
BEGIN
    // Header
    Preview1.Paper.SetFont(
    EditHeaderLabel.font.Name,
    EditHeaderLabel.font.Size,
    EditHeaderLabel.font.Style,
    EditHeaderLabel.font.Color);
    PrintedName := EditHeaderLabelText;
    Preview1.Paper.TextOut({iCenterText(PrintedName),}
             Round( ((PaperWidth)
                    - Preview1.Paper.TextWidth(PrintedName)) / 2),
             100{+ (Preview1.Paper.TextHeight(PrintedName))},
             PrintedName);
    jFromTopOfPage:=100+ (Preview1.Paper.TextHeight(PrintedName)*2);

    // Footer
    Preview1.Paper.SetFont(
    EditFooterLabel.font.Name,
    EditFooterLabel.font.Size,
    EditFooterLabel.font.Style,
    EditFooterLabel.font.Color);
    PrintedName :=  FormatDateTime('m/d/yy h:nn', Now) +
               '  ' + EditFooterLabelText+
               ' : Page ' + IntToStr(PageCount);
    Preview1.Paper.TextOut(
             Round( (PaperWidth - Preview1.Paper.TextWidth(PrintedName))
                     / 2),
             (PaperHeight -
             ((Preview1.Paper.TextHeight('X')*2) +100) ),
             PrintedName);
    INC (PageCount);
{912 2970}
    {Prep for bitmaps ?}
    Preview1.Paper.SetFont(
    ImageNameLabel.font.Name,
    ImageNameLabel.font.Size,
    ImageNameLabel.font.Style,
    ImageNameLabel.font.Color);
  END {PrintHeaderAndFooter};

begin {BitBtnOKClick}
  Screen.Cursor := crHourGlass;
  Preview1.Paper.Clear;
  Preview1.Paper.SetPage( 1 );
  Preview1.Paper.SetBrush( exClear, clWhite, clWhite{clBlack}, Nil, 0 );
  PaperWidth:=Round(Preview1.Paper.PrinterSetup.PaperWidth_MM*
                       Preview1.Paper.PrinterSetup.PixelsPerMM_byX );
  PaperHeight:=Round(Preview1.Paper.PrinterSetup.PaperHeight_MM*
                        Preview1.Paper.PrinterSetup.PixelsPerMM_byY );
{  dXRatio:=(Preview1.Paper.PrinterSetup.PixelsPerMM_byX );
  dYRatio:=(Preview1.Paper.PrinterSetup.PixelsPerMM_byY );}
  EditHeaderLabelText :=EditHeaderLabel.Text;
  EditFooterLabelText :=EditFooterLabel.Text;
  TRY                 {poLandscape;}
    TRY
      Column := 0;
      PageCount := 0;
      PrintHeaderFlag := TRUE;
      jLargestThisRow := 0;
      // Cancel button changes Continue to FALSE
      Continue := TRUE;
      IndexCount := 0;                                    {-1 ?}
      WHILE (Continue AND (IndexCount < (ResultFileList.Count))) DO
      BEGIN
        TrackBarProgress.Position := Round(((IndexCount+1)/ResultFileList.Count)*100);
        // Convert all types of images to a bitmap for printing
        Raw:= LoadGraphicFile(ResultFileList.Strings[IndexCount]);
        TRY          // Print the Image
          BitmapToPrint := Raw;
          Try
          IF PrintHeaderFlag THEN
          BEGIN
            IF PageCount > 0 THEN
               Preview1.Paper.SetPage( PageCount+1 );
            PrintHeaderAndFooter;
            PrintHeaderFlag := FALSE
          END;
          // PaperWidth divided by number of images per row  -  ~ Margins
          iDelta := ((PaperWidth-300) DIV (SpinEditMaxColumns.Value+1));
          // Start 10 from left margin + Delta Width * Column Index
          iFromLeftMargin := (100 + (iDelta*Column));
          // 0.5% width between images
          iImageWidth  :=   iDelta-20;
{          ((PaperWidth-200) DIV (SpinEditMaxColumns.Value))-20;}
          jImageHeight :=
                  Round( (iImageWidth/(BitmapToPrint.Width))
                         *(BitmapToPrint.Height));

{Showmessage('PaperWidth '+Inttostr(PaperWidth)+
'iImageWidth '+Inttostr(iImageWidth)+
' jImageHeight '+Inttostr(jImageHeight)+
' iFromLeftMargin '+Inttostr(iFromLeftMargin)+
' jFromTopOfPage '+Inttostr(jFromTopOfPage));}
{2400,380,178}
{jFromTopOfPage:=jFromTopOfPage  ;}
          IF   jImageHeight > jLargestThisRow
              THEN jLargestThisRow := jImageHeight;
{          TargetRectangle := Rect(iFromLeftMargin,
                                  jFromTopOfPage,
                                  iFromLeftMargin + iImageWidth,
                                  jFromTopOfPage  + jImageHeight);}
{      Loc_Rect.Left := Round( Zoom * varStretchDraw.Rect.Left * PixelsPerMM.X * CurrUnits * Scale/100 );
      Loc_Rect.Top := Round( Zoom * varStretchDraw.Rect.Top * PixelsPerMM.Y * CurrUnits * Scale/100 );
      Loc_Rect.Right := Round( Zoom * varStretchDraw.Rect.Right * PixelsPerMM.X * CurrUnits * Scale/100 );
      Loc_Rect.Bottom := Round( Zoom * varStretchDraw.Rect.Bottom * PixelsPerMM.Y * CurrUnits * Scale/100 );}

           Preview1.Paper.StretchDraw(
                             Rect(iFromLeftMargin,
                                  jFromTopOfPage,
                                  iFromLeftMargin + iImageWidth,
                                  jFromTopOfPage  + jImageHeight)
                            , BitmapToPrint);
          // Let's use just the filename with no extension as the printed label
          LessExtension := ExtractFilename(ResultFileList.Strings[IndexCount]);
          LessExtension := COPY(LessExtension, 1, LENGTH(LessExtension)-4);
          IF   efgPrintForm.CheckBoxAnnotations.Checked THEN
                Preview1.Paper.TextOut(iFromLeftMargin,
                       jFromTopOfPage + jImageHeight,
                       LessExtension);
         FINALLY
            {BitmapToPrint.Free}
            END
          FINALLY
          { Raw.Free}
          END;

        INC (Column);
        IF   Column = efgPrintForm.SpinEditMaxColumns.Value
        THEN
        BEGIN
          Column := 0;
          jDelta := MulDiv(jLargestThisRow,
                           100+ efgPrintForm.SpinEditRowGapPercentage.Value,
                           100)
                    +Preview1.Paper.TextHeight('X');
          jFromTopOfPage := jFromTopOfPage + jDelta;
          jLargestThisRow := 0;
          IF  ((jFromTopOfPage + jDelta) > MulDiv((PaperHeight-200), 96,100))
               THEN
               begin
               PrintHeaderFlag := TRUE;
               end;
         END;
        // Recognize the Cancel button click
        Application.ProcessMessages;
        INC (IndexCount);
      END;{Loop}
      FINALLY
       {Printer.EndDoc;}
    END;
    FINALLY
    Screen.Cursor := crDefault;
  END;
  TrackBarProgress.Position :=0;
  Preview1.MaxPage:=PageCount;
END;




  ////////////////////////////////////////////////////////////
procedure TefgPrintForm.PrintListBtnClick(Sender: TObject);
  VAR
    Raw,BitmapToPrint  :  TBitmap;
    Column         :  INTEGER;
    IndexCount     :  INTEGER;
    iDelta         :  INTEGER;
    iImageWidth    :  INTEGER;
    iFromLeftMargin:  INTEGER;
    jFromTopOfPage :  INTEGER;
    jImageHeight   :  INTEGER;
    jDelta         :  INTEGER;
    jLargestThisRow:  INTEGER;
    EditHeaderLabelText,   EditFooterLabelText,
    LessExtension  :  STRING;
    PageCount      :  INTEGER;
    PrintHeaderFlag:  BOOLEAN;
    TargetRectangle:  TRect;

  FUNCTION iCenterText(s:  STRING):  INTEGER;
  BEGIN
    RESULT := (Printer.PageWidth - Printer.Canvas.TextWidth(s)) DIV 2
  END {iCenterText};


  PROCEDURE PrintHeaderAndFooter;
    VAR
      PrintedName:  STRING;
  BEGIN
    // Header
{    Printer.canvas.font.Height := MulDiv(Printer.PageHeight, 3, 100);
    Printer.canvas.font.name := 'Arial';
    Printer.canvas.font.color := clBlack;  }
    Printer.canvas.font:=EditHeaderLabel.font;
    PrintedName := EditHeaderLabelText;
    jFromTopOfPage :=  {2*Printer.canvas.TextHeight(PrintedName);}
                       MulDiv(Printer.PageHeight, 4, 100);
    IF   efgPrintForm.CheckBoxAnnotations.Checked
    THEN {Printer.Canvas.TextOut(iCenterText(PrintedName),
                                jFromTopOfPage,
                                PrintedName); }
    Printer.Canvas.TextOut({iCenterText(PrintedName),}
             Round( ((Printer.PageWidth)
                    - Printer.Canvas.TextWidth(PrintedName)) / 2),
             100{+ (Preview1.Paper.TextHeight(PrintedName))},
             PrintedName);

    // Footer
    Printer.canvas.font:=EditFooterLabel.font;
{    iFromLeftMargin := MulDiv(Printer.PageWidth, 2 + 16*Column, 100);
    Printer.canvas.font.Height := MulDiv(Printer.PageHeight, 15, 1000);
    jFromTopOfPage := Printer.PageHeight - 2*Printer.Canvas.TextHeight('X');}
    PrintedName :=  FormatDateTime('m/d/yy h:nn', Now) +
               '  ' + EditFooterLabelText+
               ' : Page ' + IntToStr(PageCount);
    IF   efgPrintForm.CheckBoxAnnotations.Checked
    THEN {Printer.Canvas.TextOut(iFromLeftMargin, jFromTopOfPage,
               FormatDateTime('m/d/yy h:nn', Now) +
               '  ' + EditFooterLabelText);}
    Printer.Canvas.TextOut(
             Round( (Printer.PageWidth - Printer.Canvas.TextWidth(PrintedName))
                     / 2),
             (Printer.PageHeight -
             ((Printer.Canvas.TextHeight('X')*2)+100) ),
             PrintedName);
    INC (PageCount);
{    iFromLeftMargin := MulDiv(Printer.PageWidth, 8, 100);
    IF   PrintForm.CheckBoxAnnotations.Checked
    THEN Printer.Canvas.TextOut(Printer.PageWidth - Printer.Canvas.TextWidth('Page XXXXXX'),
                                jFromTopOfPage,
                               'Page ' + IntToStr(PageCount));}
    {Prep for bitmaps ?}
     jFromTopOfPage := MulDiv(Printer.PageHeight, 8, 100);
{     Printer.canvas.font.Height := MulDiv(Printer.PageHeight, 1, 100);}
    Printer.canvas.font:=ImageNameLabel.font;
  END {PrintHeaderAndFooter};

begin {BitBtnOKClick}
  Screen.Cursor := crHourGlass;
  EditHeaderLabelText :=EditHeaderLabel.Text;
{  ExtractFilePath(ResultFileList.Strings[0]);}
  EditFooterLabelText :=EditFooterLabel.Text;
{   'of '+Inttostr(ResultFileList.Count);}
{      TrackBarProgress.Enabled  :=False;}
  TRY
   Printer.Orientation :={poLandscape;} poPortrait;
    Printer.BeginDoc;
    TRY
      Column := 0;
      PageCount := 0;
      PrintHeaderFlag := TRUE;
      jLargestThisRow := 0;
      // Cancel button changes Continue to FALSE
      Continue := TRUE;
      IndexCount := 0;                                    {-1 ?}
      WHILE (Continue AND (IndexCount < (ResultFileList.Count))) DO
      BEGIN
        TrackBarProgress.Position := Round(((IndexCount+1)/ResultFileList.Count)*100);
        // Convert all types of images to a bitmap for printing
{        TrackBarProgress.Position := IndexCount;
        DisplayCurrentImage;    }
        Raw:= LoadGraphicFile(ResultFileList.Strings[IndexCount]);
        TRY          // Print the Image
          BitmapToPrint := Raw;
          Try
          IF   PrintHeaderFlag THEN
          BEGIN
            IF   PageCount > 0 THEN Printer.NewPage;
            PrintHeaderAndFooter;
            PrintHeaderFlag := FALSE
          END;
          // 98% divided by number of images per row
          iDelta := 980 DIV efgPrintForm.SpinEditMaxColumns.Value; // 0.1%
          // Start 1% from left margin + Delta Width * Column Index
          iFromLeftMargin := MulDiv(Printer.PageWidth, (10 + iDelta*Column), 1000);
          // 0.5% width between images
          iImageWidth  := MulDiv(Printer.PageWidth, iDelta-5, 1000);
          jImageHeight := MulDiv(iImageWidth, BitmapToPrint.Height, BitmapToPrint.Width);
          IF   (efgPrintForm.SpinEditMaxColumns.Value = 1) AND
                   (jImageHeight > Printer.PageHeight - 2*jFromTopOfPage)
          THEN
          BEGIN
            // Single image per row (i.e., per page) won't fit in landscape
            // orientation, so adjust the size to fit
            jImageHeight := Printer.PageHeight - 2*jFromTopOfPage;
            iImageWidth  := MulDiv(jImageHeight, BitmapToPrint.Width, BitmapToPrint.Height);
            iFromLeftMargin := (Printer.PageWidth - iImageWidth) DIV 2;
          END;
          IF   jImageHeight > jLargestThisRow
              THEN jLargestThisRow := jImageHeight;
          TargetRectangle := Rect(iFromLeftMargin, jFromTopOfPage,
                                  iFromLeftMargin + iImageWidth,
                                  jFromTopOfPage  + jImageHeight);

          PrintBitmap(Printer.Canvas, TargetRectangle, BitmapToPrint);
          // Let's use just the filename with no extension as the printed label
          LessExtension := ExtractFilename(ResultFileList.Strings[IndexCount{TrackBarProgress.Position}]);
          LessExtension := COPY(LessExtension, 1, LENGTH(LessExtension)-4);
          IF   efgPrintForm.CheckBoxAnnotations.Checked
              THEN Printer.Canvas.TextOut(iFromLeftMargin,
                                        jFromTopOfPage + jImageHeight,
                                        LessExtension);
         FINALLY
{              BitmapToPrint.Free}
            END
          FINALLY
{            Raw.Free}
          END;

        INC (Column);
        IF   Column = efgPrintForm.SpinEditMaxColumns.Value
        THEN
        BEGIN
          Column := 0;
          jDelta := MulDiv(jLargestThisRow,
                    100 + efgPrintForm.SpinEditRowGapPercentage.Value, 100);
          jFromTopOfPage := jFromTopOfPage + jDelta;
          jLargestThisRow := 0;
          IF   jFromTopOfPage + jDelta > MulDiv(Printer.PageHeight, 96,100)
               THEN PrintHeaderFlag := TRUE
        END;
        // Recognize the Cancel button click
        Application.ProcessMessages;
        INC (IndexCount);
      END;{Loop}
      FINALLY
      Printer.EndDoc;
    END;
    FINALLY
    Screen.Cursor := crDefault;
  END;
  TrackBarProgress.Enabled  :=True;
  TrackBarProgress.Position :=0;
END;


  // Based on posting to borland.public.delphi.winapi by Rodney E Geraghty,
  // 8/8/97.  Used to print bitmap on any Windows printer.
PROCEDURE TefgPrintForm.PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);
    VAR
      BitmapHeader:  pBitmapInfo;
      BitmapImage :  POINTER;
      HeaderSize  :  DWORD;
      ImageSize   :  DWORD;
  BEGIN
    GetDIBSizes(Bitmap.Handle, HeaderSize, ImageSize);
    GetMem(BitmapHeader, HeaderSize);
    GetMem(BitmapImage,  ImageSize);
    TRY
      GetDIB(Bitmap.Handle, Bitmap.Palette, BitmapHeader^, BitmapImage^);
      StretchDIBits(Canvas.Handle,
                    DestRect.Left, DestRect.Top,     // Destination Origin
                    DestRect.Right  - DestRect.Left, // Destination Width
                    DestRect.Bottom - DestRect.Top,  // Destination Height
                    0, 0,                            // Source Origin
                    Bitmap.Width, Bitmap.Height,     // Source Width & Height
                    BitmapImage,
                    TBitmapInfo(BitmapHeader^),
                    DIB_RGB_COLORS,
                    SRCCOPY)
    FINALLY
      FreeMem(BitmapHeader);
      FreeMem(BitmapImage)
    END
  END {PrintBitmap};



end.
