{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gUHistoCC; {U_TRIP}
{ R | G
  B | RGB
Make a cutter to fit 4 windows into 1 640x480 for Histogram-Density class
?250x200=>500x400
how to MAKE a WINDOW from TRIP?}
{Is a longint > 42,000,000 ... the size of a landsat file of ice?}
{Make R,G,B Toggles under Density Class
If toggled then display only that color class,
 instead of making it do all 3 to classify}
interface

{ Place a USES declaration here }
uses
  Windows, Messages, SysUtils, Classes, Graphics,
  gGlobal, Controls, Forms, Dialogs,
  StdCtrls, WinTypes, Buttons;
{ Place CONST, TYPE, and VAR declarations here }

{ Place PROCEDURE and FUNCTION declarations here }
{  PROCEDURE DO_TheStats(WhichStats:Integer);
    PROCEDURE DoImStats(StatChoice:Integer);}
procedure DoAllStats;
procedure DO_Stats(ChoiceStats: Integer);
procedure Do_Count;
procedure KillZero;
{IF (NOT StatFileExists) Then Do_Countem Else Load_Count;}
procedure GetCountName;
procedure Load_Count;
procedure Save_Count;
procedure Do_Countem;
procedure GetStatsArrayName;
procedure Load_ArrayStats;
procedure Save_ArrayStats;
procedure Do_Stat;
procedure GetStatsTextName;
procedure Load_TextStats;
procedure Save_TextStats;
procedure SortItQuick(Direction: string; Count: Integer; Item: T_Array
  {Var Item : Freq});

implementation

uses gGrip;

{If StatChoice = 1 Then StatsClass := NaturalBreaksClass
If StatChoice = 3 Then StatsClass := StepsClass;
If StatChoice = 4 Then StatsClass := AreaClass;
If StatChoice = 5 Then StatsClass := MeanDeviationClass;
If StatChoice = 6 Then StatsClass := StandardDeviationClass;
If StatChoice = 7 Then StatsClass := ArithmeticClass;
...
If StatChoice = 13 Then StatsClass := GeometricalClass;
...}
{ Place a second USES declaration here }
{uses U__Raster;}
{ Place private LABEL, CONST, TYPE, and VAR declarations here }
(*
{ Place PROCEDURE and FUNCTION bodies here }
PROCEDURE DO_TheStats(WhichStats:Integer);
BEGIN
{IF (Changed =False) then BEGIN}
    MakeImage;
    IF (ImageMade = TRUE) then BEGIN
{    Do_Count;
    DoImStats(WhichStats);      }
    Do_Stats(WhichStats);
    SetImage;
    End;{OF MAKE BITMAP}
{ChangeName('M', 'K');}
{End Else
     Application.MessageBox('This will probably crash... Save image and try again if you have to do it',
      'Raster Density Stats',
      mb_OK);}
END;

{DO ALL 3 (RGB) for Classes}
PROCEDURE DoImStats(StatChoice:Integer);
VAR
{These are Longints to compute with the Counts Longints}
NaturalClass, NaturalCCCClass,BestFitClass,
StepsClass, AreaWorking, AreaClass,
MeanSD, MedianSD,
ArithIC,ArithII,ArithID,ArithDC,ArithDI,ArithDD,
GeomIC,GeomII,GeomID,GeomDC,GeomDI,GeomDD,StatsClass: AllClasses; {Array9L;}
StepRange,R,Log : Array9D;

Doing, HowMany,Classes, Do_Them, I, J, iTemp: Integer; {Counting incrementers}
InWidth,InLength,TotalPixels,LoValue, HiValue,
Sum,Num,Median,Temp,TempNum,TempMedian, Mode, k, kSum,
Steps, Area, A_Step, ActualRange :Longint;
StepValue,A_D,G_D,
Portion, Mean, Log_Diff, XGC, RD, RX, MD, MDS,
MDL, MDH, SD, SDS, SDtemp:Double;
BEGIN { of DoImStats }
Classes:=9;
InWidth := ImageWidth+1;
InLength := ImageHeight+1;
TotalPixels := (InWidth * InLength);
if Toggle_D_R then HowMany := 1 else
if Toggle_D_G then HowMany := 1 else
if Toggle_D_B then HowMany := 1 else
HowMany := 3;
Do_Them:=0;
FOR Doing := 1 to HowMany DO BEGIN {for Red, Green, then Blue pixel stats}
if Toggle_D_R then Do_Them := 1 else
if Toggle_D_G then Do_Them := 2 else
if Toggle_D_B then Do_Them := 3 else
   inc(Do_Them);
If Do_Them = 1 Then For J := 0 to 255 DO CountArray[J]:=CountR[J];
If Do_Them = 2 Then For J := 0 to 255 DO CountArray[J]:=CountG[J];
If Do_Them = 3 Then For J := 0 to 255 DO CountArray[J]:=CountB[J];
{The HiValue and LoValue are the Pixel values stored in the array}
{As this is getting the first value that is Non-zero
they will get the Hi and Lo values of the array}
J := -1;
Repeat Inc(J) Until (CountArray[J] > 0);
LoValue := J;
J := 256;
Repeat Dec(J) Until Countarray[J] > 0;
Hivalue := J;
Sum := 0;
Median := 0;
Num := 0;
Temp := 0;
TempNum :=0;
{ Totals them = total of pixel values}
For J := 0 to 255 DO  Sum := (Sum +  (J * CountArray[J]));
{ this adds them = Number of pixels per bin totaled}
For J := 0 to 255 DO Num := (Num + (CountArray[J]));
IF TotalPixels <> Num then  Do_Error(1227,1229);
TempMedian := ((Num) Div 2);
For J := 0 to 255 DO BEGIN
    TempNum := (TempNum + (CountArray[J]));
    If TempNum <= TempMedian Then Median := J;
    End;

For J := 0 to 255 Do
    BEGIN
    If CountArray[J] > Temp Then
         BEGIN
         Temp := CountArray[J];
         Mode := J;              { this is the MODE NOT the Median }
         END;
    END;
{Total values / total number of pixels}
Mean := (Sum / Num);    { TotalPixels <> Dum }
ActualRange := (1+(HiValue - LoValue));

{Make a CASE of StatChoice so the Stats
 are NOT done for every type JUST the one CALLED}
CASE StatChoice of
1:BEGIN {Computed Natural Breaks}
  For J:= 1 to 9 DO
    Begin
    NaturalClass[J] := Round(J * 25);
    END;
  End;
2:BEGIN {Computed Best Fit}
  BestFitClass[1]:=15;
  For J:= 2 to 8 DO
    Begin
    BestFitClass[J]:= Round(BestFitClass[J-1]+(J *5));
    END;
  BestFitClass[9]:=255;
  End;
3:BEGIN{Steps, equal Value range, equal ranges}
Steps := (ActualRange div Classes);
For J := 1 to 8 DO StepsClass[J] := Round(LoValue + (J * Steps));
StepsClass[9] := 255;
End;

4:
BEGIN{AREA: equal number of pixels per range}
Area := (Sum div Classes);
For J := 1 to 8 do begin AreaWorking[J] := (Area * J); end;
For J := 1 to 8 do BEGIN
    kSum := 0;
    I := 1;
    k := (AreaWorking[J]);
      Repeat
       kSum := (kSum +  ({I *} CountArray[I]));
       Inc(I);
      Until kSum >= k;
    AreaClass[J] := Round(I);
    END;
AreaClass[9] := 255;
End;


5:BEGIN  {MEAN SD}
SDS:=0;
For J:= 0 to 255 DO
    BEGIN
    If CountArray[J] > 0 Then
    SDS:=(SDS + (Countarray[J] * ((SQR((J - Mean))))));
    END;
SDtemp:=(SDS/Num);       { TotalPixels <> Dum }
SD:=(SQRT(SDtemp));
IF ((8*SD) > ActualRange) then
begin portion:= (ActualRange/(8*SD))end else portion:=1;

MeanSD[1] := Round(Mean - (SD * Portion*(4)));
MeanSD[2] := Round(Mean - (SD * Portion*(3)));
MeanSD[3] := Round(Mean - (SD * Portion*(2)));
MeanSD[4] := Round(Mean - (SD * Portion*(1)));
MeanSD[5] := Round(Mean );
MeanSD[6] := Round(Mean + (SD * Portion*(1)));
MeanSD[7] := Round(Mean + (SD * Portion*(2)));
MeanSD[8] := Round(Mean + (SD * Portion*(3)));
MeanSD[9] := 255;
END;

6:BEGIN {MEDIAN SD}
SDS:=0;
For J:= 0 to 255 DO
    BEGIN
    If CountArray[J] > 0 Then
    SDS:=(SDS + (Countarray[J] * ((SQR((J - Mean))))));
    END;
SDtemp:=(SDS/Num);       { TotalPixels <> Dum }
SD:=(SQRT(SDtemp));
IF ((3*SD) > ActualRange) then
begin portion:= (ActualRange/(4*SD))end else portion:=1;

MedianSD[1] := Round(Mean - (SD * Portion*(1.5)));
MedianSD[2] := Round(Mean - (SD * Portion*(1.0)));
MedianSD[3] := Round(Mean - (SD * Portion*(0.6)));
MedianSD[4] := Round(Mean - (SD * Portion*(0.3)));
MedianSD[5] := Round(Mean);
MedianSD[6] := Round(Mean + (SD * Portion*(0.3)));
MedianSD[7] := Round(Mean + (SD * Portion*(0.6)));
MedianSD[8] := Round(Mean + (SD * Portion*(1.0)));
MedianSD[9] := 255;
END;

7:BEGIN {Arithmetic IC}
A_D:=1;
StepValue:=0; StepRange[0] := 0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
For J:= 1 to 9 DO  Begin StepRange[J] := ({LoValue+}((J{-1})*A_D)) End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
ArithIC[0]:=0;
For J:= 1 to 9 DO
    Begin
    ArithIC[J]:= (Round(ArithIC[J-1] +Lovalue+ (StepValue*StepRange[J])));
    End;
END;
8:BEGIN {Arithmetic II}
StepValue:=0; StepRange[0] := 0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
For J:= 1 to 9 DO  Begin A_D:=(J-1); StepRange[J] := ({LoValue+}((J{-1})*A_D)) End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
ArithII[0]:=0;
For J:= 1 to 9 DO
    Begin
    ArithII[J]:= (Round(ArithII[J-1] +Lovalue+ (StepValue*StepRange[J])));
    End;
END;
9:BEGIN {Arithmetic ID}
StepValue:=0; StepRange[0] := 0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
For J:= 1 to 9 DO  Begin A_D:=(1/J); StepRange[J] := ({LoValue+}((J{-1})*A_D)) End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
ArithID[0]:=0;
For J:= 1 to 9 DO
    Begin
    ArithID[J]:= (Round(ArithID[J-1] +Lovalue+ (StepValue*StepRange[J])));
    End;
END;
10:BEGIN {Arithmetic DC}
A_D:=(1);
StepValue:=0; StepRange[0] := 0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
For J:= 1 to 9 DO  Begin  StepRange[J] := ({LoValue+}((J{-1})*A_D)) End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
ArithDC[0]:=0;
For J:= 1 to 9 DO
    Begin
    ArithDC[J]:= (Round(ArithDC[J-1] +Lovalue+ (StepValue*StepRange[J])));
    End;
END;
11:BEGIN {Arithmetic DI}
StepValue:=0; StepRange[0] := 0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
For J:= 1 to 9 DO  Begin A_D:=(J-1); StepRange[J] := ({LoValue+}((J{-1})*A_D)) End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
ArithDI[0]:=0;
For J:= 1 to 9 DO
    Begin
    ArithDI[J]:= (Round(ArithDI[J-1] +(Lovalue + (StepValue*StepRange[J]))));
    End;
END;

12:BEGIN {Arithmetic DD}
StepValue:=0; StepRange[0] := 0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
For J:= 1 to 9 DO  Begin A_D:=-(1/J); StepRange[J] := (1 +((J-1)*A_D)) End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
ArithDD[0]:=0;
For J:= 1 to 9 DO
    Begin
    ArithDD[J]:= (Round(ArithDD[J-1] +(Lovalue + (StepValue*StepRange[J]))));
    End;
END;

13:BEGIN {Geometrical IC}
StepValue:=0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
StepRange[1] := 1;
G_D:=1.0;
For J:= 1 to 9 DO
Begin
A_D:=(2);
StepRange[J] := (1 *(exp((G_D-1)*(ln(A_D)))) );
G_D:=G_D+1.0;
End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
GeomIC[0]:=0;
For J:= 1 to 9 DO
    Begin
    GeomIC[J]:= (Round(GeomIC[J-1] +(Lovalue + (StepValue*StepRange[J]))));
    End;
END;
14:BEGIN {Geometrical II}{POOOR}
StepValue:=0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
StepRange[1] := 1;   G_D:=1.0;
For J:= 1 to 9 DO
Begin
StepRange[J] := (1 *(exp((G_D-1) * (ln(G_D)))) );
G_D:=G_D+1.0;
End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
GeomII[0]:=0;
For J:= 1 to 9 DO
    Begin
    GeomII[J]:= (Round(GeomII[J-1] +(Lovalue + (StepValue*StepRange[J]))));
    End;
END;
15:BEGIN {Geometrical ID}
StepValue:=0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
StepRange[1] := 1;
G_D:=2.0;
For J:= 2 to 9 DO
Begin
A_D:=(G_D/(G_D -1.0));
StepRange[J] := (1 *(exp((G_D-1)*(ln(A_D)))) );
G_D:=G_D+1.0;
End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
GeomID[0]:=0;
For J:= 1 to 9 DO
    Begin
    GeomID[J]:= (Round(GeomID[J-1] +(Lovalue + (StepValue*StepRange[J]))));
    End;
END;
16:BEGIN {Geometrical DC}
StepValue:=0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
StepRange[1] := 1;
G_D:=2.0;
For J:= 2 to 9 DO
Begin
A_D:=(0.5);
StepRange[J] := (1 *(exp((G_D-1)*(ln(A_D)))) );
G_D:=(G_D+1.0);
End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
GeomDC[0]:=0;
For J:= 1 to 9 DO
    Begin
    GeomDC[J]:= (Round(GeomDC[J-1] +(Lovalue + (StepValue*StepRange[J]))));
    End;
END;
17:BEGIN {Geometrical DI}
StepValue:=0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
StepRange[1] := 1;
G_D:=2.0;
For J:= 2 to 9 DO
Begin
A_D:=(1/G_D);
StepRange[J] := (1 *(exp((G_D-1)*(ln(A_D)))) ) ;
G_D:=G_D+1.0;
End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
GeomDI[0]:=0;
For J:= 1 to 9 DO
    Begin
    GeomDI[J]:= (Round(GeomDI[J-1] +(Lovalue + (StepValue*StepRange[J]))));
    End;
END;
18:BEGIN {Geometrical DD}
StepValue:=0;
For J:= 1 to 9 DO  Begin StepRange[J] := 0; End;
StepRange[1] := 1;
G_D:=2.0;
For J:= 2 to 9 DO
Begin
A_D:=((G_D-1)/G_D);
StepRange[J] := (1 *(exp((G_D-1)*(ln(A_D)))) );
G_D:=G_D+1.0;
End;
For J:= 1 to 9 DO  Begin StepValue := (StepValue + StepRange[J]) End;
StepValue := (ActualRange / StepValue);
GeomDD[0]:=0;
For J:= 1 to 9 DO
    Begin
    GeomDD[J]:= (Round(GeomDD[J-1] +(Lovalue + (StepValue*StepRange[J]))));
    End;
END;


END; {of CASE do stats}
{
If StatChoice = 1 Then StatsClass := StepsClass;
If StatChoice = 2 Then StatsClass := AreaClass;
If StatChoice = 3 Then StatsClass := ArithmeticClass;
If StatChoice = 4 Then StatsClass := GeometricalClass;
If StatChoice = 5 Then StatsClass := ReciprocalClass;
If StatChoice = 6 Then StatsClass := MeanRangeClass;
If StatChoice = 7 Then StatsClass := MeanDeviationClass;
If StatChoice = 8 Then StatsClass := StandardDeviationClass;
}
Case StatChoice of
1: begin   For J := 1 to 9 DO StatsClass[J] :=NaturalClass[J]End;
2: begin   For J := 1 to 9 DO StatsClass[J] :=BestFitClass[J]End;
3: begin   For J := 1 to 9 DO StatsClass[J] :=StepsClass[J]End;
4: begin   For J := 1 to 9 DO StatsClass[J] :=AreaClass[J]End;
5: begin   For J := 1 to 9 DO StatsClass[J] :=MeanSD[J]End;
6: begin   For J := 1 to 9 DO StatsClass[J] :=MedianSD[J]End;
7: begin   For J := 1 to 9 DO StatsClass[J] :=ArithIC[J]End;
8: begin   For J := 1 to 9 DO StatsClass[J] :=ArithII[J]End;
9: begin   For J := 1 to 9 DO StatsClass[J] :=ArithID[J]End;
10: begin   For J := 1 to 9 DO StatsClass[J] :=ArithDC[J]End;
11: begin   For J := 1 to 9 DO StatsClass[J] :=ArithDI[J]End;
12: begin   For J := 1 to 9 DO StatsClass[J] :=ArithDD[J]End;
13: begin   For J := 1 to 9 DO StatsClass[J] :=GeomIC[J]End;
14: begin   For J := 1 to 9 DO StatsClass[J] :=GeomII[J]End;
15: begin   For J := 1 to 9 DO StatsClass[J] :=GeomID[J]End;
16: begin   For J := 1 to 9 DO StatsClass[J] :=GeomDC[J]End;
17: begin   For J := 1 to 9 DO StatsClass[J] :=GeomDI[J]End;
18: begin   For J := 1 to 9 DO StatsClass[J] :=GeomDD[J]End;
 End; {of Case}
If Do_Them = 1 Then {ClassesR:=StatsClass;}
begin   For J := 1 to 9 DO Begin
        iTemp := StatsClass[J];
        If iTemp > 255 then iTemp := 255;
        If iTemp < 0 then iTemp := 0;
        ClassesR[J]:= iTemp end;
End;
If Do_Them = 2 Then {ClassesG:=StatsClass;}
begin   For J := 1 to 9 DO Begin
        iTemp := StatsClass[J];
        If iTemp > 255 then iTemp := 255;
        If iTemp < 0 then iTemp := 0;
        ClassesG[J]:= iTemp end;
End;
If Do_Them = 3 Then {ClassesB:=StatsClass;}
begin    For J := 1 to 9 DO Begin
        iTemp := StatsClass[J];
        If iTemp > 255 then iTemp := 255;
        If iTemp < 0 then iTemp := 0;
        ClassesB[J]:= iTemp end;
End;
End; {of Do_Them}
END; { of PROCEDURE DoImStats }
{DO ALL 3 (RGB) for Classes}
*)
{ORIGINAL...
If StatChoice = 1 Then StatsClass := StepsClass;
If StatChoice = 2 Then StatsClass := AreaClass;
If StatChoice = 3 Then StatsClass := ArithmeticClass;
If StatChoice = 4 Then StatsClass := GeometricalClass;
If StatChoice = 5 Then StatsClass := ReciprocalClass;
If StatChoice = 6 Then StatsClass := MeanRangeClass;
If StatChoice = 7 Then StatsClass := MeanDeviationClass;
If StatChoice = 8 Then StatsClass := StandardDeviationClass;}

procedure DoAllStats;
type
  Array256d = array[0..255] of Double;
var
  SlopeArray: Array256d;
  SlopeValleyCount, SlopeValley: array[0..255] of Integer;

{These are Longints to compute with the Counts Longints}
  WorkingStat: StatClasses;
  AreaWorking: Array9L;
  NaturalClass, NaturalCCCClass, BestFitClass,
    StepsClass, AreaClass,
    MeanSD, MedianSD,
    ArithIC, ArithII, ArithID, ArithDC, ArithDI, ArithDD,
    GeomIC, GeomII, GeomID, GeomDC, GeomDI, GeomDD, StatsClass:
  AllClasses; {Array9L;}
  StepRange, R, Log: Array9D;
  ValleyCount, TooManyCounts, Smoother,
    Doing, HowMany, Classes, Do_Them, I, J, iTemp: Integer;
      {Counting incrementers}
  InWidth, InLength, TotalPixels,
    LoValue, HiValue, Sum, Num, Median, Mode,
    Temp, TempNum, TempMedian, k, kSum,
    TempValue, Steps, Area, A_Step, ActualRange: Longint;
  Mean, SD,
    StepValue, A_D, G_D, X,
    Portion, Log_Diff, XGC, RD, RX, MD, MDS,
    MDL, MDH, SDtemp: Double; SDS: Extended;
begin { of DoImStats }
  Classes := 9;
  InWidth := ImageWidth + 1;
  InLength := ImageHeight + 1;
  TotalPixels := (InWidth * InLength);
{The HiValue and LoValue are the Pixel values stored in the array}
{As this is getting the first value that is Non-zero
they will get the Hi and Lo values of the array}
  J := -1; repeat Inc(J)until (CountR[J] > 0); RedMin := J;
  J := -1; repeat Inc(J)until (CountG[J] > 0); GreenMin := J;
  J := -1; repeat Inc(J)until (CountB[J] > 0); BlueMin := J;
  J := 256; repeat Dec(J)until CountR[J] > 0; RedMax := J;
  J := 256; repeat Dec(J)until CountG[J] > 0; GreenMax := J;
  J := 256; repeat Dec(J)until CountB[J] > 0; BlueMax := J;
{ Totals them = total of pixel values}
{Longint= 2147483647 /256=8388607 sgrt=2896}
  RSum := 0; for J := 0 to 255 do RSum := (RSum + (J * CountR[J]));
  GSum := 0; for J := 0 to 255 do GSum := (GSum + (J * CountG[J]));
  BSum := 0; for J := 0 to 255 do BSum := (BSum + (J * CountB[J]));
{RED: this adds them = Number of pixels per bin totaled}
  RNum := 0; RedMedian := 0; Temp := 0; TempNum := 0;
  for J := 0 to 255 do RNum := (RNum + (CountR[J]));
  if TotalPixels <> RNum then DoMessages(39981);
  TempMedian := ((RNum) div 2);
  for J := 0 to 255 do begin TempNum := (TempNum + (CountR[J]));
    if TempNum <= TempMedian then RedMedian := J; end;
  for J := 0 to 255 do begin { this is the MODE NOT the Median }
    if CountR[J] > Temp then
    begin Temp := CountR[J]; RedMode := J; end; end;
{Total values / total number of pixels}{ TotalPixels <> Dum }
  RedMean := Round(RSum / RNum); RedRange := (1 + (RedMax - RedMin));
{GREEN: this adds them = Number of pixels per bin totaled}
  GNum := 0; GreenMedian := 0; Temp := 0; TempNum := 0;
  for J := 0 to 255 do GNum := (GNum + (CountG[J]));
  if TotalPixels <> GNum then DoMessages(39981);
  TempMedian := ((GNum) div 2);
  for J := 0 to 255 do begin TempNum := (TempNum + (CountG[J]));
    if TempNum <= TempMedian then GreenMedian := J; end;
  for J := 0 to 255 do begin { this is the MODE NOT the Median }
    if CountG[J] > Temp then
    begin Temp := CountG[J]; GreenMode := J; end; end;
{Total values / total number of pixels}{ TotalPixels <> Dum }
  GreenMean := Round(GSum / GNum); GreenRange := (1 + (GreenMax -
    GreenMin));
{BLUE: this adds them = Number of pixels per bin totaled}
  BNum := 0; BlueMedian := 0; Temp := 0; TempNum := 0;
  for J := 0 to 255 do BNum := (BNum + (CountB[J]));
  if TotalPixels <> BNum then DoMessages(39981);
  TempMedian := ((BNum) div 2);
  for J := 0 to 255 do begin TempNum := (TempNum + (CountB[J]));
    if TempNum <= TempMedian then BlueMedian := J; end;
  for J := 0 to 255 do begin { this is the MODE NOT the Median }
    if CountB[J] > Temp then
    begin Temp := CountB[J]; BlueMode := J; end; end;
{Total values / total number of pixels}{ TotalPixels <> Dum }
  BlueMean := Round(BSum / BNum); BlueRange := (1 + (BlueMax -
    BlueMin));

{ Natural Breaks}
  TooManyCounts := 0; {Smoother:=5;}
  for J := 1 to 9 do RedStats[0, J] := 255;
  ValleyCount := 1;
  for J := 0 to 255 do begin
    SlopeArray[j] := 0;
    SlopeValley[j] := 0;
    SlopeValleyCount[j] := 0;
  end;
  TooManyCounts := TooManyCounts + CountR[0];
  TooManyCounts := TooManyCounts + CountR[1];
  TooManyCounts := TooManyCounts + CountR[2];
  for J := 3 to 253 do begin
    SlopeArray[j] := (((1 + (CountR[J - 2]) + (CountR[J - 1])
      + (CountR[J]) + (CountR[J + 1]) + (CountR[J + 2]))
      / 5)
      -
      ((1 + (CountR[J - 2]) + (CountR[J - 1])
      + (CountR[J]) + (CountR[J + 1]) + (CountR[J - 3]))
      / 5));
    TooManyCounts := TooManyCounts + CountR[J];
    if ((SlopeArray[j - 1] < 0) and (SlopeArray[j] > 0)) then begin
      if (ValleyCount < 9) then RedStats[0, ValleyCount] := J;
      SlopeValley[j] := TooManyCounts;
      TooManyCounts := 0;
      inc(ValleyCount);
    end;
  end;
  if (ValleyCount > 8) then begin
{Scrunch some classes together}
  end;

  for J := 1 to 9 do GreenStats[0, J] := 255;
  ValleyCount := 1;
  for J := 0 to 255 do
  begin SlopeArray[j] := 0; SlopeValley[j] := 0; end;
  for J := 3 to 253 do begin
    SlopeArray[j] := (((1 + (CountG[J - 2]) + (CountG[J - 1])
      + (CountG[J]) + (CountG[J + 1]) + (CountG[J + 2]))
      / 5)
      -
      ((1 + (CountG[J - 2]) + (CountG[J - 1])
      + (CountG[J]) + (CountG[J + 1]) + (CountG[J - 3]))
      / 5));
    if ((SlopeArray[j - 1] < 0) and (SlopeArray[j] > 0)) then begin
      if (ValleyCount < 9) then GreenStats[0, ValleyCount] := J;
      SlopeValley[j] := 1;
      inc(ValleyCount);
    end;
  end;


  for J := 1 to 9 do BlueStats[0, J] := 255;
  ValleyCount := 1;
  for J := 0 to 255 do
  begin SlopeArray[j] := 0; SlopeValley[j] := 0; end;
  for J := 3 to 253 do begin
    SlopeArray[j] := (((1 + (CountB[J - 2]) + (CountB[J - 1])
      + (CountB[J]) + (CountB[J + 1]) + (CountB[J + 2]))
      / 5)
      -
      ((1 + (CountB[J - 2]) + (CountB[J - 1])
      + (CountB[J]) + (CountB[J + 1]) + (CountB[J - 3]))
      / 5));
    if ((SlopeArray[j - 1] < 0) and (SlopeArray[j] > 0)) then begin
      if (ValleyCount < 9) then BlueStats[0, ValleyCount] := J;
      SlopeValley[j] := 1;
      inc(ValleyCount);
    end;
  end;

{  For J:= 1 to 8 DO RedStats[0,J] := Round(J * 25);RedStats[0,9] := 255;
  For J:= 1 to 8 DO GreenStats[0,J] := Round(J * 25);GreenStats[0,9] := 255;
  For J:= 1 to 8 DO BlueStats[0,J] := Round(J * 25);BlueStats[0,9] := 255;}

 {Computed Best Fit} RedStats[1, 1] := 15;
  for J := 2 to 8 do
    RedStats[1, J] := Round((RedStats[1, (J - 1)]) + (J * 5));
  RedStats[1, 9] := 255;
 {Computed Best Fit} GreenStats[1, 1] := 15;
  for J := 2 to 8 do
    GreenStats[1, J] := Round((GreenStats[1, (J - 1)]) + (J * 5));
  GreenStats[1, 9] := 255;
 {Computed Best Fit} BlueStats[1, 1] := 15;
  for J := 2 to 8 do
    BlueStats[1, J] := Round((BlueStats[1, (J - 1)]) + (J * 5));
  BlueStats[1, 9] := 255;


{Steps, equal Value range, equal ranges}
  Steps := (RedRange div Classes);
  for J := 1 to 8 do RedStats[2, J] := Round(RedMin + (J * Steps));
  RedStats[2, 9] := 255;
  Steps := (GreenRange div Classes);
  for J := 1 to 8 do
    GreenStats[2, J] := Round(GreenMin + (J * Steps));
  GreenStats[2, 9] := 255;
  Steps := (BlueRange div Classes);
  for J := 1 to 8 do BlueStats[2, J] := Round(BlueMin + (J * Steps));
  BlueStats[2, 9] := 255;

{AREA: equal number of pixels per range}
  Area := (RNum div Classes);
{For J := 1 to 8 do begin AreaWorking[J] := (Area * J); end;}
  I := 1; k := Area; { (Area * J);}
  for J := 1 to 8 do begin
    kSum := 0;
    repeat kSum := (kSum + (CountR[I])); Inc(I); until kSum >= k;
    Dec(I); RedStats[3, J] := I; {CountR[I];} { Round(I)};
  end; RedStats[3, 9] := 255;
{AREA: equal number of pixels per range}
  Area := (GNum div Classes);
{For J := 1 to 8 do begin GreenStats[4,J] := (Area * J); end; }
  I := 1; k := Area; {(Area * J);}
  for J := 1 to 8 do begin
    kSum := 0;
    repeat kSum := (kSum + (CountG[I])); Inc(I); until kSum >= k;
    Dec(I); GreenStats[3, J] := I; {CountG[I]; }
  end; GreenStats[3, 9] := 255;
{AREA: equal number of pixels per range}
  Area := (BNum div Classes);
{For J := 1 to 8 do begin BlueStats[4,J] := (Area * J); end; }
  I := 1; k := Area; {(Area * J);}
  for J := 1 to 8 do begin
    kSum := 0; {(BlueStats[4,J]);}
    repeat kSum := (kSum + (CountB[I])); Inc(I); until kSum >= k;
    Dec(I); BlueStats[3, J] := I; {CountB[I];}
  end; BlueStats[3, 9] := 255;


   {MEDIAN SD}{ TotalPixels <> Dum }
  SDS := 0; for J := 0 to 255 do begin if CountR[J] > 0 then
      SDS := (SDS + (CountR[J] * ((SQR((J - RedMean)))))); end;
  RedVariance := (SDS / (RNum - 1)); RedSD := (SQRT(RedVariance));
  if ((8 * RedSD) > RedRange) then
  begin portion := (RedRange / (8 * RedSD)) end else portion := 1;
  TempValue := Round(RedMedian - (RedSD * Portion * (3)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  RedStats[4, 1] := TempValue;
  TempValue := Round(RedMedian - (RedSD * Portion * (2.5)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  RedStats[4, 2] := TempValue;
  RedStats[4, 3] := Round(RedMedian - (RedSD * Portion * (2)));
  RedStats[4, 4] := Round(RedMedian - (RedSD * Portion * (1)));
  RedStats[4, 5] := Round(RedMedian);
  RedStats[4, 6] := Round(RedMedian + (RedSD * Portion * (1)));
  RedStats[4, 7] := Round(RedMedian + (RedSD * Portion * (2)));
  TempValue := Round(RedMedian + (RedSD * Portion * (3)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  RedStats[4, 8] := TempValue;
  RedStats[4, 9] := 255;
   {MEAN SD}{ TotalPixels <> Dum }
  SDS := 0; for J := 0 to 255 do begin if CountG[J] > 0 then
      SDS := (SDS + (CountG[J] * ((SQR((J - GreenMean)))))); end;
  GreenVariance := (SDS / (GNum - 1)); GreenSD :=
  (SQRT(GreenVariance));
  if ((8 * GreenSD) > GreenRange) then
  begin portion := (GreenRange / (8 * GreenSD)) end else
    portion := 1;
  TempValue := Round(GreenMedian - (GreenSD * Portion * (3)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  GreenStats[4, 1] := TempValue;
  TempValue := Round(GreenMedian - (GreenSD * Portion * (2.5)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  GreenStats[4, 2] := TempValue;
  GreenStats[4, 3] := Round(GreenMedian - (GreenSD * Portion * (2)));
  GreenStats[4, 4] := Round(GreenMedian - (GreenSD * Portion * (1)));
  GreenStats[4, 5] := Round(GreenMedian);
  GreenStats[4, 6] := Round(GreenMedian + (GreenSD * Portion * (1)));
  GreenStats[4, 7] := Round(GreenMedian + (GreenSD * Portion * (2)));
  TempValue := Round(GreenMedian + (GreenSD * Portion * (3)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  GreenStats[4, 8] := TempValue;
  GreenStats[4, 9] := 255;
   {MEAN SD}{ TotalPixels <> Dum }
  SDS := 0; for J := 0 to 255 do begin if CountB[J] > 0 then
      SDS := (SDS + (CountB[J] * ((SQR((J - BlueMean)))))); end;
  BlueVariance := (SDS / (BNum - 1)); BlueSD := (SQRT(BlueVariance));
  if ((8 * BlueSD) > BlueRange) then
  begin portion := (BlueRange / (8 * BlueSD)) end else portion := 1;
  TempValue := Round(BlueMedian - (BlueSD * Portion * (3)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  BlueStats[4, 1] := TempValue;
  TempValue := Round(BlueMedian - (BlueSD * Portion * (2.5)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  BlueStats[4, 2] := TempValue;
  BlueStats[4, 3] := Round(BlueMedian - (BlueSD * Portion * (2)));
  BlueStats[4, 4] := Round(BlueMedian - (BlueSD * Portion * (1)));
  BlueStats[4, 5] := Round(BlueMedian);
  BlueStats[4, 6] := Round(BlueMedian + (BlueSD * Portion * (1)));
  BlueStats[4, 7] := Round(BlueMedian + (BlueSD * Portion * (2)));
  TempValue := Round(BlueMedian + (BlueSD * Portion * (3)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  BlueStats[4, 8] := TempValue;
  BlueStats[4, 9] := 255;

    {MEAN SD}{ TotalPixels <> Dum }
  TempValue := Round(RedMean - (RedSD));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  RedStats[5, 1] := TempValue;
  TempValue := Round(RedMean - (RedSD * (0.8)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  RedStats[5, 2] := TempValue;
  RedStats[5, 3] := Round(RedMean - (RedSD * (0.6)));
  RedStats[5, 4] := Round(RedMean - (RedSD * (0.3)));
  RedStats[5, 5] := Round(RedMean);
  RedStats[5, 6] := Round(RedMean + (RedSD * (0.3)));
  RedStats[5, 7] := Round(RedMean + (RedSD * (0.6)));
  TempValue := Round(RedMean + (RedSD * (0.8)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  RedStats[5, 8] := TempValue;
  RedStats[5, 9] := 255;

  TempValue := Round(GreenMean - (GreenSD));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  GreenStats[5, 1] := TempValue;
  TempValue := Round(GreenMean - (GreenSD * (0.8)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  GreenStats[5, 2] := TempValue;
  GreenStats[5, 3] := Round(GreenMean - (GreenSD * (0.6)));
  GreenStats[5, 4] := Round(GreenMean - (GreenSD * (0.3)));
  GreenStats[5, 5] := Round(GreenMean);
  GreenStats[5, 6] := Round(GreenMean + (GreenSD * (0.3)));
  GreenStats[5, 7] := Round(GreenMean + (GreenSD * (0.6)));
  TempValue := Round(GreenMean + (GreenSD * (0.8)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  GreenStats[5, 8] := TempValue;
  GreenStats[5, 9] := 255;

  TempValue := Round(BlueMean - (BlueSD));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  BlueStats[5, 1] := TempValue;
  TempValue := Round(BlueMean - (BlueSD * (0.8)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  BlueStats[5, 2] := TempValue;
  BlueStats[5, 3] := Round(BlueMean - (BlueSD * (0.6)));
  BlueStats[5, 4] := Round(BlueMean - (BlueSD * (0.3)));
  BlueStats[5, 5] := Round(BlueMean);
  BlueStats[5, 6] := Round(BlueMean + (BlueSD * (0.3)));
  BlueStats[5, 7] := Round(BlueMean + (BlueSD * (0.6)));
  TempValue := Round(BlueMean + (BlueSD * (0.8)));
  if TempValue < 0 then TempValue := 0
  else if TempValue > 255 then TempValue := 255;
  BlueStats[5, 8] := TempValue;
  BlueStats[5, 9] := 255;

{Arithmetic IC}
  StepValue := 36; A_D := ((RedMax - RedMin) / StepValue);
  StepRange[0] := 0;
  StepRange[1] := (RedMin + A_D);
  for J := 2 to 9 do begin StepRange[J] := (((J) * A_D)) end;
  RedStats[6, 0] := 0;
  for J := 1 to 9 do begin {*}
    TempValue := (Round(RedStats[6, J - 1] + (J + StepRange[J])));
    if TempValue < 0 then TempValue := 0
    else if TempValue > 255 then TempValue := 255;
    RedStats[6, J] := TempValue;
  end;
  StepValue := 36; A_D := ((GreenMax - GreenMin) / StepValue);
  StepRange[0] := 0;
  StepRange[1] := (GreenMin + A_D);
  for J := 2 to 9 do begin StepRange[J] := (((J) * A_D)) end;
  GreenStats[6, 0] := 0;
  for J := 1 to 9 do begin
    TempValue := (Round(GreenStats[6, J - 1] + (J + StepRange[J])));
    if TempValue < 0 then TempValue := 0
    else if TempValue > 255 then TempValue := 255;
    GreenStats[6, J] := TempValue;
  end;
  StepValue := 36; A_D := ((BlueMax - BlueMin) / StepValue);
  StepRange[0] := 0;
  StepRange[1] := (BlueMin + A_D);
  for J := 2 to 9 do begin StepRange[J] := (((J) * A_D)) end;
  BlueStats[6, 0] := 0;
  for J := 1 to 9 do begin
    TempValue := (Round(BlueStats[6, J - 1] + (J + StepRange[J])));
    if TempValue < 0 then TempValue := 0
    else if TempValue > 255 then TempValue := 255;
    BlueStats[6, J] := TempValue;
  end;

(*
{Geometrical IC}
Log_Diff:=(ln(RedMax)-ln(RedMin));
X:=(Log_Diff / Classes);
Log[1]:=(ln(RedMax)-X);
For J:= 2 to 9 DO Begin Log[J]:=(Log[J-1]-X); End;
I:=8;For J:= 1 to 8 DO Begin TempValue:=Round(Exp(Log[I]));Dec(I);
If TempValue < 0 then TempValue := 0
else if TempValue > 255 then TempValue := 255;
RedStats[7,J]:= TempValue;
end;RedStats[7,9]:= 255;

Log_Diff:=(ln(GreenMax)-ln(GreenMin));
X:=(Log_Diff / Classes);
Log[1]:=(ln(GreenMax)-X);
For J:= 2 to 9 DO Begin Log[J]:=(Log[J-1]-X); End;
I:=8;For J:= 1 to 8 DO Begin TempValue:=Round(Exp(Log[I]));Dec(I);
If TempValue < 0 then TempValue := 0
else if TempValue > 255 then TempValue := 255;
GreenStats[7,J]:= TempValue;
end;GreenStats[7,9]:= 255;

Log_Diff:=(ln(BlueMax)-ln(BlueMin));
X:=(Log_Diff / Classes);
Log[1]:=(ln(BlueMax)-X);
For J:= 2 to 9 DO Begin Log[J]:=(Log[J-1]-X); End;
I:=8;For J:= 1 to 8 DO Begin TempValue:=Round(Exp(Log[I]));Dec(I);
If TempValue < 0 then TempValue := 0
else if TempValue > 255 then TempValue := 255;
BlueStats[7,J]:= TempValue;
end;BlueStats[7,9]:= 255;
*)
(*
{RECIPROCAL }
RD:= ((1/(GreenMin+0.000001)) - (1/GreenMax));
RX:= (RD / Classes);
     R[1]:=((1 / (GreenMin+0.000001))-RX);     R[2]:=(R[1]-RX);
     R[3]:=(R[2]-RX);      R[4]:=(R[3]-RX);
     R[5]:=(R[4]-RX);      R[6]:=(R[5]-RX);
     R[7]:=(R[6]-RX);      R[8]:=(R[7]-RX);
For J:= 1 to 9 DO    Begin
    TempValue:= Round(1/R[J]);
If TempValue < 0 then TempValue := 0
else if TempValue > 255 then TempValue := 255;
 GreenStats[8,J]:= TempValue;
End;
{RECIPROCAL }
RD:= ((1/(RedMin+0.000001)) - (1/RedMax));
RX:= (RD / Classes);
     R[1]:=((1/(RedMin+0.000001))-RX);     R[2]:=(R[1]-RX);
     R[3]:=(R[2]-RX);      R[4]:=(R[3]-RX);
     R[5]:=(R[4]-RX);      R[6]:=(R[5]-RX);
     R[7]:=(R[6]-RX);      R[8]:=(R[7]-RX);
For J:= 1 to 9 DO    Begin
    TempValue:= Round(1/R[J]);
If TempValue < 0 then TempValue := 0
else if TempValue > 255 then TempValue := 255;
 RedStats[8,J]:= TempValue;
End;
{RECIPROCAL }
RD:= ((1/(BlueMin+0.000001)) - (1/BlueMax));
RX:= (RD / Classes);
     R[1]:=((1/(BlueMin+0.000001))-RX);     R[2]:=(R[1]-RX);
     R[3]:=(R[2]-RX);      R[4]:=(R[3]-RX);
     R[5]:=(R[4]-RX);      R[6]:=(R[5]-RX);
     R[7]:=(R[6]-RX);      R[8]:=(R[7]-RX);
For J:= 1 to 9 DO    Begin
    TempValue:= Round(1/R[J]);
If TempValue < 0 then TempValue := 0
else if TempValue > 255 then TempValue := 255;
 BlueStats[8,J]:= TempValue;
End;
*)

{Free Zone Increaser}
  for J := 1 to 9 do RedStats[7, J] := (Round(J * 26.666) + J);
  for J := 1 to 9 do GreenStats[7, J] := (Round(J * 26.666) + J);
  for J := 1 to 9 do BlueStats[7, J] := (Round(J * 26.666) + J);


  for J := 9 downto 1 do
    RedStats[8, J] := 255 - (Round((9 - J) * 26.666));
  for J := 9 downto 1 do
    GreenStats[8, J] := 255 - (Round((9 - J) * 26.666));
  for J := 9 downto 1 do
    BlueStats[8, J] := 255 - (Round((9 - J) * 26.666));

{  For J:= 1 to 9 DO RedStats[8,J] := Round(J * 25);
  For J:= 1 to 9 DO GreenStats[8,J] := Round(J * 25);
  For J:= 1 to 9 DO BlueStats[8,J] := Round(J * 25);}

{Really only  0..8 are used... }
  RedStats[9, 1] := 15;
  for J := 2 to 8 do
    RedStats[9, J] := Round(RedStats[9, J - 1] + (J * J));
  RedStats[9, 9] := 255;
  GreenStats[9, 1] := 15;
  for J := 2 to 8 do
    GreenStats[9, J] := Round(GreenStats[9, J - 1] + (J * J));
  GreenStats[9, 9] := 255;
  BlueStats[9, 1] := 15;
  for J := 2 to 8 do
    BlueStats[9, J] := Round(BlueStats[9, J - 1] + (J * J));
  BlueStats[9, 9] := 255;

(*
  SDS:=0;
  For J:= 0 to 255 DO
  SDS:=(SDS + ((CountR[J] * (J - RedMean))*(CountG[J] * (J - GreenMean)) ));
  B12CoVariance:=(SDS/RNum-1); B12R:=(B12CoVariance/(RedSD*GreenSD));
  SDS:=0;
  For J:= 0 to 255 DO
  SDS:=(SDS + ((CountR[J] * (J - RedMean))*(CountB[J] * (J - BlueMean))));
  B13CoVariance:=(SDS/RNum-1); B13R:=(B13CoVariance/(RedSD*BlueSD));
  SDS:=0;
  For J:= 0 to 255 DO
  SDS:=(SDS + ((CountB[J] * (J - BlueMean))*(CountG[J] * (J - GreenMean))));
  B23CoVariance:=(SDS/RNum-1); B23R:=(B13CoVariance/(GreenSD*BlueSD));*)

  SDS := 0; StepValue := ((RSum - GSum) / Rnum);
  for J := 0 to 255 do SDS := (SDS + ((CountR[J] * CountG[J])));
  SDS := (SDS - StepValue);
  B12CoVariance := (SDS / RNum - 1); B12R := (B12CoVariance / (RedSD
    * GreenSD));
  SDS := 0; StepValue := ((RSum - BSum) / Rnum);
  for J := 0 to 255 do SDS := (SDS + ((CountR[J] * CountB[J])));
  SDS := (SDS - StepValue);
  B13CoVariance := (SDS / RNum - 1); B13R := (B13CoVariance / (RedSD
    * BlueSD));
  SDS := 0; StepValue := ((GSum - BSum) / Rnum);
  for J := 0 to 255 do SDS := (SDS + ((CountG[J] * CountB[J])));
  SDS := (SDS - StepValue);
  B23CoVariance := (SDS / RNum - 1); B23R := (B23CoVariance / (GreenSD
    * BlueSD));
end; { of PROCEDURE DoImStats }
{---------------------------------------------------------------------}

procedure DO_Stats(ChoiceStats: Integer);
var NamedStatS: string;
  TheColor: LongInt;
  RedColor, BlueColor, GreenColor: Byte;
{InClassesR0,InClassesG0,InClassesB0,}
  InClassesR1, InClassesG1, InClassesB1,
    InClassesR2, InClassesG2, InClassesB2,
    InClassesR3, InClassesG3, InClassesB3,
    InClassesR4, InClassesG4, InClassesB4,
    InClassesR5, InClassesG5, InClassesB5,
    InClassesR6, InClassesG6, InClassesB6,
    InClassesR7, InClassesG7, InClassesB7,
    InClassesR8, InClassesG8, InClassesB8,
    InClassesR9, InClassesG9, InClassesB9: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range, FLength, FWidth,
    sX, sY, Where: Integer;
  IL, IW: Dword;
{  RGBS: array[0..128] of Char;
  strTemp: array[0..127] of Char;}
begin
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  if (not ((Toggle_D_R or Toggle_D_G or Toggle_D_B or Toggle_D_RGB) =
    True))
    then DoMessages(39)
  else begin

{FillChar(RGBS, sizeof(RGBS),' ');
IF (LoadString(HInstance, (ChoiceStats+943), RGBS, SizeOf(RGBS)) > 0)
then
    StrCopy(strTemp, RGBS);
    SetWindowText(hWindow, strTemp);}
{NEED!!!!!!
Change this to check ALL 3 RGB stats IF (ALL 3) THEN = Color1}
    InClassesR1 := ClassesR[1];
    InClassesG1 := ClassesG[1];
    InClassesB1 := ClassesB[1];
    InClassesR2 := ClassesR[2];
    InClassesG2 := ClassesG[2];
    InClassesB2 := ClassesB[2];
    InClassesR3 := ClassesR[3];
    InClassesG3 := ClassesG[3];
    InClassesB3 := ClassesB[3];
    InClassesR4 := ClassesR[4];
    InClassesG4 := ClassesG[4];
    InClassesB4 := ClassesB[4];
    InClassesR5 := ClassesR[5];
    InClassesG5 := ClassesG[5];
    InClassesB5 := ClassesB[5];
    InClassesR6 := ClassesR[6];
    InClassesG6 := ClassesG[6];
    InClassesB6 := ClassesB[6];
    InClassesR7 := ClassesR[7];
    InClassesG7 := ClassesG[7];
    InClassesB7 := ClassesB[7];
    InClassesR8 := ClassesR[8];
    InClassesG8 := ClassesG[8];
    InClassesB8 := ClassesB[8];
    InClassesR9 := ClassesR[9];
    InClassesG9 := ClassesG[9];
    InClassesB9 := ClassesB[9];

    ILStart := (0);
    IWStart := (0);
    ILEnd := (ImageHeight);
    IWEnd := (ImageWidth);
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
        TheColor := Color9;
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;
{Histogram window that does the Statistics for Class Breaks
Make window NOT changeable in size: page 613 of TPW}
        if Toggle_D_R then begin
          if (RedColor <= InClassesR1) then
          begin TheColor := Color1 end
          else if (RedColor <= InClassesR2) then
          begin TheColor := Color2 end
          else if (RedColor <= InClassesR3) then
          begin TheColor := Color3 end
          else if (RedColor <= InClassesR4) then
          begin TheColor := Color4 end
          else if (RedColor <= InClassesR5) then
          begin TheColor := Color5 end
          else if (RedColor <= InClassesR6) then
          begin TheColor := Color6 end
          else if (RedColor <= InClassesR7) then
          begin TheColor := Color7 end
          else if (RedColor <= InClassesR8) then
          begin TheColor := Color8 end
          else if (RedColor > InClassesR8) then
          begin TheColor := Color9 end
        end {of IF Toggle_D_R}

        else if Toggle_D_G then begin
          if (GreenColor <= InClassesG1) then
          begin TheColor := Color1 end
          else if (GreenColor <= InClassesG2) then
          begin TheColor := Color2 end
          else if (GreenColor <= InClassesG3) then
          begin TheColor := Color3 end
          else if (GreenColor <= InClassesG4) then
          begin TheColor := Color4 end
          else if (GreenColor <= InClassesG5) then
          begin TheColor := Color5 end
          else if (GreenColor <= InClassesG6) then
          begin TheColor := Color6 end
          else if (GreenColor <= InClassesG7) then
          begin TheColor := Color7 end
          else if (GreenColor <= InClassesG8) then
          begin TheColor := Color8 end
          else if (GreenColor > InClassesG8) then
          begin TheColor := Color9 end
        end {of IF Toggle_D_G}

        else if Toggle_D_B then begin
          if (BlueColor <= InClassesB1) then
          begin TheColor := Color1 end
          else if (BlueColor <= InClassesB2) then
          begin TheColor := Color2 end
          else if (BlueColor <= InClassesB3) then
          begin TheColor := Color3 end
          else if (BlueColor <= InClassesB4) then
          begin TheColor := Color4 end
          else if (BlueColor <= InClassesB5) then
          begin TheColor := Color5 end
          else if (BlueColor <= InClassesB6) then
          begin TheColor := Color6 end
          else if (BlueColor <= InClassesB7) then
          begin TheColor := Color7 end
          else if (BlueColor <= InClassesB8) then
          begin TheColor := Color8 end
          else if (BlueColor > InClassesB8) then
          begin TheColor := Color9 end
        end
        else if Toggle_D_RGB then begin
          if ((RedColor <= InClassesR1)
            and (GreenColor <= InClassesG1)
            and (BlueColor <= InClassesB1))
            then begin TheColor := Color1 end
          else if ((RedColor <= InClassesR2) and (RedColor >
            InClassesR1)
            and (GreenColor <= InClassesG2) and (GreenColor >
            InClassesG1)
            and (BlueColor <= InClassesB2) and (BlueColor >
            InClassesB1))
            then begin TheColor := Color2 end
          else if ((RedColor <= InClassesR3) and (RedColor >
            InClassesR2)
            and (GreenColor <= InClassesG3) and (GreenColor >
            InClassesG2)
            and (BlueColor <= InClassesB3) and (BlueColor >
            InClassesB2))
            then begin TheColor := Color3 end
          else if ((RedColor <= InClassesR4) and (RedColor >
            InClassesR3)
            and (GreenColor <= InClassesG4) and (GreenColor >
            InClassesG3)
            and (BlueColor <= InClassesB4) and (BlueColor >
            InClassesB3))
            then begin TheColor := Color4 end
          else if ((RedColor <= InClassesR5) and (RedColor >
            InClassesR4)
            and (GreenColor <= InClassesG5) and (GreenColor >
            InClassesG4)
            and (BlueColor <= InClassesB5) and (BlueColor >
            InClassesB4))
            then begin TheColor := Color5 end
          else if ((RedColor <= InClassesR6) and (RedColor >
            InClassesR5)
            and (GreenColor <= InClassesG6) and (GreenColor >
            InClassesG5)
            and (BlueColor <= InClassesB6) and (BlueColor >
            InClassesB5))
            then begin TheColor := Color6 end
          else if ((RedColor <= InClassesR7) and (RedColor >
            InClassesR6)
            and (GreenColor <= InClassesG7) and (GreenColor >
            InClassesG6)
            and (BlueColor <= InClassesB7) and (BlueColor >
            InClassesB6))
            then begin TheColor := Color7 end
          else if ((RedColor <= InClassesR8) and (RedColor >
            InClassesR7)
            and (GreenColor <= InClassesG8) and (GreenColor >
            InClassesG7)
            and (BlueColor <= InClassesB8) and (BlueColor >
            InClassesB7))
            then begin TheColor := Color8 end
          else if ((RedColor > InClassesR8)
            and (GreenColor > InClassesG8)
            and (BlueColor > InClassesB8))
            then begin TheColor := Color9 end
     {(NOT Bleeder)}
      {Make these so they are TRUE to WORK!!!}
     {... to do what is on the other side of the Boolean}
          else {IF Blocked}  TheColor := ColorWhite;
        end;
 {of IF Toggle_D_RGB}
{of IF Toggle_D_B and the other 3: RGB, R,G}
{ SetPixel(hWorkDC, IW, IL,TheColor);}
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        BlueColor := GetBValue(TheColor);
        RedColor := GetRValue(TheColor);
        GreenColor := GetGValue(TheColor);
        lpPixelB^ := BlueColor; lpPixelG^ := GreenColor; lpPixelR^ :=
        RedColor;

      end; {OF WIDTH}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {OF LENGTH}
    if Toggle_D_Rotate then SetImage; {of Rotate}
    MyChanged := True;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
  end; end; {of Do_Stats}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}



{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure GetCountName;
var
  fsave: file of byte;
  I {,NameNumber,Code }: Integer;
{Keeper:Char;
NString:String[1];}
  FileLen: Word;
begin
  CountName := GRIPFileName;
  FileLen := Length(CountName);
  I := FileLen - 1;
  while (I <> 0) and ((CountName[I] <> '.')) do Dec(I);
  Inc(I);
  CountName[I] := char('a');
  Inc(I);
  CountName[I] := char('d');
  Inc(I);
  CountName[I] := char('c');
{$I-}
  Assign(fsave, CountName);
  Reset(fsave);
  Close(fsave);
{$I+}
  CountFileExists := (IOResult = 0);
{    if CountFileExists then CountName := FileName;}
end;
{---------------------------------------------------------------------}

procedure Load_Count;
var
  fLoad: file of Count; { FileName:String;}
begin
{$I-}
  AssignFile(fLoad, CountName);
  Reset(fLoad);
  Read(fLoad, CountR); {[I] :=0;}
  Read(fLoad, CountG); {[I] :=0;}
  Read(fLoad, CountB); {[I] :=0;}
  CloseFile(fLoad);
{$I+}
end;

procedure Save_Count;
var
  fLoad: file of Count; { FileName:String;  }
begin
{$I-}
  AssignFile(fLoad, CountName);
  Rewrite(fLoad);
  Write(fLoad, CountR); {[I] :=0;}
  Write(fLoad, CountG); {[I] :=0;}
  Write(fLoad, CountB); {[I] :=0;}
  CloseFile(fLoad);
{$I+}
end;
{---------------------------------------------------------------------}
{Called by DO_Stats; then this calls Save_Stats;}
{Do actual statistics-Min,Max,Median,Mode,Standard Deviation}

procedure Do_Count;
begin
  GetCountName;
  if CountFileExists then Load_Count
  else begin
    Do_Countem;
    if (CountFailed = True) then begin
      GRIPForm.StatusBar1.Panels[1].Text :=
        'Image has Zeros, will take a while longer...';
      KillZero;
      Do_Countem;
      Save_Count;
    end else Save_Count;
  end;
end;
{---------------------------------------------------------------------}

procedure KillZero;
var
  RedColor, BlueColor, GreenColor: Byte;
{  I,} IL, IW: DWord; {Integer;}
begin
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := 0 to ImageHeight do begin
      for IW := 0 to ImageWidth do begin
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;
        if (BlueColor = 0) then lpPixelB^ := 1 else
          lpPixelB^ := BlueColor;
        if (GreenColor = 0) then lpPixelG^ := 1 else
          lpPixelG^ := GreenColor;
        if (RedColor = 0) then lpPixelR^ := 1 else
          lpPixelR^ := RedColor;
      end; {OF WIDTH}
      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {OF LENGTH}
    FreeImage; end;
end; {of for 255}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure Do_Countem;
var
{  TheColor:Longint;}
  RedColor, BlueColor, GreenColor: Byte;
  RedOne, GreenOne, BlueOne,
    I: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  CountFailed := False; ;
  MakeImage;
  if ImageMade = TRUE then begin
{CLEAR the Count Arrays}
    for I := 0 to 255 do begin
      CountR[I] := 0;
      CountG[I] := 0;
      CountB[I] := 0;
    end;
    for IL := 0 to ImageHeight do begin
      for IW := 0 to ImageWidth do begin
        { TheColor:= GetPixel(hTRIPDC,IW,IL);
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor);       }
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;
        if ((BlueColor = 0) or (GreenColor = 0) or (RedColor = 0))
          then CountFailed := True;
{Inc(CountR[RedColor]);}
        RedOne := RedColor;
        CountR[RedOne] := (CountR[RedOne] + 1);
{Inc(CountG[GreenColor]);}
        GreenOne := GreenColor;
        CountG[GreenOne] := (CountG[GreenOne] + 1);
{Inc(CountB[BlueColor]);}
        BlueOne := BlueColor;
        CountB[BlueOne] := (CountB[BlueOne] + 1);
{Parallelpiped Multivariate RGB Linked List
If Red = Red then
   If Green = Green then
     If Blue = Blue then inc(RGB[])
     ELSE make a new point in the linked list
}
      end; {OF WIDTH}
      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {OF LENGTH}
    FreeImage; end;
end; {of for 255}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure GetStatsArrayName;
var
  fsave: file of byte;
  I {,NameNumber,Code}: Integer;
{Keeper:Char;
NString:String[1]; }
  FileLen: Word;
begin
  StatsArrayName := GRIPFileName;
  FileLen := Length(StatsArrayName);
  I := FileLen - 1;
  while (I <> 0) and ((StatsArrayName[I] <> '.')) do Dec(I);
  Inc(I);
  StatsArrayName[I] := char('a');
  Inc(I);
  StatsArrayName[I] := char('d');
  Inc(I);
  StatsArrayName[I] := char('s');
{$I-}
  Assign(fsave, StatsArrayName);
  Reset(fsave);
  Close(fsave);
{$I+}
  StatsFileExists := (IOResult = 0);
{    if CountFileExists then CountName := FileName;}
end;

procedure Load_ArrayStats;
var
  fLoad: file of StatClasses; { FileName:String;}
begin
{$I-}
  AssignFile(fLoad, StatsArrayName);
  Reset(fLoad);
  Read(fLoad, RedStats); {[I] :=0;}
  Read(fLoad, GreenStats); {[I] :=0;}
  Read(fLoad, BlueStats); {[I] :=0;}
  CloseFile(fLoad);
{$I+}
end;

procedure Save_ArrayStats;
var
  fLoad: file of StatClasses; { FileName:String;  }
begin
{$I-}
  AssignFile(fLoad, StatsArrayName);
  Rewrite(fLoad);
  Write(fLoad, RedStats); {[I] :=0;}
  Write(fLoad, GreenStats); {[I] :=0;}
  Write(fLoad, BlueStats); {[I] :=0;}
  CloseFile(fLoad);
{$I+}
end;


procedure Do_Stat;
begin Do_Count;
  GetStatsArrayName;
  if StatsFileExists then Load_ArrayStats
  else begin
    DoAllStats;
    Save_ArrayStats;
  end;
  GetStatsTextName;
  if StatsTextFileExists then Load_TextStats
  else begin
    DoAllStats;
    Save_TextStats;
  end;
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure GetStatsTextName;
var
  fsave: file of byte;
  I {,NameNumber,Code}: Integer;
{Keeper:Char;
NString:String[1];}
  FileLen: Word;
begin
  StatsTextName := GRIPFileName;
  FileLen := Length(StatsTextName);
  I := FileLen - 1;
  while (I <> 0) and ((StatsTextName[I] <> '.')) do Dec(I);
  Inc(I);
  StatsTextName[I] := char('a');
  Inc(I);
  StatsTextName[I] := char('d');
  Inc(I);
  StatsTextName[I] := char('t');
{$I-}
  Assign(fsave, StatsTextName);
  Reset(fsave);
  Close(fsave);
{$I+}
  StatsTextFileExists := (IOResult = 0);
{    if CountFileExists then CountName := FileName;}
end;

procedure Load_TextStats;
var
  fLoad: TextFile; S: string; Code: Integer;
begin
{$I-}
  AssignFile(fLoad, StatsTextName);
  Reset(fLoad);
  Readln(fLoad, S); val(S, RedMean, Code);
  Readln(fLoad, S); val(S, RedSD, Code);
  Readln(fLoad, S); val(S, RedVariance, Code);
  Readln(fLoad, S); val(S, GreenMean, Code);
  Readln(fLoad, S); val(S, GreenSD, Code);
  Readln(fLoad, S); val(S, GreenVariance, Code);
  Readln(fLoad, S); val(S, BlueMean, Code);
  Readln(fLoad, S); val(S, BlueSD, Code);
  Readln(fLoad, S); val(S, BlueVariance, Code);
  Readln(fLoad, S); val(S, RedMin, Code);
  Readln(fLoad, S); val(S, RedMax, Code);
  Readln(fLoad, S); val(S, RedMedian, Code);
  Readln(fLoad, S); val(S, RedMode, Code);
  Readln(fLoad, S); val(S, RSum, Code);
  Readln(fLoad, S); val(S, RNum, Code);
  Readln(fLoad, S); val(S, RedRange, Code);
  Readln(fLoad, S); val(S, GreenMin, Code);
  Readln(fLoad, S); val(S, GreenMax, Code);
  Readln(fLoad, S); val(S, GreenMedian, Code);
  Readln(fLoad, S); val(S, GreenMode, Code);
  Readln(fLoad, S); val(S, GSum, Code);
  Readln(fLoad, S); val(S, GNum, Code);
  Readln(fLoad, S); val(S, GreenRange, Code);
  Readln(fLoad, S); val(S, BlueMin, Code);
  Readln(fLoad, S); val(S, BlueMax, Code);
  Readln(fLoad, S); val(S, BlueMedian, Code);
  Readln(fLoad, S); val(S, BlueMode, Code);
  Readln(fLoad, S); val(S, BSum, Code);
  Readln(fLoad, S); val(S, BNum, Code);
  Readln(fLoad, S); val(S, BlueRange, Code);
  Readln(fLoad, S); val(S, B12CoVariance, Code);
  Readln(fLoad, S); val(S, B12R, Code);
  Readln(fLoad, S); val(S, B13CoVariance, Code);
  Readln(fLoad, S); val(S, B13R, Code);
  Readln(fLoad, S); val(S, B23CoVariance, Code);
  Readln(fLoad, S); val(S, B23R, Code);

  CloseFile(fLoad);
{$I+}
end;


procedure Save_TextStats;
var
  fLoad: TextFile; S: string;
begin
{$I-}
  AssignFile(fLoad, StatsTextName);
  Rewrite(fLoad);
  Str(RedMean, S); Writeln(fLoad, S);
  Str(RedSD, S); Writeln(fLoad, S);
  Str(RedVariance, S); Writeln(fLoad, S);
  Str(GreenMean, S); Writeln(fLoad, S);
  Str(GreenSD, S); Writeln(fLoad, S);
  Str(GreenVariance, S); Writeln(fLoad, S);
  Str(BlueMean, S); Writeln(fLoad, S);
  Str(BlueSD, S); Writeln(fLoad, S);
  Str(BlueVariance, S); Writeln(fLoad, S);
  Str(RedMin, S); Writeln(fLoad, S);
  Str(RedMax, S); Writeln(fLoad, S);
  Str(RedMedian, S); Writeln(fLoad, S);
  Str(RedMode, S); Writeln(fLoad, S);
  Str(RSum, S); Writeln(fLoad, S);
  Str(RNum, S); Writeln(fLoad, S);
  Str(RedRange, S); Writeln(fLoad, S);
  Str(GreenMin, S); Writeln(fLoad, S);
  Str(GreenMax, S); Writeln(fLoad, S);
  Str(GreenMedian, S); Writeln(fLoad, S);
  Str(GreenMode, S); Writeln(fLoad, S);
  Str(GSum, S); Writeln(fLoad, S);
  Str(GNum, S); Writeln(fLoad, S);
  Str(GreenRange, S); Writeln(fLoad, S);
  Str(BlueMin, S); Writeln(fLoad, S);
  Str(BlueMax, S); Writeln(fLoad, S);
  Str(BlueMedian, S); Writeln(fLoad, S);
  Str(BlueMode, S); Writeln(fLoad, S);
  Str(BSum, S); Writeln(fLoad, S);
  Str(BNum, S); Writeln(fLoad, S);
  Str(BlueRange, S); Writeln(fLoad, S);
  Str(B12CoVariance, S); Writeln(fLoad, S);
  Str(B12R, S); Writeln(fLoad, S);
  Str(B13CoVariance, S); Writeln(fLoad, S);
  Str(B23CoVariance, S); Writeln(fLoad, S);
  Str(B23CoVariance, S); Writeln(fLoad, S);
  Str(B23R, S); Writeln(fLoad, S);
  CloseFile(fLoad);
{$I+}
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

(************ Begin of SortItQuick ***************************************)
                      {'UP' or 'DN' }

procedure SortItQuick(Direction: string; Count: Integer; Item: T_Array
  {Var Item : Freq});
  { Making the Array a variable means less copying and space is saved }
(*************************************************************************
*         A recursive procedure made of 2 other procedures.
*         The SortItQuick is a mask to pass the variable to PartialSort
*         which does most of the work.  When a number is found to be sorted
*         the procedure Switch exchanges the 2 numbers.
*************************************************************************)

  procedure PartialSortUP(left, right: Integer; var InArray: T_Array
    {Freq});
  var
    i, j, k: integer; { used in PartialSort to determine the middle
                               of the array and use it to compare with
                               elements in the array as they are processed }
(********* Recursive procedure inside SortItQuick *************************)
    procedure Switch(var A, B: Integer);
                      { Variable so it will return the numbers as switched }
    var
      C: Integer; { The A,B,C reals are switched around using C as }
    begin { temporary storage passage space.               }
      if A <> B then
      begin
        C := A;
        A := B;
        B := C;
      end;
    end;
(************ End of Switch ***********************************************)

(************ Begin of PartialSortUP ****************************************)
  begin
    k := (InArray[left] + InArray[right]) div 2;
                                  { Find the middle of Array to start from }
    i := left;
      { Duplicated to be able to keep the ends while changing }
    j := right;
      { the number that is being referenced in the array      }

    repeat
      while InArray[i] < k do
        { 1 of 2 : Change > to < for Ascending sort   }
        Inc(i);
          { Inc and Dec Increase or Decrease the variable by 1    }

      while k < InArray[j] do
        { 2 of 2 : Change > to < for Ascending sort   }
        Dec(j); { if it is Dec(i,n) the n can be up to a Longint }

      if i <= j then
        { if the left is less than the right then switch the    }
      begin { Numbers in the array                                  }
        Switch(InArray[i], InArray[j]);
        Inc(i);
        Dec(j);
      end;
    until i > j;

    if left < j then
      { Check to see if the original left has been passed   }
      PartialSortUP(left, j, InArray); { by the working right }
    if i < right then
      PartialSortUP(i, right, InArray);
  end;
(************ End of PartialSortUP ******************************************)



  procedure PartialSortDN(left, right: Integer; var InArray: T_Array
    {Freq});
(**************************************************************************
*         This procedure is documented along with the Source code in
*         an effort to effectively allow the understanding of the algorithm.
***************************************************************************)
  var
    i, j, k: integer; { used in PartialSort to determine the middle
                               of the array and use it to compare with
                               elements in the array as they are processed }
(********* Recursive procedure inside SortItQuick *************************)
    procedure Switch(var A, B: Integer);
                      { Variable so it will return the numbers as switched }
    var
      C: Integer; { The A,B,C reals are switched around using C as }
    begin { temporary storage passage space.               }
      if A <> B then
      begin
        C := A;
        A := B;
        B := C;
      end;
    end;
(************ End of Switch ***********************************************)

(************ Begin of PartialSortDN ****************************************)
  begin
    k := (InArray[left] + InArray[right]) div 2;
                                  { Find the middle of Array to start from }
    i := left;
      { Duplicated to be able to keep the ends while changing }
    j := right;
      { the number that is being referenced in the array      }

    repeat
      while InArray[i] > k do
        { 1 of 2 : Change > to < for Ascending sort   }
        Inc(i);
          { Inc and Dec Increase or Decrease the variable by 1    }

      while k > InArray[j] do
        { 2 of 2 : Change > to < for Ascending sort   }
        Dec(j); { if it is Dec(i,n) the n can be up to a Longint }

      if i <= j then
        { if the left is less than the right then switch the    }
      begin { Numbers in the array                                  }
        Switch(InArray[i], InArray[j]);
        Inc(i);
        Dec(j);
      end;
    until i > j;

    if left < j then
      { Check to see if the original left has been passed   }
      PartialSortDN(left, j, InArray); { by the working right }
    if i < right then
      PartialSortDN(i, right, InArray);
  end;
(************ End of PartialSortDN ******************************************)

(************ Begin of SortItQuick ****************************************)
begin
  if Direction = 'UP' then
    PartialSortUP(1, Count, Item)
  else if Direction = 'DN' then
    PartialSortDN(1, Count, Item)
  else Writeln(' Boo Boo Took the pick-a-nick basket ');
end;
(************ End of SortItQuick ******************************************)

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
end.
