{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gUIPFilter;
{------------------------ TSPLAT Implementation ------------------}
{ Do_IntegerFile }
{Do_SAdd  RealFile}
{ Ratio: RatBoy }
{ Slope: BatGirl }
{Do_Rotate8SQRTFile}
{CMIMD_FreiandChen ... does not exist ... is as a filter for rotate8}
{CMIMD_Kirsch}{Do a Kirsch with SQRT(SQRT(SQ1+SQ2+SQ3+SQ4+SQ5+SQ6+SQ7+SQ8))
  {CMIMD_KirschFile}{Call it an S&K}
{CMIMD_SobelSOD}
{SobelDOGarctan}
{Make Dynamic arrays for Array 1..8 of Matrix Array [-4..4,-4..4]
load filters into F_M[i,x,y]}
{CMIM_Slope8}
{Do_SlopeFile}
{CMIM_SlopeDir}
{
When you are up to your neck in Alligators
it is hard to remember that the Prime Directive
was to drain the swamp
Alligator       alley gator     Error Comment
Investigator    In vest gator   Comment expert
Navigator       Navy gator      Expert Help
}
interface

uses Windows, {WinTypes,} Dialogs, {SysUtils,} gGlobal;


{MATRIX: Filed Filters; Ranked Edge; Texture; Ratio; Algebra}
procedure Do_IntegerFile(InFilterName: string; AutoTimes: Integer);
procedure Do_RealFile(InFilterName: string; AutoTimes: Integer);
               {CMInspectRatioTexture Ratio ADD}
procedure RatBoy(InFilterName: string; AutoTimes: Integer);
                {CMInspectP_Slope: Ratio MAX}
procedure BatGirl(InFilterName: string; AutoTimes: Integer);

procedure Do_SobelFile(InFilterName: string; AutoTimes: Integer);
procedure Do_SoDogFile(InFilterName: string; AutoTimes: Integer);
procedure Do_Rotate8SQRTFile(InFilterName: string;
  AutoTimes, Ranger, Rangette: Integer);
procedure Do_Rotate8MaxFile(InFilterName: string; AutoTimes:
  Integer);
{Roberts Cross  ... Slope 2,6,8}
{Slope 2}
{Process as a SQRT loading a sobel_r.f23 filter}
{Slope 6}
{Process as a INVTAN loading a     AAA   B B
Sobel (8 edge cells)or a            X    BXB
Prewitt (6 edge cells) filter      AAA   B B }
{Slope 8}
{Process as a SQRT loading a       AAA   B B
Sobel (8 edge cells)or a            X    BXB
Prewitt (6 edge cells) filter      AAA   B B }
procedure Do_SlopeFile(InFilterName: string;
  AutoTimes: Integer; WhichSlope: Integer);

(*
    PROCEDURE CMIMD_Rotate8SQRT(var Msg: TMessage);
    PROCEDURE CMIM_Slope2(var Msg: TMessage);
    PROCEDURE CMIM_Slope6(var Msg: TMessage);
    PROCEDURE CMIM_Slope8(var Msg: TMessage);
*)
implementation
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure Do_IntegerFile(InFilterName: string; AutoTimes: Integer);
var
  SpatError: Boolean;
  ClassFile: file of Integer; { Double;}
  Filter: array[-4..4, -4..4] of Integer; {Double;}
  i, NumberOfScores: Integer;
  Input, IsOne,
    R_Min, G_Min, B_Min: Integer; {Double;}
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    R_Filtered, G_Filtered, B_Filtered: Integer; {Double;}
  TheColor: Longint;
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range, FLength, FWidth,
{ : Integer;}
  sX, sY, Where, IL, IW: Dword;
  HowManyS: string;
begin {Get current Window DC}
  iAT_Max := round(dAT_Max);
  iAT_Min := round(dAT_Min);
  SpatError := FALSE;
  IsOne := 0;
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
  Assign(ClassFile, InFilterName);
  Reset(ClassFile);
  {Filter extension ie. FL3, FL5, FL7, FL9: Size of Filter}
  HowMany := WhatsMySize(InFilterName);
  {Negative of 3/2=1.5=1; 5/2=2.5=2; 7/2=3.5=3; 9/2=4.5=4}
  {Determines the starting point of Filter convolution
   Allows retreiving pixel data for the matrix around the
   current PIXEL being filtered}
  Where := {(HowMany Div 2); }(-Trunc(HowMany / 2));
  NumberOfScores := 0;
  for FLength := 0 to (HowMany - 1) do begin
    for FWidth := 0 to (HowMany - 1) do
    begin
      Read(ClassFile, Input); inc(NumberOfScores);
      Filter[(FWidth + Where), (FLength + Where)] :=
        {ScoreI[NumberOfScores]} Input;
      IsOne := IsOne + Input;
    end;
  end;
  Close(ClassFile);
    {Wait a second and let Windows talk to itself}
    {?? how to??}
  ILStart := (0 + {(HowMany div 2)}(Trunc(HowMany / 2)));
  IWStart := (0 + {(HowMany div 2)}(Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - (Trunc(HowMany / 2)));
  IWEnd := (ImageWidth - (Trunc(HowMany / 2)));
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range div 255; {or 256?}
      G_Range := G_Max - G_Min;
      G_Range := G_Range div 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range div { /}  255;

      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
          R_Filtered := 0;
          G_Filtered := 0;
          B_Filtered := 0;
          for sY := 0 to (HowMany - 1) do begin
            for sX := 0 to (HowMany - 1) do begin
{!!!!         TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor);}
              WherePixel := (3 * (IW + (sX + Where))) + (BytesPerLine
                * (((IL + sY + Where))));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueColor := lpPixelB^;
              GreenColor := lpPixelG^;
              RedColor := lpPixelR^;
{  str( RedColor,HowManyS);
   MessageDlg(HowManyS, mtInformation,[mbOk], 0);
 }
              R_Filtered := (R_Filtered +
                (RedColor * Filter[(sX + Where), (sY + Where)]));
              G_Filtered := (G_Filtered +
                (GreenColor * Filter[(sX + Where), (sY + Where)]));
              B_Filtered := (B_Filtered +
                (BlueColor * Filter[(sX + Where), (sY + Where)]));
            end;
          end;
          if V_Absolute then begin
            if R_Filtered < 0 then R_Filtered := (R_Filtered * -1);
            if G_Filtered < 0 then G_Filtered := (G_Filtered * -1);
            if B_Filtered < 0 then B_Filtered := (B_Filtered * -1);
          end;
          if R_AutoTT then begin
            if R_Filtered > iAT_Max then R_Filtered := iAT_Max;
            if R_Filtered < iAT_Min then R_Filtered := iAT_Min;
            if G_Filtered > iAT_Max then G_Filtered := iAT_Max;
            if G_Filtered < iAT_Min then G_Filtered := iAT_Min;
            if B_Filtered > iAT_Max then B_Filtered := iAT_Max;
            if B_Filtered < iAT_Min then B_Filtered := iAT_Min;
          end;
          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Filtered > R_Max then R_Max := R_Filtered;
              if G_Filtered > G_Max then G_Max := G_Filtered;
              if B_Filtered > B_Max then B_Max := B_Filtered;
              if R_Filtered < R_Min then R_Min := R_Filtered;
              if G_Filtered < G_Min then G_Min := G_Filtered;
              if B_Filtered < B_Min then B_Min := B_Filtered;
            end else
              if Range = 1 then begin
                R_Filtered := (R_Filtered - (R_Min)) div {/}
                  R_Range;
{       IF G_Min < 0 Then G_Min := (G_Min * -1);}
                G_Filtered := (G_Filtered - (G_Min)) div {/}
                  G_Range;
{       IF B_Min < 0 Then B_Min := (B_Min * -1);}
                B_Filtered := (B_Filtered - (B_Min)) div {/}
                  B_Range;
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := {Round}(R_Filtered);

                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := {Round}(G_Filtered);

                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := {Round}(B_Filtered);
                if S_Threshold then begin
                  if RedColor > bST_Max then RedColor := bST_Max;
                  if RedColor < bST_Min then RedColor := 0;
                  if GreenColor > bST_Max then GreenColor := bST_Max;
                  if GreenColor < bST_Min then GreenColor := 0;
                  if BlueColor > bST_Max then BlueColor := bST_Max;
                  if BlueColor < bST_Min then BlueColor := 0;
                end;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor;
                lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));  }
              end;
          end else
            if {Do_Absolute, AutoRange, B_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := {Round}(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
            end else

              if {Do_Absolute, AutoRange,}  Do_Ex_com
                {, ClipR, ThresholdR,}
              then begin
                if IsOne > 1 then
                  R_Filtered := (R_Filtered div {/}  IsOne);
                if R_Filtered < 1 then
                  R_Filtered := ((R_Filtered * 127) + 1) else
                  if R_Filtered >= 1 then
                    R_Filtered := (128 + (R_Filtered div 2));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);

                if IsOne > 1 then
                  G_Filtered := (G_Filtered div {/}  IsOne);
                if G_Filtered < 1 then
                  G_Filtered := ((G_Filtered * 127) + 1) else
                  if G_Filtered >= 1 then
                    G_Filtered := (128 + (G_Filtered div 2));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);

                if IsOne > 1 then
                  B_Filtered := (B_Filtered div {/}  IsOne);
                if B_Filtered < 1 then
                  B_Filtered := ((B_Filtered * 127) + 1) else
                  if B_Filtered >= 1 then
                    B_Filtered := (128 + (B_Filtered div 2));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
                if S_Threshold then begin
                  if RedColor > bST_Max then RedColor := bST_Max;
                  if RedColor < bST_Min then RedColor := 0;
                  if GreenColor > bST_Max then GreenColor := bST_Max;
                  if GreenColor < bST_Min then GreenColor := 0;
                  if BlueColor > bST_Max then BlueColor := bST_Max;
                  if BlueColor < bST_Min then BlueColor := 0;
                end;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
              end else
                if {Do_Absolute, AutoRange, Do_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if IsOne > 1 then
                    R_Filtered := (R_Filtered div {/}  IsOne);
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);

                  if IsOne > 1 then
                    G_Filtered := (G_Filtered div {/}  IsOne);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);

                  if IsOne > 1 then
                    B_Filtered := (B_Filtered div {/}  IsOne);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
                  if S_Threshold then begin
                    if RedColor > bST_Max then RedColor := bST_Max;
                    if RedColor < bST_Min then RedColor := 0;
                    if GreenColor > bST_Max then
                      GreenColor := bST_Max;
                    if GreenColor < bST_Min then GreenColor := 0;
                    if BlueColor > bST_Max then BlueColor := bST_Max;
                    if BlueColor < bST_Min then BlueColor := 0;
                  end;
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
                end; { of AutoRange Insider Edition}
        end; {OF WIDTH}

        if Autorange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, All_Min,
                All_Max);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {OF LENGTH}
    end; {of AutoRange}
    BlackOut;
    SetImage;
{!IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
end; {of Integer files}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure Do_RealFile(InFilterName: string; AutoTimes: Integer);
var
  SpatError: Boolean;
  Filter: array[-4..4, -4..4] of Double; {Integer;}
  ClassFile: file of Double; {Integer;}
  R_Min, G_Min, B_Min: Double;
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    Input, IsOne, R_Filtered, G_Filtered, B_Filtered: Double;
  TheColor: Longint;
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range: Integer;
  FLength, FWidth, IL, IW, sX, sY, Where: Dword;
begin {Get current Window DC}
  SpatError := FALSE;
  {Begin  Do the Filter load and work}
  IsOne := 0;
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
  Assign(ClassFile, InFilterName);
  Reset(ClassFile);
  {Filter extension ie. FL3, FL5, FL7, FL9: Size of Filter}
  HowMany := WhatsMySize(InFilterName);
  {Negative of 3/2=1.5=1; 5/2=2.5=2; 7/2=3.5=3; 9/2=4.5=4}
  {Determines the starting point of Filter convolution
   Allows retreiving pixel data for the matrix around the
   current PIXEL being filtered}
  Where := (-Trunc(HowMany / 2));
  for FLength := 0 to (HowMany - 1) do begin
    for FWidth := 0 to (HowMany - 1) do
    begin
      Read(ClassFile, Input);
      Filter[(FWidth + Where), (FLength + Where)] := Input;
      IsOne := IsOne + Input;
    end;
  end;
  Close(ClassFile);
  if (IsOne > 1) then begin
    for FLength := 0 to (HowMany - 1) do begin
      for FWidth := 0 to (HowMany - 1) do
      begin
        Filter[(FWidth + Where), (FLength + Where)] :=
          ((Filter[(FWidth + Where), (FLength + Where)]) / IsOne);
      end;
    end;
  end; {of If IsOne}
    {Wait a second and let Windows talk to itself}
    {?? how to??}
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255; {or 256?}
      G_Range := G_Max - G_Min;
      G_Range := G_Range / 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / 255;
      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
          R_Filtered := 0;
          G_Filtered := 0;
          B_Filtered := 0;
          for sY := 0 to (HowMany - 1) do begin
            for sX := 0 to (HowMany - 1) do begin
{         TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor);}
              WherePixel := (3 * (IW + (sX + Where))) + (BytesPerLine
                * (((IL + sY + Where))));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueColor := lpPixelB^;
              GreenColor := lpPixelG^;
              RedColor := lpPixelR^;

              R_Filtered := (R_Filtered +
                (RedColor * Filter[(sX + Where), (sY + Where)]));
              G_Filtered := (G_Filtered +
                (GreenColor * Filter[(sX + Where), (sY + Where)]));
              B_Filtered := (B_Filtered +
                (BlueColor * Filter[(sX + Where), (sY + Where)]));
            end;
          end;
          if V_Absolute then begin
            if R_Filtered < 0 then R_Filtered := (R_Filtered * -1);
            if G_Filtered < 0 then G_Filtered := (G_Filtered * -1);
            if B_Filtered < 0 then B_Filtered := (B_Filtered * -1);
          end;
          if R_AutoTT then begin
            if R_Filtered > dAT_Max then R_Filtered := dAT_Max;
            if R_Filtered < dAT_Min then R_Filtered := dAT_Min;
            if G_Filtered > dAT_Max then G_Filtered := dAT_Max;
            if G_Filtered < dAT_Min then G_Filtered := dAT_Min;
            if B_Filtered > dAT_Max then B_Filtered := dAT_Max;
            if B_Filtered < dAT_Min then B_Filtered := dAT_Min;
          end;
          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Filtered > R_Max then R_Max := R_Filtered;
              if G_Filtered > G_Max then G_Max := G_Filtered;
              if B_Filtered > B_Max then B_Max := B_Filtered;
              if R_Filtered < R_Min then R_Min := R_Filtered;
              if G_Filtered < G_Min then G_Min := G_Filtered;
              if B_Filtered < B_Min then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
{       IF R_Min < 0 Then R_Min := (R_Min * -1);}
              R_Filtered := (R_Filtered - (R_Min)) / R_Range;
{       IF G_Min < 0 Then G_Min := (G_Min * -1);}
              G_Filtered := (G_Filtered - (G_Min)) / G_Range;
{       IF B_Min < 0 Then B_Min := (B_Min * -1);}
              B_Filtered := (B_Filtered - (B_Min)) / B_Range;
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);

              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);

              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end;
          end else
            if {Do_Absolute, AutoRange,}  Do_Ex_com
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}

       {IF IsOne > 1.0 then R_Filtered := (R_Filtered/IsOne);}
              if R_Filtered < 1 then
                R_Filtered := ((R_Filtered * 127) + 1) else
                if R_Filtered >= 1 then
                  R_Filtered := (128 + (R_Filtered / 2));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);

       {IF IsOne > 1.0 then G_Filtered := (G_Filtered/IsOne);}
              if G_Filtered < 1 then
                G_Filtered := ((G_Filtered * 127) + 1) else
                if G_Filtered >= 1 then
                  G_Filtered := (128 + (G_Filtered / 2));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);

       {IF IsOne > 1.0 then B_Filtered := (B_Filtered/IsOne);}
              if B_Filtered < 1 then
                B_Filtered := ((B_Filtered * 127) + 1) else
                if B_Filtered >= 1 then
                  B_Filtered := (128 + (B_Filtered / 2));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end else
              if {Do_Absolute, AutoRange, Do_Ex_com}  BelowZero
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                  127));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                  127));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                  127));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
                if S_Threshold then begin
                  if RedColor > bST_Max then RedColor := bST_Max;
                  if RedColor < bST_Min then RedColor := 0;
                  if GreenColor > bST_Max then GreenColor := bST_Max;
                  if GreenColor < bST_Min then GreenColor := 0;
                  if BlueColor > bST_Max then BlueColor := bST_Max;
                  if BlueColor < bST_Min then BlueColor := 0;
                end;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
              end else

                if {Do_Absolute, AutoRange, Do_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
                  if S_Threshold then begin
                    if RedColor > bST_Max then RedColor := bST_Max;
                    if RedColor < bST_Min then RedColor := 0;
                    if GreenColor > bST_Max then
                      GreenColor := bST_Max;
                    if GreenColor < bST_Min then GreenColor := 0;
                    if BlueColor > bST_Max then BlueColor := bST_Max;
                    if BlueColor < bST_Min then BlueColor := 0;
                  end;
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;
{      SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
                end; { of AutoRange Insider Edition}
        end; {OF WIDTH}

        if Autorange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, All_Min,
                All_Max);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {OF LENGTH}
    end; {of AutoRange}
    BlackOut;
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {of Makebitmap}
end;

{---------------------------------------------------------------------}
                {CMInspectRatioTexture}

procedure RatBoy(InFilterName: string; AutoTimes: Integer);
(*
Function WhatsMySize(FileName:String):Integer;
VAR
I,FilterSize,Code : Integer;
FileLen :Word;
BEGIN
FileLen := Length(FileName);
  I := FileLen - 1;
  while (I <> 0) and ( (FileName[I] <> '.')) do
    Dec(I); {Dec's while looking, then Inc's once to total a count}
    Inc(I,2);
    IF FileName[I] = 'r' THEN
    Begin
    Inc(I);
    Val(FileName[I],FilterSize,Code);
    IF Code <> 0 Then Begin Do_Error(1232,1240);
                      end else
        WhatsMySize := FilterSize;
    End Else Do_Error(1233,1240);
End;
*)
var
  SpatError: Boolean;
  Filter: array[-4..4, -4..4] of Double; {Integer;}
  ClassFile: file of Double; {Integer;}
  R_Min, G_Min, B_Min: Double {Single};
  R_Fd, G_Fd, B_Fd, RCenter, GCenter, BCenter,
    R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    Input, IsOne, R_Filtered, G_Filtered, B_Filtered: Double;
{  CenterPixel, TheColor:Longint;}
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range: Integer;
  Center, Size, IL, IW, FLength, FWidth, sX, sY, Where: Dword;
begin {Get current Window DC}
  SpatError := FALSE;
  IsOne := 0;
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
  Assign(ClassFile, InFilterName);
  Reset(ClassFile);
  {Filter extension ie. FL3, FL5, FL7, FL9: Size of Filter}
  HowMany := WhatsMySize(InFilterName);
  {Negative of 3/2=1.5=1; 5/2=2.5=2; 7/2=3.5=3; 9/2=4.5=4}
  {Determines the starting point of Filter convolution
   Allows retreiving pixel data for the matrix around the
   current PIXEL being filtered}
  Where := (-Trunc(HowMany / 2));
  for FLength := 0 to (HowMany - 1) do begin
    for FWidth := 0 to (HowMany - 1) do
    begin
      Read(ClassFile, Input);
      Filter[(FWidth + Where), (FLength + Where)] := Input;
      IsOne := IsOne + Input;
    end;
  end;
  Close(ClassFile);
    {Wait a second and let Windows talk to itself}
    {?? how to??}
    {This seems wrong but it works better...}
  Center := (Trunc(HowMany / 2) {+1});
     {Begin of Whole Autorange = True... Do Twice}
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255; {or 256?}
      G_Range := G_Max - G_Min;
      G_Range := G_Range / 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / 255;
      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
          R_Filtered := 0;
          G_Filtered := 0;
          B_Filtered := 0;
   {    CenterPixel := GetPixel(hUnDoDC, IW,IL);}
          WherePixel := ((3 * IW) + (BytesPerLine * IL));
          pPixelB := @PHugeByteArray(Undo)^[WherePixel];
          pPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
          pPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
          BCenter := pPixelB^;
          GCenter := pPixelG^;
          RCenter := pPixelR^;

        {Cannot divide by Zero... 0/1 = 0 }
       { RCenter:= GetRValue(CenterPixel); }
          if RCenter = 0 then RCenter := 1
          else RCenter := RCenter * Filter[0, 0];
       { GCenter:= GetGValue(CenterPixel);}
          if GCenter = 0 then GCenter := 1
          else GCenter := GCenter * Filter[0, 0]; ;
        {BCenter:= GetBValue(CenterPixel);}
          if BCenter = 0 then BCenter := 1
          else BCenter := BCenter * Filter[0, 0]; ;

          for sY := 0 to (HowMany - 1) do begin
            for sX := 0 to (HowMany - 1) do begin
         {Get the Center Pixel}
     {    TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor); }
              WherePixel := (3 * (IW + (sX + Where))) + (BytesPerLine
                * (((IL + sY + Where))));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueColor := lpPixelB^;
              GreenColor := lpPixelG^;
              RedColor := lpPixelR^;

              R_Fd := ((RedColor * Filter[(sX + Where), (sY +
                  Where)]));
              G_Fd := ((GreenColor * Filter[(sX + Where), (sY +
                  Where)]));
              B_Fd := ((BlueColor * Filter[(sX + Where), (sY +
                  Where)]));

         {Do not do the center ... it would be one
         and mess with the total, and the Center = 1 stuff}
              if (sX <> Center) and (sY <> Center) then
{         IF ((sX+Where <> 0) AND (sY+Where<>0)) Then}

              begin
                R_Filtered := (R_Filtered +
                  (R_Fd / RCenter));
                G_Filtered := (G_Filtered +
                  (G_Fd / GCenter));
                B_Filtered := (B_Filtered +
                  (B_Fd / BCenter));
              end; {of If Center}
            end; { Filter Width}
          end; {Filter Length}
          if V_Absolute then begin
            if R_Filtered < 0 then R_Filtered := (R_Filtered * -1);
            if G_Filtered < 0 then G_Filtered := (G_Filtered * -1);
            if B_Filtered < 0 then B_Filtered := (B_Filtered * -1);
          end;
          if R_AutoTT then begin
            if R_Filtered > dAT_Max then R_Filtered := dAT_Max;
            if R_Filtered < dAT_Min then R_Filtered := dAT_Min;
            if G_Filtered > dAT_Max then G_Filtered := dAT_Max;
            if G_Filtered < dAT_Min then G_Filtered := dAT_Min;
            if B_Filtered > dAT_Max then B_Filtered := dAT_Max;
            if B_Filtered < dAT_Min then B_Filtered := dAT_Min;
          end;
          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Filtered > R_Max then R_Max := R_Filtered;
              if G_Filtered > G_Max then G_Max := G_Filtered;
              if B_Filtered > B_Max then B_Max := B_Filtered;
{This uses the filtered and min because the result evaluates
the filtered}
              if R_Filtered < R_Min then R_Min := R_Filtered;
              if G_Filtered < G_Min then G_Min := G_Filtered;
              if B_Filtered < B_Min then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
{       IF R_Min < 0 Then R_Min := (R_Min * -1);}
              R_Filtered := (R_Filtered - (R_Min)) / R_Range;
{       IF G_Min < 0 Then G_Min := (G_Min * -1);}
              G_Filtered := (G_Filtered - (G_Min)) / G_Range;
{       IF B_Min < 0 Then B_Min := (B_Min * -1);}
              B_Filtered := (B_Filtered - (B_Min)) / B_Range;
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);

              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);

              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end;
          end else
            if {Do_Absolute, AutoRange, Do_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end else

              if {Do_Absolute, AutoRange,}  Do_Ex_com
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
{       R_Hope := Round(R_Filtered*100);}
{       IF R_Filtered < 0 then R_Filtered := (R_Filtered * -1);}
                if R_Filtered < 1 then
                  R_Filtered := ((R_Filtered * 127) + 1) else
                  if R_Filtered >= 1 then
                    R_Filtered := (128 + (R_Filtered / 2));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
{       G_Filtered := Round(G_Filtered*100);}
{       IF G_Filtered < 0 then G_Filtered := (G_Filtered * -1);}
                if G_Filtered < 1 then
                  G_Filtered := ((G_Filtered * 127) + 1) else
                  if G_Filtered >= 1 then
                    G_Filtered := (128 + (G_Filtered / 2));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
{       B_Filtered := Round(B_Filtered*100);}
{       IF B_Filtered < 0 then B_Filtered := (B_Filtered * -1);}
                if B_Filtered < 1 then
                  B_Filtered := ((B_Filtered * 127) + 1) else
                  if B_Filtered >= 1 then
                    B_Filtered := (128 + (B_Filtered / 2));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
                if S_Threshold then begin
                  if RedColor > bST_Max then RedColor := bST_Max;
                  if RedColor < bST_Min then RedColor := 0;
                  if GreenColor > bST_Max then GreenColor := bST_Max;
                  if GreenColor < bST_Min then GreenColor := 0;
                  if BlueColor > bST_Max then BlueColor := bST_Max;
                  if BlueColor < bST_Min then BlueColor := 0;
                end;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
              end else
                if {Do_Absolute, AutoRange, Do_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
                  if S_Threshold then begin
                    if RedColor > bST_Max then RedColor := bST_Max;
                    if RedColor < bST_Min then RedColor := 0;
                    if GreenColor > bST_Max then
                      GreenColor := bST_Max;
                    if GreenColor < bST_Min then GreenColor := 0;
                    if BlueColor > bST_Max then BlueColor := bST_Max;
                    if BlueColor < bST_Min then BlueColor := 0;
                  end;
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
                end; { of AutoRange Insider Edition}
        end; {of  Image Width}

        if (Range = 0) then
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done(1, Per_Done
            {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
        end else
          if (Range = 1) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(2, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done1(Per_Done);
          end;
      end; {of Image Length}
    end; {of AutoRange}
    BlackOut;
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
end; {of Ratboy}
{---------------------------------------------------------------------}
                 {CMInspectP_Slope}

procedure BatGirl(InFilterName: string; AutoTimes: Integer);
(*
Function WhatsMySize(FileName:String):Integer;
VAR
I,FilterSize,Code : Integer;
FileLen :Word;
BEGIN
FileLen := Length(FileName);
  I := FileLen - 1;
  while (I <> 0) and ( (FileName[I] <> '.')) do
    Dec(I); {Dec's while looking, then Inc's once to total a count}
    Inc(I,2);
    IF FileName[I] = 'r' THEN
    Begin
    Inc(I);
    Val(FileName[I],FilterSize,Code);
    IF Code <> 0 Then Begin Do_Error(1232,1241);
                      end else
        WhatsMySize := FilterSize;
    End Else Do_Error(1232,1241);
End;*)
var
  Filter: array[-4..4, -4..4] of Double; {Integer;}
  ClassFile: file of Double; {Integer;}
  {DirectionX, DirectionY, TheDirection : Integer;}
  R_Min, G_Min, B_Min, R_Mins, G_Mins, B_Mins: Double {Single};
  R_Range, R_Maxs, G_Range, G_Maxs, B_Range, B_Maxs,
    R_Max, G_Max, B_Max,
    InPut, IsOne,
    RCenter, GCenter, BCenter,
    R_Filtered, G_Filtered, B_Filtered: Double;
  CenterPixel, TheColor: Longint;
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range: Integer;
  Center, FLength, FWidth, IL, IW, sX, sY, Where: DWord;
begin {Get current Window DC}
{  SpatError := FALSE;}
  IsOne := 0;
  R_Maxs := 0;
  R_Mins := 255;
  G_Maxs := 0;
  G_Mins := 255;
  B_Maxs := 0;
  B_Mins := 255;
  R_Max := 0.0;
  G_Max := 0.0;
  B_Max := 0.0;
  R_Min := 255.0;
  G_Min := 255.0;
  B_Min := 255.0;
  Assign(ClassFile, InFilterName);
  Reset(ClassFile);
  {Filter extension ie. FL3, FL5, FL7, FL9: Size of Filter}
  HowMany := WhatsMySize(InFilterName);
  {Negative of 3/2=1.5=1; 5/2=2.5=2; 7/2=3.5=3; 9/2=4.5=4}
  {Determines the starting point of Filter convolution
   Allows retrieving pixel data for the matrix around the
   current PIXEL being filtered}
  Where := (-Trunc(HowMany / 2));
    {This seems wrong but it works better...
    due to maxing the area it becomes grey
    this moves it off center aand thus offsets it to
    become like a embossing or something}
    {NO... 5/2 =2.5 = 2 = 2+1}
  Center := (Trunc(HowMany / 2) + 1);
  for FLength := 0 to (HowMany - 1) do begin
    for FWidth := 0 to (HowMany - 1) do
    begin
      Read(ClassFile, Input);
      Filter[(FWidth + Where), (FLength + Where)] := Input;
      IsOne := IsOne + Input;
    end;
  end;
  Close(ClassFile);
    {Wait a second and let Windows talk to itself}
    {?? how to??}
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Maxs - R_Mins;
      R_Range := R_Range / 255; {or 256?}
      G_Range := G_Maxs - G_Mins;
      G_Range := G_Range / 255;
      B_Range := B_Maxs - B_Mins;
      B_Range := B_Range / 255;
      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
{  DirectionX, DirectionY, TheDirection : Integer;
  R_Max, G_Max, B_Max,}
          R_Max := 0.0;
          G_Max := 0.0;
          B_Max := 0.0;
          R_Min := 255.0;
          G_Min := 255.0;
          B_Min := 255.0;
          R_Filtered := 0.0;
          G_Filtered := 0.0;
          B_Filtered := 0.0;
         {Get the Center Pixel}
{       CenterPixel := GetPixel(hUnDoDC, IW,IL);}
          WherePixel := ((3 * IW) + (BytesPerLine * IL));
          pPixelB := @PHugeByteArray(Undo)^[WherePixel];
          pPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
          pPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
          BCenter := pPixelB^;
          GCenter := pPixelG^;
          RCenter := pPixelR^;

{        RCenter:= GetRValue(CenterPixel);}
          if RCenter = 0 then RCenter := 0.1;
        {else} RCenter := RCenter * Filter[0, 0];
{        GCenter:= GetGValue(CenterPixel);}
          if GCenter = 0 then GCenter := 0.1;
        {else} GCenter := GCenter * Filter[0, 0];
{        BCenter:= GetBValue(CenterPixel);}
          if BCenter = 0 then BCenter := 0.1;
        {else} BCenter := BCenter * Filter[0, 0]; ;

          for sY := 0 to (HowMany - 1) do begin
            for sX := 0 to (HowMany - 1) do begin
{         TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor);}
              WherePixel := (3 * (IW + (sX + Where))) + (BytesPerLine
                * (((IL + sY + Where))));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueColor := lpPixelB^;
              GreenColor := lpPixelG^;
              RedColor := lpPixelR^;

              R_Filtered := ((RedColor * Filter[(sX + Where), (sY +
                  Where)]));
              G_Filtered := ((GreenColor * Filter[(sX + Where), (sY +
                  Where)]));
              B_Filtered := ((BlueColor * Filter[(sX + Where), (sY +
                  Where)]));

  {Too heavy, save for DTM Monochrome
  DirectionX, DirectionY, TheDirection : Integer;}
              if ((sX + Where <> 0) and (sY + Where <> 0)) then
{         IF ((sX <> Center) AND (sY <> Center)) Then}
              begin
                R_Filtered := (R_Filtered {RedColor} / RCenter);
                G_Filtered := (G_Filtered {GreenColor} / GCenter);
                B_Filtered := (B_Filtered {BlueColor} / BCenter);
                if V_Absolute then begin
                  if R_Filtered < 0 then
                    R_Filtered := (R_Filtered * -1);
                  if G_Filtered < 0 then
                    G_Filtered := (G_Filtered * -1);
                  if B_Filtered < 0 then
                    B_Filtered := (B_Filtered * -1);
                end;
                if R_AutoTT then begin
                  if R_Filtered > dAT_Max then R_Filtered := dAT_Max;
                  if R_Filtered < dAT_Min then R_Filtered := dAT_Min;
                  if G_Filtered > dAT_Max then G_Filtered := dAT_Max;
                  if G_Filtered < dAT_Min then G_Filtered := dAT_Min;
                  if B_Filtered > dAT_Max then B_Filtered := dAT_Max;
                  if B_Filtered < dAT_Min then B_Filtered := dAT_Min;
                end;
                if R_Filtered > R_Max then R_Max := R_Filtered;
                if R_Max < R_Min then R_Min := R_Max;
                if G_Filtered > G_Max then G_Max := G_Filtered;
                if G_Max < G_Min then G_Min := G_Max;
                if B_Filtered > B_Max then B_Max := B_Filtered;
                if B_Max < B_Min then B_Min := B_Max;
              end;
            end; { Filter Width}
          end; {Filter Length}

          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Maxs < R_Max then R_Maxs := R_Max;
              if R_Mins > R_Min then R_Mins := R_Min;
              if G_Maxs < G_Max then G_Maxs := G_Max;
              if G_Mins > G_Min then G_Mins := G_Min;
              if B_Maxs < B_Max then B_Maxs := B_Max;
              if B_Mins > B_Min then B_Mins := B_Min;
            end;
            if Range = 1 then begin
{       IF R_Min < 0 Then R_Min := (R_Min * -1);}
              R_Max := (R_Max - (R_Mins)) / R_Range;
{       IF G_Min < 0 Then G_Min := (G_Min * -1);}
              G_Max := (G_Max - (G_Mins)) / G_Range;
{       IF B_Min < 0 Then B_Min := (B_Min * -1);}
              B_Max := (B_Max - (B_Mins)) / B_Range;
              if R_Max > 255 then R_Max := 255;
              if R_Max < 0 then R_Max := 0;
              RedColor := Round(R_Max);
              if G_Max > 255 then G_Max := 255;
              if G_Max < 0 then G_Max := 0;
              GreenColor := Round(G_Max);
              if B_Max > 255 then B_Max := 255;
              if B_Max < 0 then B_Max := 0;
              BlueColor := Round(B_Max);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{      SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));      }
            end;
          end else
            if {Do_Absolute, AutoRange,}  Do_Ex_com
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
  (**) if R_Max < 1.0 then
                R_Filtered := (Round((R_Max * 127) + 1)) else
                if R_Max >= 1.0 then
                  R_Filtered := (Round(128 + (R_Max / 2)));
              if G_Max < 1.0 then
                G_Filtered := (Round((G_Max * 127) + 1)) else
                if G_Max >= 1.0 then
                  G_Filtered := (Round(128 + (G_Max / 2)));
              if B_Max < 1.0 then
                B_Filtered := (Round((B_Max * 127) + 1)) else
                if B_Max >= 1.0 then
                  B_Filtered := (Round(128 + (B_Max / 2)));
(**)
(*
R_Filtered := ((R_Max*100));
G_Filtered := ((G_Max*100));
B_Filtered := ((B_Max*100));
*)
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end else
              if {Do_Absolute, AutoRange, Do_Ex_com}  BelowZero
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                  127));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                  127));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                  127));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
                if S_Threshold then begin
                  if RedColor > bST_Max then RedColor := bST_Max;
                  if RedColor < bST_Min then RedColor := 0;
                  if GreenColor > bST_Max then GreenColor := bST_Max;
                  if GreenColor < bST_Min then GreenColor := 0;
                  if BlueColor > bST_Max then BlueColor := bST_Max;
                  if BlueColor < bST_Min then BlueColor := 0;
                end;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
              end else

                if {Do_Absolute, AutoRange, Do_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
                  if S_Threshold then begin
                    if RedColor > bST_Max then RedColor := bST_Max;
                    if RedColor < bST_Min then RedColor := 0;
                    if GreenColor > bST_Max then
                      GreenColor := bST_Max;
                    if GreenColor < bST_Min then GreenColor := 0;
                    if BlueColor > bST_Max then BlueColor := bST_Max;
                    if BlueColor < bST_Min then BlueColor := 0;
                  end;
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
                end;
        end; {of  Image Width}

        if Autorange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, All_Min,
                All_Max);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {of Image Length}
    end; {of AutoRange}
    BlackOut;
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {of Makebitmap}
end; {End of Ratio Max}

{---------------------------------------------------------------------}

procedure Do_SobelFile(InFilterName: string; AutoTimes: Integer);
(*
Function WhatsMySize(FileName:String):Integer;
VAR
I,FilterSize,Code : Integer;
FileLen :Word;
BEGIN
FileLen := Length(FileName);
  I := FileLen - 1;
  while (I <> 0) and ( (FileName[I] <> '.')) do
    Dec(I); {Dec's while looking, then Inc's once to total a count}
    Inc(I,2);
    IF FileName[I] = '2' THEN
    Begin
    Inc(I);
    Val(FileName[I],FilterSize,Code);
    IF Code <> 0 Then Begin Do_Error(1232,1236);
                      end else
        WhatsMySize := FilterSize;
    End Else Do_Error(1233,1236);
End;  *)
var
  SpatError: Boolean;
  FandCFilter, Filter1, Filter2: array[0..81] of Double;
  Filter: array[-4..4, -4..4] of Double; {Integer;}
  ClassFile: file of Double; {Integer;}
  R_Min, G_Min, B_Min: Double {Single};
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    SobelR1, SobelR2, SobelG1, SobelG2, SobelB1, SobelB2,
    Input, IsOne, IsOneWhat, IsOneIs, {: Integer;}
    R_Filtered, G_Filtered, B_Filtered: Double;
  TheColor: Longint;
  OutByte, RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, IamFandC, Ido, Range: Integer;
  IL, IW, FLength, FWidth, sX, sY, Where: Dword;
begin {Get current Window DC}
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;

  SpatError := FALSE;
{  Begin  Do the Filter load and work
  IsOne :=0;}
  Assign(ClassFile, InFilterName);
  Reset(ClassFile);
    {Filter extension ie. FL3, FL5, FL7, FL9: Size of Filter}
  HowMany := WhatsMySize(InFilterName);
  Where := (-Trunc(HowMany / 2));
    {Negative of 3/2=1.5=1; 5/2=2.5=2; 7/2=3.5=3; 9/2=4.5=4}
    {Determines the starting point of Filter convolution
     Allows retreiving pixel data for the matrix around the
     current PIXEL being filtered}
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter1[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter2[(Ido)] := Input;
  end;
  Close(ClassFile);
    {Wait a second and let Windows talk to itself}
    {?? how to??}
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255; {or 256}
      G_Range := G_Max - G_Min;
      G_Range := G_Range / 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / 255;
      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin

          for IamFandC := 1 to 2 do
          begin
            R_Filtered := 0;
            G_Filtered := 0;
            B_Filtered := 0;
            case IamFandC of
              1: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter1[Ido];
              2: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter2[Ido];
            end;
            IDo := 0;
            for FLength := 0 to (HowMany - 1) do begin
              for FWidth := 0 to (HowMany - 1) do
              begin
                Input := FandCFilter[Ido];
                inc(Ido);
                Filter[(FWidth + Where), (FLength + Where)] := Input;
              end;
            end;

            for sY := 0 to (HowMany - 1) do begin
              for sX := 0 to (HowMany - 1) do begin
{         TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor);}
                WherePixel := (3 * (IW + (sX + Where))) +
                  (BytesPerLine * (((IL + sY + Where))));
                lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
                lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
                BlueColor := lpPixelB^;
                GreenColor := lpPixelG^;
                RedColor := lpPixelR^;

                R_Filtered := (R_Filtered +
                  (RedColor * Filter[(sX + Where), (sY + Where)]));
                G_Filtered := (G_Filtered +
                  (GreenColor * Filter[(sX + Where), (sY + Where)]));
                B_Filtered := (B_Filtered +
                  (BlueColor * Filter[(sX + Where), (sY + Where)]));
              end;
            end;
            R_Filtered := (SQR(R_Filtered));
            G_Filtered := (SQR(G_Filtered));
            B_Filtered := (SQR(B_Filtered));
            if IamFandC = 1 then begin
              SobelR1 := R_Filtered;
              SobelG1 := G_Filtered;
              SobelB1 := B_Filtered;
            end;
            if IamFandC = 2 then begin
              SobelR2 := R_Filtered;
              SobelG2 := G_Filtered;
              SobelB2 := B_Filtered;
            end;

          end; {OF IamFandC ...DO IT TWICE}
          R_Filtered := SQRT(SobelR1 + SobelR2);
          G_Filtered := SQRT(SobelG1 + SobelG2);
          B_Filtered := SQRT(SobelB1 + SobelB2);
          if V_Absolute then begin
            if R_Filtered < 0 then R_Filtered := (R_Filtered * -1);
            if G_Filtered < 0 then G_Filtered := (G_Filtered * -1);
            if B_Filtered < 0 then B_Filtered := (B_Filtered * -1);
          end;
          if R_AutoTT then begin
            if R_Filtered > dAT_Max then R_Filtered := dAT_Max;
            if R_Filtered < dAT_Min then R_Filtered := dAT_Min;
            if G_Filtered > dAT_Max then G_Filtered := dAT_Max;
            if G_Filtered < dAT_Min then G_Filtered := dAT_Min;
            if B_Filtered > dAT_Max then B_Filtered := dAT_Max;
            if B_Filtered < dAT_Min then B_Filtered := dAT_Min;
          end;
          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Max < R_Filtered then R_Max := R_Filtered;
              if R_Min > R_Filtered then R_Min := R_Filtered;
              if G_Max < G_Filtered then G_Max := G_Filtered;
              if G_Min > G_Filtered then G_Min := G_Filtered;
              if B_Max < B_Filtered then B_Max := B_Filtered;
              if B_Min > B_Filtered then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
{       IF R_Min < 0 Then R_Min := (R_Min * -1);}
              R_Filtered := (R_Filtered - (R_Min)) / R_Range;
{       IF G_Min < 0 Then G_Min := (G_Min * -1);}
              G_Filtered := (G_Filtered - (G_Min)) / G_Range;
{       IF B_Min < 0 Then B_Min := (B_Min * -1);}
              B_Filtered := (B_Filtered - (B_Min)) / B_Range;
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{      SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));      }
            end;
          end else
            if {Do_Absolute, AutoRange, Do_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end else

            begin {Does NOT DO Do_Ex_com so just do ClipR...}
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
            end;
        end; {OF WIDTH}

        if Autorange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, All_Min,
                All_Max);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {OF LENGTH}
    end; {of AutoRange}
    BlackOut;
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
end;


{---------------------------------------------------------------------}

procedure Do_SoDogFile(InFilterName: string; AutoTimes: Integer);
(*
Function WhatsMySize(FileName:String):Integer;
VAR
I,FilterSize,Code : Integer;
FileLen :Word;
BEGIN
FileLen := Length(FileName);
  I := FileLen - 1;
  while (I <> 0) and ( (FileName[I] <> '.')) do
    Dec(I); {Dec's while looking, then Inc's once to total a count}
    Inc(I,2);
    IF FileName[I] = '2' THEN
    Begin
    Inc(I);
    Val(FileName[I],FilterSize,Code);
    IF Code <> 0 Then Begin Do_Error(1232,1237);
                      end else
        WhatsMySize := FilterSize;
    End Else Do_Error(1233,1237);
End;*)
var
  SpatError: Boolean;
  FandCFilter, Filter1, Filter2: array[0..81] of Double;
  Filter: array[-4..4, -4..4] of Double; {Integer;}
  ClassFile: file of Double; {Integer;}
  R_Min, G_Min, B_Min: Double {Single};
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    SobelR1, SobelR2, SobelG1, SobelG2, SobelB1, SobelB2,
    Input, IsOne, IsOneWhat, IsOneIs, {: Integer;}
    R_Filtered, G_Filtered, B_Filtered: Double;
  TheColor: Longint;
  OutByte, RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, IamFandC, Ido, Range: Integer;
  IL, IW, FLength, FWidth, sX, sY, Where: DWord;
begin {Get current Window DC}
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;

  SpatError := FALSE;
{  Begin  Do the Filter load and work
  IsOne :=0;}
  Assign(ClassFile, InFilterName);
  Reset(ClassFile);
    {Filter extension ie. FL3, FL5, FL7, FL9: Size of Filter}
  HowMany := WhatsMySize(InFilterName);
  Where := (-Trunc(HowMany / 2));
    {Negative of 3/2=1.5=1; 5/2=2.5=2; 7/2=3.5=3; 9/2=4.5=4}
    {Determines the starting point of Filter convolution
     Allows retreiving pixel data for the matrix around the
     current PIXEL being filtered}
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter1[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter2[(Ido)] := Input;
  end;
  Close(ClassFile);
    {Wait a second and let Windows talk to itself}
    {?? how to??}
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
  MakeImage;
  if (ImageMade = TRUE) then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255; {or 256}
      G_Range := G_Max - G_Min;
      G_Range := G_Range / 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / 255;
      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin

          for IamFandC := 1 to 2 do
          begin
            R_Filtered := 0;
            G_Filtered := 0;
            B_Filtered := 0;
            case IamFandC of
              1: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter1[Ido];
              2: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter2[Ido];
            end;
            IDo := 0;
            for FLength := 0 to (HowMany - 1) do begin
              for FWidth := 0 to (HowMany - 1) do
              begin
                Input := FandCFilter[Ido];
                inc(Ido);
                Filter[(FWidth + Where), (FLength + Where)] := Input;
              end;
            end;

            for sY := 0 to (HowMany - 1) do begin
              for sX := 0 to (HowMany - 1) do begin
        { TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor); }
                WherePixel := (3 * (IW + (sX + Where))) +
                  (BytesPerLine * (((IL + sY + Where))));
                lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
                lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
                BlueColor := lpPixelB^;
                GreenColor := lpPixelG^;
                RedColor := lpPixelR^;

                R_Filtered := (R_Filtered +
                  (RedColor * Filter[(sX + Where), (sY + Where)]));
                G_Filtered := (G_Filtered +
                  (GreenColor * Filter[(sX + Where), (sY + Where)]));
                B_Filtered := (B_Filtered +
                  (BlueColor * Filter[(sX + Where), (sY + Where)]));
              end;
            end;
{       R_Filtered := (SQR(R_Filtered));
        G_Filtered := (SQR(G_Filtered));
        B_Filtered := (SQR(B_Filtered));}
            if IamFandC = 1 then begin
              SobelR1 := R_Filtered;
              SobelG1 := G_Filtered;
              SobelB1 := B_Filtered;
            end;
            if IamFandC = 2 then begin
              if R_Filtered = 0 then R_Filtered := 0.001;
              SobelR2 := R_Filtered;
              if G_Filtered = 0 then G_Filtered := 0.001;
              SobelG2 := G_Filtered;
              if B_Filtered = 0 then B_Filtered := 0.001;
              SobelB2 := B_Filtered;
            end;

          end; {OF SobelDOGarctan ...DO IT TWICE}
          R_Filtered := arctan(ABS(SobelR1 / SobelR2));
          G_Filtered := arctan(ABS(SobelG1 / SobelG2));
          B_Filtered := arctan(ABS(SobelB1 / SobelB2));
          if V_Absolute then begin
            if R_Filtered < 0 then R_Filtered := (R_Filtered * -1);
            if G_Filtered < 0 then G_Filtered := (G_Filtered * -1);
            if B_Filtered < 0 then B_Filtered := (B_Filtered * -1);
          end;
          if R_AutoTT then begin
            if R_Filtered > dAT_Max then R_Filtered := dAT_Max;
            if R_Filtered < dAT_Min then R_Filtered := dAT_Min;
            if G_Filtered > dAT_Max then G_Filtered := dAT_Max;
            if G_Filtered < dAT_Min then G_Filtered := dAT_Min;
            if B_Filtered > dAT_Max then B_Filtered := dAT_Max;
            if B_Filtered < dAT_Min then B_Filtered := dAT_Min;
          end;
          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Max < R_Filtered then R_Max := R_Filtered;
              if R_Min > R_Filtered then R_Min := R_Filtered;
              if G_Max < G_Filtered then G_Max := G_Filtered;
              if G_Min > G_Filtered then G_Min := G_Filtered;
              if B_Max < B_Filtered then B_Max := B_Filtered;
              if B_Min > B_Filtered then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
{       IF R_Min < 0 Then R_Min := (R_Min * -1);}
              R_Filtered := ((R_Filtered - (R_Min)) / R_Range);
{       IF G_Min < 0 Then G_Min := (G_Min * -1);}
              G_Filtered := ((G_Filtered - (G_Min)) / G_Range);
{       IF B_Min < 0 Then B_Min := (B_Min * -1);}
              B_Filtered := ((B_Filtered - (B_Min)) / B_Range);
(*       IF R_Filtered < 1 then R_Filtered := ((R_Filtered*127)+1) else
       IF R_Filtered >= 1 then R_Filtered := (128+(R_Filtered/2));
*)
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);

(*       IF G_Filtered < 1 then G_Filtered := ((G_Filtered*127)+1) else
       IF G_Filtered >= 1 then G_Filtered := (128+(G_Filtered/2));
*)
{       G_Filtered := Round(G_Filtered);}
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
(*       IF B_Filtered < 1 then B_Filtered := ((B_Filtered*127)+1) else
       IF B_Filtered >= 1 then B_Filtered := (128+(B_Filtered/2));
*)
{       B_Filtered := Round(B_Filtered);}
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end;
          end else
            if {Do_Absolute, AutoRange, Do_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end else

              if {Do_Absolute, AutoRange,}  Do_Ex_com
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
                if R_Filtered < 1 then
                  R_Filtered := ((R_Filtered * 127) + 1) else
                  if R_Filtered >= 1 then
                    R_Filtered := (128 + (R_Filtered / 2));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
                if G_Filtered < 1 then
                  G_Filtered := ((G_Filtered * 127) + 1) else
                  if G_Filtered >= 1 then
                    G_Filtered := (128 + (G_Filtered / 2));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
                if B_Filtered < 1 then
                  B_Filtered := ((B_Filtered * 127) + 1) else
                  if B_Filtered >= 1 then
                    B_Filtered := (128 + (B_Filtered / 2));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
                if S_Threshold then begin
                  if RedColor > bST_Max then RedColor := bST_Max;
                  if RedColor < bST_Min then RedColor := 0;
                  if GreenColor > bST_Max then GreenColor := bST_Max;
                  if GreenColor < bST_Min then GreenColor := 0;
                  if BlueColor > bST_Max then BlueColor := bST_Max;
                  if BlueColor < bST_Min then BlueColor := 0;
                end;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
              end else
                if {Do_Absolute, AutoRange, Do_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
                  if S_Threshold then begin
                    if RedColor > bST_Max then RedColor := bST_Max;
                    if RedColor < bST_Min then RedColor := 0;
                    if GreenColor > bST_Max then
                      GreenColor := bST_Max;
                    if GreenColor < bST_Min then GreenColor := 0;
                    if BlueColor > bST_Max then BlueColor := bST_Max;
                    if BlueColor < bST_Min then BlueColor := 0;
                  end;
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
                end;
        end; {OF WIDTH}

        if Autorange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if Autorange then begin
              if (Range = 1) then
              begin
                Per_Done := Round(100 * (IL / (ImageHeight)));
                SetP_Done(2, Per_Done
                  {inWindow: HWND; iPercentDone: integer}, 0, 0);
              end
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {OF LENGTH}
    end; {of AutoRange}
    BlackOut;
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
end;
{---------------------------------------------------------------------}

procedure Do_Rotate8SQRTFile(InFilterName: string; AutoTimes, Ranger,
  Rangette: Integer);
(*
Function WhatsMySize(FileName:String):Integer;
VAR
I,FilterSize,Code : Integer;
FileLen :Word;
BEGIN
FileLen := Length(FileName);
  I := FileLen - 1;
  while (I <> 0) and ( (FileName[I] <> '.')) do
    Dec(I); {Dec's while looking, then Inc's once to total a count}
    Inc(I,2);
    IF FileName[I] = '8' THEN
    Begin
    Inc(I);
    Val(FileName[I],FilterSize,Code);
    IF Code <> 0 Then Begin Do_Error(1232,1238);
                      end else
        WhatsMySize := FilterSize;
    End Else Do_Error(1233,1238);
End;
*)
var
  SpatError: Boolean;
  FandCFilter,
    Filter1, Filter2, Filter3, Filter4,
    Filter5, Filter6, Filter7, Filter8: array[0..25] of Double;
  Filter: array[-4..4, -4..4] of Double; {Integer;}
  ClassFile: file of Double; {Integer;}
  G_Min, R_Min, B_Min: Double {Single};
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    R_Maxk, R_Mink, G_Maxk, G_Mink, B_Maxk, B_Mink,
    Input, IsOne,
    R_Filtered, G_Filtered, B_Filtered: Double;
  WorkColor, TheColor: Longint;
  WorkRedColor, WorkBlueColor, WorkGreenColor,
    RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, IamFandC, Ido, Range: Integer;
  IL, IW, FLength, FWidth, sX, sY, Where: DWord;
begin {Get current Window DC}

{   R_Mink  :=255;
   G_Mink  :=255;
   B_Mink :=255;}
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
  IsOne := 0;
  SpatError := FALSE;
  Assign(ClassFile, InFilterName);
  Reset(ClassFile);
    {Filter extension ie. FL3, FL5, FL7, FL9: Size of Filter}
  HowMany := WhatsMySize(InFilterName);
  Where := (-Trunc(HowMany / 2));
    {Negative of 3/2=1.5=1; 5/2=2.5=2; 7/2=3.5=3; 9/2=4.5=4}
    {Determines the starting point of Filter convolution
     Allows retreiving pixel data for the matrix around the
     current PIXEL being filtered}
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter1[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter2[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter3[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter4[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter5[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter6[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter7[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter8[(Ido)] := Input;
  end;
  Close(ClassFile);
    {Wait a second and let Windows talk to itself}
    {?? how to??}
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / Ranger; {or 256?}
      G_Range := G_Max - G_Min;
      G_Range := G_Range / Ranger;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / Ranger;
      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
          R_Maxk := 0;
          G_Maxk := 0;
          B_Maxk := 0;
          for IamFandC := 1 to 8 do
          begin
            R_Filtered := 0;
            G_Filtered := 0;
            B_Filtered := 0;
            case IamFandC of
              1: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter1[Ido];
              2: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter2[Ido];
              3: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter3[Ido];
              4: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter4[Ido];
              5: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter5[Ido];
              6: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter6[Ido];
              7: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter7[Ido];
              8: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter8[Ido];
            end;
            IDo := 0;
            for FLength := 0 to (HowMany - 1) do begin
              for FWidth := 0 to (HowMany - 1) do
              begin
                Input := FandCFilter[Ido];
                inc(Ido);
                Filter[(FWidth + Where), (FLength + Where)] := Input;
                IsOne := IsOne + Input;
              end;
            end;

            for sY := 0 to (HowMany - 1) do begin
              for sX := 0 to (HowMany - 1) do begin
       {  TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor);  }
                WherePixel := (3 * (IW + (sX + Where))) +
                  (BytesPerLine * (((IL + sY + Where))));
                lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
                lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
                BlueColor := lpPixelB^;
                GreenColor := lpPixelG^;
                RedColor := lpPixelR^;

                R_Filtered := (R_Filtered +
                  (RedColor * Filter[(sX + Where), (sY + Where)]));
                G_Filtered := (G_Filtered +
                  (GreenColor * Filter[(sX + Where), (sY + Where)]));
                B_Filtered := (B_Filtered +
                  (BlueColor * Filter[(sX + Where), (sY + Where)]));
              end;
            end;
            R_Maxk := R_Maxk + (SQR(R_Filtered));
            G_Maxk := G_Maxk + (SQR(G_Filtered));
            B_Maxk := B_Maxk + (SQR(B_Filtered));

          end; {OF IamFandC ...DO IT 8 times}
          R_Filtered := SQRT(R_Maxk);
          G_Filtered := SQRT(G_Maxk);
          B_Filtered := SQRT(B_Maxk);
{          NOT NECESSARY due to being SQUARED
       IF Do_Absolute then Begin
       IF R_Filtered < 0 Then R_Filtered := (R_Filtered * -1);
       IF G_Filtered < 0 Then G_Filtered := (G_Filtered * -1);
       IF B_Filtered < 0 Then B_Filtered := (B_Filtered * -1);
       End;
}
          if R_AutoTT then begin
            if R_Filtered > dAT_Max then R_Filtered := dAT_Max;
            if R_Filtered < dAT_Min then R_Filtered := dAT_Min;
            if G_Filtered > dAT_Max then G_Filtered := dAT_Max;
            if G_Filtered < dAT_Min then G_Filtered := dAT_Min;
            if B_Filtered > dAT_Max then B_Filtered := dAT_Max;
            if B_Filtered < dAT_Min then B_Filtered := dAT_Min;
          end;
          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Filtered > R_Max then R_Max := R_Filtered;
              if G_Filtered > G_Max then G_Max := G_Filtered;
              if B_Filtered > B_Max then B_Max := B_Filtered;
              if R_Filtered < R_Min then R_Min := R_Filtered;
              if G_Filtered < G_Min then G_Min := G_Filtered;
              if B_Filtered < B_Min then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
{       IF R_Min < 0 Then R_Min := (R_Min * -1);}
{       IF G_Min < 0 Then G_Min := (G_Min * -1);}
              G_Filtered := ((G_Filtered - (G_Min)) / G_Range);
              R_Filtered := ((R_Filtered - (R_Min)) / R_Range);
{       IF B_Min < 0 Then B_Min := (B_Min * -1);}
              B_Filtered := ((B_Filtered - (B_Min)) / B_Range);

              if R_Filtered > 255 then R_Filtered := Rangette; {255;}
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);

              if G_Filtered > 255 then G_Filtered := Rangette; {255;}
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);

              if B_Filtered > 255 then B_Filtered := Rangette; {255;}
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);

              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end;
          end else
            if {Do_Absolute, AutoRange, Do_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end else

            begin {Does NOT DO Do_Ex_com so Default to ClipR...}
{       IF IsOne > 1 then R_Filtered := (R_Filtered/IsOne);}
              if R_Filtered > 255 then R_Filtered := Rangette;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);

{       IF IsOne > 1 then G_Filtered := (G_Filtered/IsOne);}
              if G_Filtered > 255 then G_Filtered := Rangette;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);

{       IF IsOne > 1 then B_Filtered := (B_Filtered/IsOne);}
              if B_Filtered > 255 then B_Filtered := Rangette;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);

              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end;

        end; {OF WIDTH}

        if AutoRange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, All_Min,
                All_Max);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {OF LENGTH}
    end; {of AutoRange}
    BlackOut;
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
end;


{---------------------------------------------------------------------}

procedure Do_Rotate8MaxFile(InFilterName: string; AutoTimes:
  Integer);
(*
Function WhatsMySize(FileName:String):Integer;
VAR
I,FilterSize,Code : Integer;
FileLen :Word;
BEGIN
FileLen := Length(FileName);
  I := FileLen - 1;
  while (I <> 0) and ( (FileName[I] <> '.')) do
    Dec(I); {Dec's while looking, then Inc's once to total a count}
    Inc(I,2);
    IF FileName[I] = '8' THEN
    Begin
    Inc(I);
    Val(FileName[I],FilterSize,Code);
    IF Code <> 0 Then Begin Do_Error(1232,1239);
                      end else
        WhatsMySize := FilterSize;
    End Else Do_Error(1233,1239);
End;*)
var
  SpatError: Boolean;
  FandCFilter,
    Filter1, Filter2, Filter3, Filter4,
    Filter5, Filter6, Filter7, Filter8: array[0..25] of Double;
  Filter: array[-4..4, -4..4] of Double; {Integer;}
  ClassFile: file of Double; {Integer;}
  R_Min, G_Min, B_Min: Double {Single};
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    R_Maxk, R_Mink, G_Maxk, G_Mink, B_Maxk, B_Mink,
{  SobelR1,SobelR2,SobelG1,SobelG2,SobelB1,SobelB2,}
  Input, { IsOne, IsOneWhat,IsOneIs, } {: Integer;}
    R_Filtered, G_Filtered, B_Filtered: Double;
  TheColor: Longint;
{  OutByte,} RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, IamFandC, Ido, Range: Integer;
  IL, IW, FLength, FWidth, sX, sY, Where: Dword;
begin {Get current Window DC}
  R_Maxk := 0;
  R_Mink := 255;
  G_Maxk := 0;
  G_Mink := 255;
  B_Maxk := 0;
  B_Mink := 255;
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
  SpatError := FALSE;
{  Begin  Do the Filter load and work
  IsOne :=0;}
  Assign(ClassFile, InFilterName);
  Reset(ClassFile);
    {Filter extension ie. FL3, FL5, FL7, FL9: Size of Filter}
  HowMany := WhatsMySize(InFilterName);
  Where := (-Trunc(HowMany / 2));
    {Negative of 3/2=1.5=1; 5/2=2.5=2; 7/2=3.5=3; 9/2=4.5=4}
    {Determines the starting point of Filter convolution
     Allows retreiving pixel data for the matrix around the
     current PIXEL being filtered}
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter1[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter2[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter3[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter4[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter5[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter6[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter7[(Ido)] := Input;
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter8[(Ido)] := Input;
  end;
  Close(ClassFile);
    {Wait a second and let Windows talk to itself}
    {?? how to??}
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Maxk - R_Mink;
      R_Range := R_Range / 255; {or 256?}
      G_Range := G_Maxk - G_Mink;
      G_Range := G_Range / 255;
      B_Range := B_Maxk - B_Mink;
      B_Range := B_Range / 255;
      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
          R_Max := 0;
          R_Min := 255;
          G_Max := 0;
          G_Min := 255;
          B_Max := 0;
          B_Min := 255;
          for IamFandC := 1 to 8 do
          begin
            R_Filtered := 0;
            G_Filtered := 0;
            B_Filtered := 0;
            case IamFandC of
              1: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter1[Ido];
              2: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter2[Ido];
              3: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter3[Ido];
              4: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter4[Ido];
              5: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter5[Ido];
              6: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter6[Ido];
              7: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter7[Ido];
              8: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter8[Ido];
            end;
            IDo := 0;
            for FLength := 0 to (HowMany - 1) do begin
              for FWidth := 0 to (HowMany - 1) do
              begin
                Input := FandCFilter[Ido];
                inc(Ido);
                Filter[(FWidth + Where), (FLength + Where)] := Input;
              end;
            end;

            for sY := 0 to (HowMany - 1) do begin
              for sX := 0 to (HowMany - 1) do begin
{         TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor);}
                WherePixel := (3 * (IW + (sX + Where))) +
                  (BytesPerLine * (((IL + sY + Where))));
                lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
                lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
                BlueColor := lpPixelB^;
                GreenColor := lpPixelG^;
                RedColor := lpPixelR^;
                R_Filtered := (R_Filtered +
                  (RedColor * Filter[(sX + Where), (sY + Where)]));
                G_Filtered := (G_Filtered +
                  (GreenColor * Filter[(sX + Where), (sY + Where)]));
                B_Filtered := (B_Filtered +
                  (BlueColor * Filter[(sX + Where), (sY + Where)]));
              end;
            end;
            if V_Absolute then begin
              if R_Filtered < 0 then R_Filtered := (R_Filtered * -1);
              if G_Filtered < 0 then G_Filtered := (G_Filtered * -1);
              if B_Filtered < 0 then B_Filtered := (B_Filtered * -1);
            end;
            if R_AutoTT then begin
              if R_Filtered > dAT_Max then R_Filtered := dAT_Max;
              if R_Filtered < dAT_Min then R_Filtered := dAT_Min;
              if G_Filtered > dAT_Max then G_Filtered := dAT_Max;
              if G_Filtered < dAT_Min then G_Filtered := dAT_Min;
              if B_Filtered > dAT_Max then B_Filtered := dAT_Max;
              if B_Filtered < dAT_Min then B_Filtered := dAT_Min;
            end;
            if R_Filtered > R_Max then R_Max := R_Filtered;
            if G_Filtered > G_Max then G_Max := G_Filtered;
            if B_Filtered > B_Max then B_Max := B_Filtered;
            if R_Max < R_Min then R_Min := R_Max;
            if G_Max < G_Min then G_Min := G_Max;
            if B_Max < B_Min then B_Min := B_Max;
       {to get the range of the maxes kept
       IF R_Filtered < R_Min then R_Min :=R_Filtered;
       IF G_Filtered < G_Min then G_Min :=G_Filtered;
       IF B_Filtered < B_Min then B_Min :=B_Filtered;}
          end; {OF IamFandC ...DO IT 8 times}

          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Maxk < R_Max then R_Maxk := R_Max;
              if R_Mink > R_Min then R_Mink := R_Min;
              if G_Maxk < G_Max then G_Maxk := G_Max;
              if G_Mink > G_Min then G_Mink := G_Min;
              if B_Maxk < B_Max then B_Maxk := B_Max;
              if B_Mink > B_Min then B_Mink := B_Min;
            end;
            if Range = 1 then begin
{   IF R_MinK < 0 Then R_MinK := (R_MinK * -1); }
              R_Max := ((R_Max - (R_Mink)) / R_Range);
{       IF G_MinK < 0 Then G_MinK := (G_MinK * -1);}
              G_Max := ((G_Max - (G_Mink)) / G_Range);
{       IF G_MinK < 0 Then G_MinK := (G_MinK * -1);}
              B_Max := ((B_Max - (B_Mink)) / B_Range);
              R_Filtered := (R_Max);
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              G_Filtered := (G_Max);
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              B_Filtered := (B_Max);
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{      SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));      }
            end;
          end else
            if {Do_Absolute, AutoRange, Do_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
              R_Filtered := (R_Max);
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              G_Filtered := (G_Max);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              B_Filtered := (B_Max);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end else
              if {Do_Absolute, AutoRange, }  Do_Ex_com
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
                R_Filtered := (R_Max);
                G_Filtered := (G_Max);
                B_Filtered := (B_Max);

                if R_Filtered < 1 then
                  R_Filtered := ((R_Filtered * 127) + 1) else
                  if R_Filtered >= 1 then
                    R_Filtered := (128 + (R_Filtered / 2));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
                if G_Filtered < 1 then
                  G_Filtered := ((G_Filtered * 127) + 1) else
                  if G_Filtered >= 1 then
                    G_Filtered := (128 + (G_Filtered / 2));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
                if B_Filtered < 1 then
                  B_Filtered := ((B_Filtered * 127) + 1) else
                  if B_Filtered >= 1 then
                    B_Filtered := (128 + (B_Filtered / 2));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
                if S_Threshold then begin
                  if RedColor > bST_Max then RedColor := bST_Max;
                  if RedColor < bST_Min then RedColor := 0;
                  if GreenColor > bST_Max then GreenColor := bST_Max;
                  if GreenColor < bST_Min then GreenColor := 0;
                  if BlueColor > bST_Max then BlueColor := bST_Max;
                  if BlueColor < bST_Min then BlueColor := 0;
                end;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
              end else
                if {Do_Absolute, AutoRange, Do_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  R_Filtered := (R_Max);
                  G_Filtered := (G_Max);
                  B_Filtered := (B_Max);

                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
                  if S_Threshold then begin
                    if RedColor > bST_Max then RedColor := bST_Max;
                    if RedColor < bST_Min then RedColor := 0;
                    if GreenColor > bST_Max then
                      GreenColor := bST_Max;
                    if GreenColor < bST_Min then GreenColor := 0;
                    if BlueColor > bST_Max then BlueColor := bST_Max;
                    if BlueColor < bST_Min then BlueColor := 0;
                  end;
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
                end; { of AutoRange Insider Edition}
        end; {OF WIDTH}

        if AutoRange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, 0, 0);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {OF LENGTH}
    end; {of AutoRange}
    BlackOut;
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
end;
{---------------------------------------------------------------------}

procedure Do_SlopeFile(InFilterName: string; AutoTimes: Integer;
  WhichSlope: Integer);
(*
Function WhatsMySize(FileName:String):Integer;
VAR
I,FilterSize,Code : Integer;
FileLen :Word;
BEGIN
FileLen := Length(FileName);
  I := FileLen - 1;
  while (I <> 0) and ( (FileName[I] <> '.')) do
    Dec(I); {Dec's while looking, then Inc's once to total a count}
    Inc(I,2);
    IF FileName[I] = '2' THEN
    Begin
    Inc(I);
    Val(FileName[I],FilterSize,Code);
    IF Code <> 0 Then Begin
        Do_Error(1232, 1243);
                      end else
        WhatsMySize := FilterSize;
    End Else Do_Error(1233, 1243);
End;*)
var
  FandCFilter, Filter1, Filter2: array[0..81] of Double;
  Filter: array[-4..4, -4..4] of Double; {Integer;}
  ClassFile: file of Double; {Integer;}
  FilterValue1, FilterValue2, Div1, Div2,
    R_Range, R_Max, R_Min, G_Range, G_Max, G_Min, B_Range, B_Max,
    B_Min,
    SobelR1, SobelR2, SobelG1, SobelG2, SobelB1, SobelB2,
    Input, IsOne, IsOneWhat, IsOneIs, {: Integer;}
    R_Filtered, G_Filtered, B_Filtered: Double;
  TheColor: Longint;
  OutByte, RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, IamFandC, Ido, Range: Integer;
  FLength, FWidth, sX, sY, Where: Dword;
  IL, IW: Dword;
begin {Get current Window DC}
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
  FilterValue1 := 0;
  FilterValue2 := 0;
{  Begin  Do the Filter load and work
  IsOne :=0;}
  Assign(ClassFile, InFilterName);
  Reset(ClassFile);
    {Filter extension ie. FL3, FL5, FL7, FL9: Size of Filter}
  HowMany := WhatsMySize(InFilterName);
  Where := (-Trunc(HowMany / 2));
    {Negative of 3/2=1.5=1; 5/2=2.5=2; 7/2=3.5=3; 9/2=4.5=4}
    {Determines the starting point of Filter convolution
     Allows retreiving pixel data for the matrix around the
     current PIXEL being filtered}
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter1[(Ido)] := Input;
    FilterValue1 := (FilterValue1 + ABS(Input));
  end;
  for Ido := 0 to ((HowMany * HowMany) - 1) do
  begin
    Read(ClassFile, Input);
    Filter2[(Ido)] := Input;
    FilterValue2 := (FilterValue2 + ABS(Input));
  end;
  Close(ClassFile);
  Div1 := (FilterValue1);
  if Div1 = 0 then Div1 := 1;
  Div2 := (FilterValue2);
  if Div2 = 0 then Div2 := 1;
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255; {or 256}
      G_Range := G_Max - G_Min;
      G_Range := G_Range / 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / 255;
      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin

          for IamFandC := 1 to 2 do
          begin
            R_Filtered := 0;
            G_Filtered := 0;
            B_Filtered := 0;
            case IamFandC of
              1: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter1[Ido];
              2: for Ido := 0 to 8 do
                  FandCFilter[Ido] := Filter2[Ido];
            end;
            IDo := 0;
            for FLength := 0 to (HowMany - 1) do begin
              for FWidth := 0 to (HowMany - 1) do
              begin
                Input := FandCFilter[Ido];
                inc(Ido);
                Filter[(FWidth + Where), (FLength + Where)] := Input;
              end;
            end;

            for sY := 0 to (HowMany - 1) do begin
              for sX := 0 to (HowMany - 1) do begin
{         TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor);}
                WherePixel := (3 * (IW + (sX + Where))) +
                  (BytesPerLine * (((IL + sY + Where))));
                lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
                lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
                BlueColor := lpPixelB^;
                GreenColor := lpPixelG^;
                RedColor := lpPixelR^;
                R_Filtered := (R_Filtered +
                  (RedColor * Filter[(sX + Where), (sY + Where)]));
                G_Filtered := (G_Filtered +
                  (GreenColor * Filter[(sX + Where), (sY + Where)]));
                B_Filtered := (B_Filtered +
                  (BlueColor * Filter[(sX + Where), (sY + Where)]));
              end;
            end;
{the filter is + and - values already
Slope(sn) = (7++4+4+8)-(6+2+2+5) / (8*cell size)
Slope(we) = (8+1+1+5)-(7+3+3+6) / (8*cell size)
}
            if IamFandC = 1 then begin
              R_Filtered := SQR(R_Filtered / (Div1));
              G_Filtered := SQR(G_Filtered / (Div1));
              B_Filtered := SQR(B_Filtered / (Div1));
              SobelR1 := R_Filtered;
              SobelG1 := G_Filtered;
              SobelB1 := B_Filtered;
            end;
            if IamFandC = 2 then begin
              R_Filtered := SQR(R_Filtered / (Div2));
              G_Filtered := SQR(G_Filtered / (Div2));
              B_Filtered := SQR(B_Filtered / (Div2));
              SobelR2 := R_Filtered;
              SobelG2 := G_Filtered;
              SobelB2 := B_Filtered;
            end;

          end; {OF IamFandC ...DO IT TWICE}
{Slope in degrees = INVTAN(SQRT(SQR(S1) + SQR(S2))); }
{ARCTAN makes NO edge in AUTO,/w dots of color;
    black screen without AUTO}
          if WhichSlope = 6 then begin
            R_Filtered := ARCTAN(SobelR1 + SobelR2);
            G_Filtered := ARCTAN(SobelG1 + SobelG2);
            B_Filtered := ARCTAN(SobelB1 + SobelB2);
          end;
          if WhichSlope = 8 then begin
            R_Filtered := SQRT(SobelR1 + SobelR2);
            G_Filtered := SQRT(SobelG1 + SobelG2);
            B_Filtered := SQRT(SobelB1 + SobelB2);
          end;
          if R_AutoTT then begin
            if R_Filtered > dAT_Max then R_Filtered := dAT_Max;
            if R_Filtered < dAT_Min then R_Filtered := dAT_Min;
            if G_Filtered > dAT_Max then G_Filtered := dAT_Max;
            if G_Filtered < dAT_Min then G_Filtered := dAT_Min;
            if B_Filtered > dAT_Max then B_Filtered := dAT_Max;
            if B_Filtered < dAT_Min then B_Filtered := dAT_Min;
          end;
          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Max < R_Filtered then R_Max := R_Filtered;
              if R_Min > R_Filtered then R_Min := R_Filtered;
              if G_Max < G_Filtered then G_Max := G_Filtered;
              if G_Min > G_Filtered then G_Min := G_Filtered;
              if B_Max < B_Filtered then B_Max := B_Filtered;
              if B_Min > B_Filtered then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
              R_Filtered := ((R_Filtered - (R_Min)) / R_Range);
              G_Filtered := ((G_Filtered - (G_Min)) / G_Range);
              B_Filtered := ((B_Filtered - (B_Min)) / B_Range);
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{      SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));      }
            end;
          end else
            if {Do_Absolute, AutoRange, Do_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              if S_Threshold then begin
                if RedColor > bST_Max then RedColor := bST_Max;
                if RedColor < bST_Min then RedColor := 0;
                if GreenColor > bST_Max then GreenColor := bST_Max;
                if GreenColor < bST_Min then GreenColor := 0;
                if BlueColor > bST_Max then BlueColor := bST_Max;
                if BlueColor < bST_Min then BlueColor := 0;
              end;
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
            end else

              if {Do_Absolute, AutoRange,}  Do_Ex_com
                {, ClipR, ThresholdR,}
              then begin
                if R_Filtered < 1 then
                  R_Filtered := ((R_Filtered * 127) + 1) else
                  if R_Filtered >= 1 then
                    R_Filtered := (128 + (R_Filtered / 2));
                if G_Filtered < 1 then
                  G_Filtered := ((G_Filtered * 127) + 1) else
                  if G_Filtered >= 1 then
                    G_Filtered := (128 + (G_Filtered / 2));
                if B_Filtered < 1 then
                  B_Filtered := ((B_Filtered * 127) + 1) else
                  if B_Filtered >= 1 then
                    B_Filtered := (128 + (B_Filtered / 2));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
                if S_Threshold then begin
                  if RedColor > bST_Max then RedColor := bST_Max;
                  if RedColor < bST_Min then RedColor := 0;
                  if GreenColor > bST_Max then GreenColor := bST_Max;
                  if GreenColor < bST_Min then GreenColor := 0;
                  if BlueColor > bST_Max then BlueColor := bST_Max;
                  if BlueColor < bST_Min then BlueColor := 0;
                end;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
              end else
                if {Do_Absolute, AutoRange, Do_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
                  if S_Threshold then begin
                    if RedColor > bST_Max then RedColor := bST_Max;
                    if RedColor < bST_Min then RedColor := 0;
                    if GreenColor > bST_Max then
                      GreenColor := bST_Max;
                    if GreenColor < bST_Min then GreenColor := 0;
                    if BlueColor > bST_Max then BlueColor := bST_Max;
                    if BlueColor < bST_Min then BlueColor := 0;
                  end;
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));     }
                end;
        end; {OF WIDTH}

        if Autorange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, 0, 0);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {OF LENGTH}
    end; {of AutoRange}
{BLACK out the workBitmap so the edges do not show}
    BlackOut;
    SetImage;
{IF (DeleteBitmap <>TRUE) THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
end;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}


{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
end.
